var offlineOpen = localStorage.getItem('offline')
var vm = new Vue({
    el:"#content",
    data:function(){
        return{
            isShowHeaderList:false,
            breadList: [],
            current: {},
            pieceList: []
        }
    },
    methods:{
        showHeaderList(){
            this.isShowHeaderList = !this.isShowHeaderList;
        },
        closeHeaderList(){
            this.isShowHeaderList = false;
        },
        selectBread(bread) {
            vm.current = bread
			localStorage.setItem('breedingCrossIndexTitle',JSON.stringify(bread));
            vm.isShowHeaderList = false
            getFieldList()
        },
        goDetail(piece) {
            mui.openWindow({url: '/html/breeding/field-detail.html', id: '/html/breeding/field-detail.html', extras: {
                piece: piece,
                breed_plan_id: vm.current.breedPlanId
            }})
        }
    },
})

// 获取收种执行
function getFieldList() {
    plus.nativeUI.showWaiting()
    if (offlineOpen === 'off') {
        plus.sqlite.selectSql({
            name: 'hz',
            sql: `select * from breed_pieces where breed_plan_id = ${vm.current.breedPlanId}`,
            success: function(e){
                if (e.length > 0) {
                    vm.pieceList = JSON.parse(e[0].list)
                } else {
                    vm.pieceList = []
                }
            }
        })
        plus.nativeUI.closeWaiting();
    } else {
		if (!vm.current) {
			window.model.planErr('没有进行中的育种计划');
		}
        window.model.post('hzapp/breed/load_breed_pieces.do', {
            breed_plan_id: vm.current.breedPlanId
        }, function(data){
            switch (data.code){
                case 1:
                    vm.pieceList = data.data
                    plus.nativeUI.closeWaiting()
                    break;
                default:
                    mui.toast(data.message, {type: 'div', duration:'long'});
                    plus.nativeUI.closeWaiting();
                    break;
            }
           
        }, function(error) {
            mui.toast(error.message, {type: 'div', duration:'long'});
            plus.nativeUI.closeWaiting();
        })
    }
}
// 处理育种计划表
function handleBreeds(data) {
    vm.breadList = data
   let currentTemp =localStorage.getItem('breedingCrossIndexTitle');
   if(currentTemp){
   	vm.current=JSON.parse(currentTemp)
   }else{
   	vm.current =data[0];
   }
    getFieldList()
    plus.nativeUI.closeWaiting()
}
// 获取育种计划列表
function getBreadList() {
    plus.nativeUI.showWaiting()
    if (offlineOpen === 'off') {
        plus.sqlite.selectSql({
            name: 'hz',
            sql: `select * from breed_plans`,
            success: function(e){
                if (e.length > 0) {
                    handleBreeds(JSON.parse(e[0].list))
                }
            }
        })
        plus.nativeUI.closeWaiting()
    } else {
        window.model.post('hzapp/breed/load_breed_plan.do', {
        }, function(data){
            handleBreeds(data.data)
        }, function() {
            plus.nativeUI.closeWaiting()
        })
    }
}

mui.plusReady(function () {
    plus.sqlite.openDatabase({
        name: 'hz',
        path: '_doc/huazhi.db'
    })
    getBreadList()
})
window.addEventListener('homeRefresh', function (event) {
    offlineOpen = localStorage.getItem('offline')
    currentTemp =localStorage.getItem('breedingCrossIndexTitle');
    if(currentTemp){
        vm.current=JSON.parse(currentTemp)
    }else{
        vm.current =data[0];
    }
    getBreadList()
})
mui.back = function() {
    vm.isShowHeaderList = false;
    var offlineOpen = localStorage.getItem('offline')
    if (offlineOpen === 'off') {
        mui.fire(plus.webview.getWebviewById('html/main/home.html'),'refreshOffline')
    }
    plus.webview.currentWebview().hide("auto", 300);
};
