var offlineOpen = localStorage.getItem('offline')

var vm = new Vue({
	el: "#content",
	data: function() {
		return {
			dataOption: '{"type":"date","beginYear":2000,"endYear":2200}', //日期类型
			activeSelect: 0,
			breed_plan_id: '',
			isShow: true,
			selectList: [{
				name: "无调查/实施",
				type: 0,

			}, {
				name: "已调查",
				type: 1,

			}, {
				name: "已实施",
				type: 2,
			}],
			subitem: { //所属项目列表
				text: '',
				picker: {}
			},
			searchCodeValue: '', //搜素田间编码
			fieldList: [],
			fieldItemF: {}, //母本
			fieldItemM: {}, //父本
			num: '',
			formData: [{
				maleSubitemGermplasmId: '', //父本项目材料ID 
				maleBlockRow: '', //父本行 
				maleBlockColumn: '', //父本列 
				maleStrainNo: '', //父本株系号 
				femaleSubitemGermplasmId: '', //母本项目材料ID 
				femaleGermplasmName: '',
				maleGermplasmName: '',
				femaleBlockRow: '', //母本行 
				femaleBlockColumn: '', //母本列 
				femaleStrainNo: '', //母本株系号 
				belongProjectId: '', //所属项目 
				maleHeadingTime: '', //父本抽穗时间（type=1时候传递） 
				femaleHeadingTime: '', //母本抽穗时间（type=1时候传递） 
				matchOperateNo: '', //杂交实施编号（type=2时候传递） 
				femaleOperateTime: '', //去雄时间（type=2时候传递） 
				operateTime: '', //授权时间（type=2时候传递） 
				operateDesc: '', //描述（type=2时候传递）	
			}],
		}
	},
	methods: {
		// 切换杂交进度选项
		changeActiveSelect(index) {
			this.activeSelect = index;
		},
		// 所属项目数据处理
		handleInitData(data) {
			let subitemList = data || [];
			if (subitemList.length > 0) {
				subitemList = subitemList.map(x => {
					return {
						value: x.project_id,
						text: x.project_name
					}
				});
			};
			common.picker.initPicker(vm, 'subitem', subitemList);
		},
		// 所属项目
		initDataSubitem() {
			var self = this;
			if (offlineOpen === 'off') {
				plus.sqlite.selectSql({
					name: 'hz',
					sql: `select distinct project_name, project_id, subitem_id, subitem_name from breed_fields where breed_plan_id = ${vm.breed_plan_id}`,
					success: function(e) {
						vm.handleInitData(e)
					}
				})
			} else {
				window.model.post('hzapp/breed/load_breed_subitem.do', {
					breed_plan_id: vm.breed_plan_id,
					// search_value:vm.fieldCodeFemale.text||vm.fieldCodeMale.text||'',
					search_value: '',
				}, function(res) {
					vm.handleInitData(res.data)
				}, function(error) {})
			}
		},
		// 切换所属项目选中栏
		changeSubitem() {
			common.picker.changePicker(this, 'subitem', (selectedItem) => {
				this.formData[0].belongProjectId = selectedItem[0].value;
			})
		},
		// 搜索田间编码
		searchCode(num) {
			this.isShow = false;
			this.changeCode()
			// mui('#codePopover').popover('show');
			this.num = num; //母本父本田间编码 1：母本，2： 父本
		},
		// 获取田间编码结果
		changeCode() {
			vm.fieldList = [];
			plus.nativeUI.showWaiting();
			if (offlineOpen === 'off') {
				plus.sqlite.selectSql({
					name: 'hz',
					sql: `select * from breed_fields where breed_plan_id = ${vm.breed_plan_id} and field_no like '%${vm.searchCodeValue}%'`,
					success: function(e) {
						vm.fieldList = e
					}
				})
				plus.nativeUI.closeWaiting();
			} else {
				window.model.post('hzapp/breed/load_breed_fields.do', {
					breed_plan_id: vm.breed_plan_id,
					search_value: vm.searchCodeValue,
					pageSize: 100,
				}, function(res) {
					vm.fieldList = res.data;
					plus.nativeUI.closeWaiting();

				}, function(error) {
					plus.nativeUI.closeWaiting();
				})
			}
		},
		// 保存数据
		handleSave() {
			mui.toast('保存成功', {
				type: 'div',
				duration: 'long'
			});
			plus.nativeUI.closeWaiting();
			setTimeout(() => {
				mui.fire(plus.webview.getWebviewById('/html/breeding/cross-index.html'), 'homeRefresh');
				plus.webview.currentWebview().close();
			}, 1000);
		},
		// 选中数据返回结果
		selectField(fieldItem) {
			this.isShow = true;
			// mui('#codePopover').popover('hide');
			vm.searchCodeValue = '';
			vm.fieldList = [];
			if (vm.num == 1) {
				this.fieldItemF = fieldItem;
				vm.formData[0].femaleSubitemGermplasmId = fieldItem.subitem_germplasm_id;
				vm.formData[0].femaleGermplasmName = fieldItem.germplasm_name;
			} else if (vm.num == 2) {
				this.fieldItemM = fieldItem;
				vm.formData[0].maleSubitemGermplasmId = fieldItem.subitem_germplasm_id;
				vm.formData[0].maleGermplasmName = fieldItem.germplasm_name;

			}
		},
		//保存杂交配对
		saveHybridMatch() {
			if (!vm.fieldItemF.field_no) {
				mui.toast('请输入母本田间编号', {
					type: 'div',
					duration: 'long'
				});
				return
			}
			if (!vm.formData[0].femaleSubitemGermplasmId) {
				mui.toast('请输入母本项目材料ID', {
					type: 'div',
					duration: 'long'
				});
				return
			}
			// if (!vm.formData[0].femaleBlockColumn) {
			// 	mui.toast('请输入母本列', {
			// 		type: 'div',
			// 		duration: 'long'
			// 	});
			// 	return
			// }
			// if (!vm.formData[0].femaleBlockRow) {
			// 	mui.toast('请输入母本行', {
			// 		type: 'div',
			// 		duration: 'long'
			// 	});
			// 	return
			// }
			if (!vm.fieldItemM.field_no) {
				mui.toast('请输入父本田间编号', {
					type: 'div',
					duration: 'long'
				});
				return
			}
			if (vm.fieldItemF.field_no == vm.fieldItemM.field_no) {
				mui.toast('请输入不同的父母本田间编号', {
					type: 'div',
					duration: 'long'
				});
				return
			}
			if (!vm.formData[0].femaleSubitemGermplasmId) {
				mui.toast('请输入父本项目材料ID', {
					type: 'div',
					duration: 'long'
				});
				return
			}
			// if (!vm.formData[0].maleBlockColumn) {
			// 	mui.toast('请输入父本列', {
			// 		type: 'div',
			// 		duration: 'long'
			// 	});
			// 	return
			// }
			// if (!vm.formData[0].maleBlockRow) {
			// 	mui.toast('请输入父本行', {
			// 		type: 'div',
			// 		duration: 'long'
			// 	});
			// 	return
			// }
			if (!vm.formData[0].belongProjectId) {
				mui.toast('请选择所属项目', {
					type: 'div',
					duration: 'long'
				});
				return
			}
			if (this.selectList[vm.activeSelect].type === 2) {
				if (!vm.formData[0].matchOperateNo) {
					mui.toast('请填写实施编号', {
						type: 'div',
						duration: 'long'
					});
					return
				}
				if (!vm.formData[0].femaleOperateTime) {
					mui.toast('请选择去雄时间', {
						type: 'div',
						duration: 'long'
					});
					return
				}
				if (!vm.formData[0].operateTime) {
					mui.toast('请选择授粉时间', {
						type: 'div',
						duration: 'long'
					});
					return
				}
			}

			let status = 1
			if (offlineOpen === 'off') {
				status = 0
			}
			plus.sqlite.selectSql({
				name: 'hz',
				sql: `select * from breed_hybrid_matches where match_no like '%NEW%'`,
				success: function(e) {
					let matchNo = 'NEW' + (e.length + 1)
					let sql =
						`insert into breed_hybrid_matches values (${vm.breed_plan_id}, '${vm.fieldItemM.germplasm_name}', '${vm.fieldItemF.field_no}', '${matchNo}', '${vm.fieldItemF.germplasm_name}',`
					sql +=
						`0, ${vm.formData[0].femaleSubitemGermplasmId}, ${vm.formData[0].maleSubitemGermplasmId}, '${vm.fieldItemM.field_no}', '', '', ${status}, 0, ${vm.formData[0].belongProjectId}`
					sql +=
						`, null, ${vm.formData[0].maleBlockRow}, ${vm.formData[0].maleBlockColumn}, '${vm.formData[0].maleStrainNo}', null, ${vm.formData[0].femaleBlockRow}, ${vm.formData[0].femaleBlockColumn}, '${vm.formData[0].femaleStrainNo}')`
					plus.sqlite.selectSql({
						name: 'hz',
						sql: sql,
						success: function(e) {
							if (offlineOpen === 'off') {
								vm.handleSave()
							}
						},
						fail: function(e) {
							console.log(e)
						}
					})
				}
			})
			if (offlineOpen !== 'off') {
				if (!vm.formData[0].femaleBlockColumn) vm.formData[0].femaleBlockColumn = 0;
				if (!vm.formData[0].femaleBlockRow) vm.formData[0].femaleBlockRow = 0;
				if (!vm.formData[0].maleBlockColumn) vm.formData[0].maleBlockColumn = 0;
				if (!vm.formData[0].maleBlockRow) vm.formData[0].maleBlockRow = 0;
				window.model.post('hzapp/breed/save_hybrid_match.do', {
					breed_plan_id: vm.breed_plan_id,
					type: this.selectList[vm.activeSelect].type,
					data: JSON.stringify(vm.formData),
				}, function(res) {
					switch (res.code) {
						case 1:
							vm.handleSave()
							break;
						default:
							mui.toast(res.message, {
								type: 'div',
								duration: 'long'
							});
							plus.nativeUI.closeWaiting();
							break;
					}

				}, function(error) {
					mui.toast(error.message, {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.closeWaiting();
				})
			}
		},
		//选择去雄时间
		selectData(type) {
			var _self = this;
			if (_self.picker) {
				_self.picker.show(function(rs) {
					vm.formData[0][type] = rs.text;
					_self.picker.dispose();
					_self.picker = null;
				});
			} else {
				var optionsJson = vm.dataOption || '{}';
				var options = JSON.parse(optionsJson);
				//var id = this.getAttribute('id');
				/*
				 * 首次显示时实例化组件
				 * 示例为了简洁，将 options 放在了按钮的 dom 上
				 * 也可以直接通过代码声明 optinos 用于实例化 DtPicker
				 */
				_self.picker = new mui.DtPicker(options);
				_self.picker.show(function(rs) {
					/*
					 * rs.value 拼合后的 value
					 * rs.text 拼合后的 text
					 * rs.y 年，可以通过 rs.y.vaue 和 rs.y.text 获取值和文本
					 * rs.m 月，用法同年
					 * rs.d 日，用法同年
					 * rs.h 时，用法同年
					 * rs.i 分（minutes 的第二个字母），用法同年
					 */
					vm.formData[0][type] = rs.text;
					/* 
					 * 返回 false 可以阻止选择框的关闭
					 * return false;
					 */
					/*
					 * 释放组件资源，释放后将将不能再操作组件
					 * 通常情况下，不需要示放组件，new DtPicker(options) 后，可以一直使用。
					 * 当前示例，因为内容较多，如不进行资原释放，在某些设备上会较慢。
					 * 所以每次用完便立即调用 dispose 进行释放，下次用时再创建新实例。
					 */
					_self.picker.dispose();
					_self.picker = null;
				});
			}
		},
	},
	mounted: function() {}
});

mui('#saveBtn')[0].addEventListener('tap', function() {
	// 保存杂交配对
	vm.saveHybridMatch();
})
mui.plusReady(function() {
	plus.sqlite.openDatabase({
		name: 'hz',
		path: '_doc/huazhi.db'
	})
	let self = plus.webview.currentWebview();
	vm.breed_plan_id = self.breed_plan_id;
	vm.initDataSubitem(); //所属项目
	//vm.initDataFieldCode();//田间编码
});
