var offlineOpen = localStorage.getItem('offline')
var vm = new Vue({
	el: "#content",
	data: function() {
		return {
			isEditMode: false,
			isShowAddForm: false,
			imageFiles: [], // 文件[{path:'',name:''}]
			imageFilesPath: [], // 纯图片路径
			breed_plan_id: '', //育种计划ID
			match_no: '', //杂交编号
			female_field_no: '', //母本小区编号
			female_germplasm_name: '', //母本材料
			male_field_no: '', //父本小区编号
			male_germplasm_name: '', //父本材料
			male_subitem_germplasm_id: '', //父本材料ID
			female_subitem_germplasm_id: '', //母本材料ID 
			matchItem: {},

			//弹窗字段
			implementList: [],
			match_operate_no: '',
			female_block_row: '',
			female_block_column: '',
			female_strain_no: '',
			male_block_row: '',
			male_block_column: '',
			male_strain_no: '',
			female_operate_time: '',
			operate_time: '',
			operate_desc: '',

			implementItem: {}, //拍照暂存
			file: '', //暂时 图片上传用

			dataOption: '{"type":"date","beginYear":2000,"endYear":2200}', //日期类型
			pictureList: [],
			baseUrl: ''
		}
	},
	methods: {
		//选择日期
		selectData(dataItem) {
			var _self = this;
			if (_self.picker) {
				_self.picker.show(function(rs) {
					if (dataItem == 'female_operate_time') {
						vm.female_operate_time = rs.text;
					} else {
						vm.operate_time = rs.text;
					}

					_self.picker.dispose();
					_self.picker = null;
				});
			} else {
				var optionsJson = vm.dataOption || '{}';
				var options = JSON.parse(optionsJson);
				//var id = this.getAttribute('id');
				/*
				 * 首次显示时实例化组件
				 * 示例为了简洁，将 options 放在了按钮的 dom 上
				 * 也可以直接通过代码声明 optinos 用于实例化 DtPicker
				 */
				_self.picker = new mui.DtPicker(options);
				_self.picker.show(function(rs) {
					/*
					 * rs.value 拼合后的 value
					 * rs.text 拼合后的 text
					 * rs.y 年，可以通过 rs.y.vaue 和 rs.y.text 获取值和文本
					 * rs.m 月，用法同年
					 * rs.d 日，用法同年
					 * rs.h 时，用法同年
					 * rs.i 分（minutes 的第二个字母），用法同年
					 */
					if (dataItem == 'female_operate_time') {
						vm.female_operate_time = rs.text;
					} else {
						vm.operate_time = rs.text;
					}
					/* 
					 * 返回 false 可以阻止选择框的关闭
					 * return false;
					 */
					/*
					 * 释放组件资源，释放后将将不能再操作组件
					 * 通常情况下，不需要示放组件，new DtPicker(options) 后，可以一直使用。
					 * 当前示例，因为内容较多，如不进行资原释放，在某些设备上会较慢。
					 * 所以每次用完便立即调用 dispose 进行释放，下次用时再创建新实例。
					 */
					_self.picker.dispose();
					_self.picker = null;
				});
			}
		},
		// 显示编辑窗
		enterEdit: function() {
			this.isEditMode = true;
		},
		// 关闭编辑窗
		closeEdit: function() {
			this.isEditMode = false;
		},
		// 显示新增弹窗
		showAddForm: function() {
			this.isShowAddForm = true;
			this.match_operate_no = this.match_no;
			this.female_block_row = '';
			this.female_block_column = '';
			this.female_strain_no = '';
			this.male_block_row = '';
			this.male_block_column = '';
			this.male_strain_no = '';
			this.female_operate_time = '';
			this.operate_time = '';
			this.operate_desc = '';
		},
		// 关闭新增弹窗
		closeAddForm: function(num) {
			this.isShowAddForm = false;
		},
		// 保存杂交实施
		saveAddForm: function(num) {
			if (!this.match_operate_no) {
				mui.toast('请填写实施编码', {
					type: 'div',
					duration: 'long'
				})
				return
			}
			if (this.match_operate_no === this.match_no) {
				mui.toast('请修改实施编码', {
					type: 'div',
					duration: 'long'
				})
				return
			}
			// if (!this.female_block_row) {
			//  mui.toast('请填写母本行', {type: 'div', duration:'long'})
			//  return
			// }
			// if (!this.female_block_column) {
			//  mui.toast('请填写母本列', {type: 'div', duration:'long'})
			//  return
			// }
			// if (!this.female_strain_no) {
			//  mui.toast('请填写母本株系号', {type: 'div', duration:'long'})
			//  return
			// }
			//  if (!this.male_block_row) {
			// 	mui.toast('请填写父本行', {type: 'div', duration:'long'})
			// 	return
			// }
			// if (!this.male_block_column) {
			// 	mui.toast('请填写父本列', {type: 'div', duration:'long'})
			// 	return
			// }
			// if (!this.male_strain_no) {
			// 	mui.toast('请填写父本株系号', {type: 'div', duration:'long'})
			// 	return
			// }
			if (!this.female_operate_time) {
				mui.toast('请填写去雄时间', {
					type: 'div',
					duration: 'long'
				})
				return
			}
			if (!this.operate_time) {
				mui.toast('请填写授粉时间', {
					type: 'div',
					duration: 'long'
				})
				return
			}
			vm.saveHybridMatch(); //新增杂交实施（去雄、授粉）	
		},
		// 处理杂交实施
		handleSaveHybridMatch() {
			this.isShowAddForm = false;
			// vm.implementList = vm.implementList.push({
			// 	male_operate_no:this.male_operate_no,
			// 	female_block_row:this.female_block_row,
			// 	female_block_column:this.female_block_column,
			// 	female_strain_no:this.female_strain_no,
			// 	male_block_row:this.male_block_row,
			// 	male_block_column:this.male_block_column,
			// 	male_strain_no:this.male_strain_no,
			// 	female_operate_time:this.female_operate_time,
			// 	operate_time:this.operate_time,
			// 	operate_desc:this.operate_desc
			// });
			mui.toast('新增成功', {
				type: 'div',
				duration: 'long'
			});
			vm.getHybridImplement(); //获取实施结果
			plus.nativeUI.closeWaiting();
		},
		//新增杂交实施（去雄、授粉）
		saveHybridMatch: function() {
			let data = [{
				matchNo: this.match_no,
				matchOperateNo: this.match_operate_no,
				maleSubitemGermplasmId: this.male_subitem_germplasm_id,
				femaleSubitemGermplasmId: this.female_subitem_germplasm_id,
				maleBlockRow: this.male_block_row || 0,
				maleBlockColumn: this.male_block_column || 0,
				maleStrainNo: this.male_strain_no,
				femaleBlockRow: this.female_block_row || 0,
				femaleBlockColumn: this.female_block_column || 0,
				femaleStrainNo: this.female_strain_no,
				femaleOperateTime: this.female_operate_time,
				operateTime: this.operate_time,
				creator: '',
				femaleCreator: '',
				operateDesc: this.operate_desc,
				operateStatus: '',
			}];
			let status = 1
			if (offlineOpen === 'off') {
				status = 0
			}
			plus.sqlite.selectSql({
				name: 'hz',
				sql: `select * from breed_hybrid_implementes where match_no like '%NEW%'`,
				success: function(e) {
					// let matchNo = 'NEW' + (e.length + 1)
					let sql =
						`insert into breed_hybrid_implementes values (${vm.breed_plan_id}, '${data[0].operateDesc}', '${vm.matchItem.female_field_no}', '${vm.matchItem.male_germplasm_name}', ${data[0].maleBlockColumn}, `
					sql +=
						`'${data[0].femaleOperateTime}', '${data[0].matchOperateNo}', ${vm.matchItem.female_subitem_germplasm_id}, ${data[0].femaleBlockRow}, `
					sql +=
						`0, ${vm.matchItem.male_subitem_germplasm_id}, ${data[0].femaleBlockColumn}, '${vm.matchItem.male_field_no}', '', '${data[0].operateTime}', '${data[0].matchNo}', `
					sql +=
						`${data[0].maleBlockRow}, '${vm.matchItem.female_germplasm_name}', '', '${data[0].maleStrainNo}', '${data[0].femaleStrainNo}', 0, ${status})`
					plus.sqlite.selectSql({
						name: 'hz',
						sql: sql,
						success: function(e) {
							if (offlineOpen === 'off') {
								vm.handleSaveHybridMatch()
							}
						},
						fail: function(e) {
							console.log(e)
						}
					})
				}
			})

			if (offlineOpen !== 'off') {
				window.model.post('hzapp/breed/save_hybrid_implement.do', {
					breed_plan_id: this.breed_plan_id,
					data: JSON.stringify(data),
				}, function(res) {
					switch (res.code) {
						case 1:
							vm.handleSaveHybridMatch()
							break;
						default:
							mui.toast(res.message, {
								type: 'div',
								duration: 'long'
							});
							plus.nativeUI.closeWaiting();
							break;
					}
				}, function(error) {
					mui.toast(error.message, {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.closeWaiting();
				});
			}
		},
		// 处理实施结果
		handleHybridImplement(data) {
			vm.implementList = data;
			if (data.length > 0) {
				vm.female_field_no = data[0].female_field_no;
				vm.female_germplasm_name = data[0].female_germplasm_name;
				vm.male_field_no = data[0].male_field_no;
				vm.male_germplasm_name = data[0].male_germplasm_name;
				vm.male_subitem_germplasm_id = data[0].male_subitem_germplasm_id;
				vm.female_subitem_germplasm_id = data[0].female_subitem_germplasm_id;
				vm.creator = data[0].creator;
				vm.female_creator = data[0].female_creator;
				vm.operate_status = data[0].operate_status;
			} else {
				vm.female_field_no = vm.matchItem.female_field_no;
				vm.female_germplasm_name = vm.matchItem.female_germplasm_name;
				vm.male_field_no = vm.matchItem.male_field_no;
				vm.male_germplasm_name = vm.matchItem.male_germplasm_name;
				vm.male_subitem_germplasm_id = vm.matchItem.male_subitem_germplasm_id;
				vm.female_subitem_germplasm_id = vm.matchItem.female_subitem_germplasm_id;
			}
			plus.nativeUI.closeWaiting();
		},
		//获取实施结果
		getHybridImplement: function() {
			plus.nativeUI.showWaiting();
			if (offlineOpen === 'off') {
				plus.sqlite.selectSql({
					name: 'hz',
					sql: `select * from breed_hybrid_implementes where breed_plan_id = ${vm.breed_plan_id} and match_no = '${vm.match_no}' and delete_flag = 0`,
					success: function(e) {
						vm.handleHybridImplement(e)
					}
				})
				plus.nativeUI.closeWaiting()
			} else {
				window.model.post('hzapp/breed/load_hybrid_implement.do', {
					breed_plan_id: vm.breed_plan_id,
					match_no: vm.match_no,
				}, function(res) {
					switch (res.code) {
						case 1:
							vm.handleHybridImplement(res.data)
							break;
						default:
							mui.toast(res.message, {
								type: 'div',
								duration: 'long'
							});
							plus.nativeUI.closeWaiting();
							break;
					}
				}, function(error) {
					mui.toast(error.message, {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.closeWaiting();
				});
			}
		},
		//删除杂交实施
		onDeleteItem: function(implementItem) {
			mui.confirm('确认是否删除本条数据？', '系统提示', ['取消', '确认'], function(e) {
				if (e.index == 1) {
					let sql =
						`update breed_hybrid_implementes set delete_flag = 1, status = 0 where breed_plan_id = ${vm.breed_plan_id} and match_no = '${vm.match_no}' `
					sql +=
						`and male_block_row = ${implementItem.male_block_row} and male_block_column = ${implementItem.male_block_column} and male_strain_no = ${implementItem.male_strain_no} `
					sql +=
						`and female_block_row = ${implementItem.female_block_row} and female_block_column = ${implementItem.female_block_column} and female_strain_no = ${implementItem.female_strain_no}`
					plus.sqlite.executeSql({
						name: 'hz',
						sql: sql,
						success: function(e) {
							mui.toast('删除成功', {
								type: 'div',
								duration: 'long'
							});
							vm.getHybridImplement(); //获取实施结果
							plus.nativeUI.closeWaiting();
						},
						fail: function(e) {
							plus.nativeUI.closeWaiting();
						}
					})
					if (offlineOpen !== 'off') {
						window.model.post('hzapp/breed/remove_hybrid_implement.do', {
							match_no: vm.match_no,
							match_operate_no: implementItem.match_operate_no,
							breed_plan_id: vm.breed_plan_id,
						}, function(res) {
							switch (res.code) {
								case 1:
									mui.toast('删除成功', {
										type: 'div',
										duration: 'long'
									});
									vm.getHybridImplement(); //获取实施结果
									plus.nativeUI.closeWaiting();
									break;
								default:
									mui.toast(res.message, {
										type: 'div',
										duration: 'long'
									});
									plus.nativeUI.closeWaiting();
									break;
							}

						}, function(error) {
							mui.toast(error.message, {
								type: 'div',
								duration: 'long'
							});
							plus.nativeUI.closeWaiting();
						})
					}
				}

			}, 'div')
		},
		// 		handleUploadImage(implementItem) {
		// 			vm.implementItem=implementItem;//拍照暂存
		// 		    var bts = [{
		// 		        title: "拍照"
		// 		    }, {
		// 		        title: "从相册选择"
		// 		    }]
		// 		    var self = this
		// 		    window.plus.nativeUI.actionSheet({
		// 		            cancel: "取消",
		// 		            buttons: bts
		// 		        },
		// 		        function(e) {
		// 		            if (e.index == 1) {
		// 		                self.getImage()
		// 		            } else if (e.index == 2) {
		// 		                self.galleryImgs()
		// 		            }
		// 		        }
		// 		    )
		// 		},
		//拍照  
		getImage(implementItem) {
			vm.implementItem = implementItem; //拍照暂存
			var self = this;
			var cmr = window.plus.camera.getCamera();
			//const implementItem=self.implementItem;
			//    breed_plan_id int, match_no text, image_path text, file_name text, file_size text, remark text, modifier text, modify_time text, status int
			cmr.captureImage(function(p) {
				window.plus.io.resolveLocalFileSystemURL(p, function(entry) {
					entry.file(function(file) {
						// var dstname = vm.breed_plan_id + '_' + implementItem.match_no + '_'+implementItem.match_operate_no + '_' + (new Date()).getTime()+'.jpg' //设置压缩后图片的路径  
						let sql =
							`insert into breed_hybrid_implementes_images values(${vm.breed_plan_id}, '${implementItem.match_no}', '${implementItem.match_operate_no}', `
						sql += `'${file.fullPath}', '${file.name}', '${file.size}', '', '', '', 0)`
						plus.sqlite.executeSql({
							name: 'hz',
							sql: sql,
							success: function(e) {},
							fail: function(e) {
								console.log(e)
							}
						})
					})
				})
			})
		},

		//压缩图片，这个比较变态的方法，无法return  
		compressImage(src, dstname) {
			var self = this
			//var dstname="_downloads/"+getUid()+".jpg";  
			window.plus.zip.compressImage({
					src: src,
					dst: dstname,
					overwrite: true,
					quality: 20,
					rotate: 0
				},
				function(e) {
					var reader = new plus.io.FileReader(); // 构建文件对象  
					reader.readAsDataURL(e.target) // 添加文件（此处安卓可以直接添加文件路径，而IOS则需要文件对象）  
					reader.onloadend = function(e) { // 文件加载 完成后的事件回调  
						var file = (function(path, name) {
							var arr = path.split(','),
								mime = arr[0].match(/:(.*?);/)[1],
								bstr = atob(arr[1]),
								n = bstr.length,
								u8arr = new Uint8Array(n);
							while (n--) {
								u8arr[n] = bstr.charCodeAt(n);
							}
							return new File([u8arr], name, {
								type: mime
							});
						})(e.target.result, dstname);
						//self.upload(file)
						vm.file = file;
						// self.imageFiles.push(file)
					}
				},
				function(error) {
					console.log(error)
				});
		},
		// 上传文件  
		upload() {
			var self = this
			var wt = window.plus.nativeUI.showWaiting('上传中...')
			var formData = new FormData()
			formData.append('file', vm.file)
			window.model.upload('hzapp/breed/save_hybrid_implement_image.do', null, formData, function(res) {
				if (res.code === 1) {
					mui.toast('上传成功', {
						type: 'div',
						duration: 'long'
					});
					// self.imageFiles.push(res.data[0])
				} else {
					mui.toast('上传失败', {
						type: 'div',
						duration: 'long'
					});
				}
				wt.close(); //关闭等待提示按钮
			})
		},
		//图片预览
		previewImage() {
			// if(vm.imageFilesPath.length>0){
			// 	var imgeGroup = mui.previewImage();  
			// 	/**  
			// 	* 第一个参数是分组中图片的索引，从0开始；  
			// 	* 第二个参数是分组的索引；  
			// 	*/  
			// 	imgeGroup.open(0, 1); 
			// }else{
			// 		mui.toast('暂无图片', {type: 'div', duration:'long'});
			// }



			// if (offlineOpen === 'off') {
			// 	vm.getOfflinePictures()
			// } else {
			// 	vm.getOnPictures()
			// }
			mui.openWindow({
				url: '/html/breeding/pictures1.html',
				id: '/html/breeding/pictures1.html',
				extras: {
					breed_plan_id: vm.breed_plan_id,
					match_no: vm.match_no,
					matchItem: vm.matchItem,
				}
			})
		},
		// 大图展示
		preview() {
			var pswpElement = document.querySelectorAll('.pswp')[0];
			var items = [];
			vm.pictureList.forEach(picture => {
				switch (picture.type) {
					case 'on':
						items.push({
							src: vm.baseUrl + picture.src,
							w: document.body.clientWidth,
							h: 400
						})
						break;
					case 'off':
						items.push({
							src: picture.src,
							w: document.body.clientWidth,
							h: 400
						})
						break;
				}
			});
			var options = {
				index: 0
			};
			var gallery = new PhotoSwipe(pswpElement, PhotoSwipeUI_Default, items, options);
			gallery.init();
		},

		// 获取在线图片
		getOnPictures() {
			window.model.post('hzapp/breed/load_hybrid_implement_image.do', {
				breed_plan_id: vm.breed_plan_id,
				match: vm.match_no
			}, function(data) {
				if (data.code === 1) {
					let imgs = []
					for (let i = 0; i < data.data.length; i++) {
						const item = data.data[i];
						imgs.push({
							type: "on",
							src: item.image_path
						})
					}
					vm.pictureList = vm.pictureList.concat(imgs)
					vm.getOfflinePictures()
				} else {
					vm.getOfflinePictures()
				}
			}, function() {
				vm.getOfflinePictures()
			})
		},
		// 获取离线图片
		getOfflinePictures() {
			let sql =
				`select * from breed_hybrid_implementes_images where breed_plan_id = ${vm.breed_plan_id} and match_no = '${vm.match_no}' `
			if (offlineOpen !== 'off') {
				sql += `and status = 0 `
			}
			plus.sqlite.selectSql({
				name: 'hz',
				sql: sql,
				success: function(e) {
					if (e && e.length > 0) {
						let pictureList = []
						for (const key in e) {
							if (e.hasOwnProperty(key)) {
								pictureList.push({
									type: 'off',
									src: e[key].image_path
								})
							}
						}
						vm.pictureList = vm.pictureList.concat(pictureList)
					}
					if (vm.pictureList.length === 0) {
						mui.toast('暂无图片', {
							type: 'div',
							duration: 'long'
						});
					} else {
						vm.preview()
					}
				},
				fail: function(e) {
					console.log(e)
				}
			})
		}
	},
});
mui.plusReady(function() {
	plus.sqlite.openDatabase({
		name: 'hz',
		path: '_doc/huazhi.db'
	})
	const self = plus.webview.currentWebview();
	vm.breed_plan_id = self.breed_plan_id;
	vm.match_no = self.matchItem.match_no;
	vm.matchItem = self.matchItem
	let baseUrl = window.model.urlHandle('hzapp/breed/show_hybrid_implement_image.do')
	baseUrl += `&breed_plan_id=${vm.breed_plan_id}&image_path=`
	vm.baseUrl = baseUrl
	let imageFilesPath = localStorage.getItem('crossDetailImageFilesPath');
	if (imageFilesPath) {
		vm.imageFilesPath = JSON.parse(imageFilesPath);
	}
	vm.getHybridImplement(); //获取实施结果
	mui.back = function() {
		mui.fire(plus.webview.getWebviewById('/html/breeding/cross-index.html'), 'homeRefresh');
		self.close();
	}
});
