mui.init();
var offlineOpen = localStorage.getItem('offline')
var vm = new Vue({
	el: "#content",
	data: function() {
		return {
			isShowHeaderList: false,
			breed_plan_id: '', //育种计划ID 暂定
			active: 0,
			titleList: '',
			title: '', //当前标题
			selectList: [{
				name: "调查",

			}, {
				name: "实施"
			}, {
				name: "实施结果",
			}],
			search_value1: '',
			search_value2: '',
			search_value3: '',
			iv1: '',
			iv2: '',
			iv3: '',
			surveyList: [], //调查列表
			implementList: [], //实施结果列表
			matchList: [], //实施配对
			surveyItem: '', //暂存，用于选择时间
			tempMatchNo: '',
			tempMatchOperateNo: '',
		}
	},
	methods: {
		// 显示头部
		showHeaderList() {
			this.isShowHeaderList = !this.isShowHeaderList;
		},
		// 关闭头部
		closeHeaderList() {
			this.isShowHeaderList = false;
		},
		// 处理进度图表数据
		handleCircleData(data) {
			$('.indicatorContainer1,.indicatorContainer2').html('');
			$('.indicatorContainer1').radialIndicator({
				initValue: data.survey_progress,
				format: '##.##',
				percentage: true,
				fontColor: "#fff",
				paddingTop: 100,
				barWidth: 6,
				radius: 50,
				barColor: {
					0: '#ff5311',
					100: '#f09819'
				},
			});
			$('.indicatorContainer2').radialIndicator({
				initValue: data.implement_progress,
				format: '##.##',
				percentage: true,
				fontColor: "#fff",
				barWidth: 6,
				radius: 50,
				barColor: {
					0: '#ff5311',
					100: '#f09819'
				},
			});
		},
		// 获取进度图表数据
		getCircleDate() {
			if (offlineOpen === 'off') {
				vm.handleCircleData({
					survey_progress: 0,
					implement_progress: 0
				})
			} else {
				window.model.post('hzapp/breed/load_hybrid_progress.do', {
					breed_plan_id: vm.breed_plan_id,
				}, function(res) {
					vm.handleCircleData(res.data)
				}, function(error) {});
			}
		},
		// 切换弹窗显示
		openPopover: function(surveyItem, type) {
			/**
			 * @param {type} 1 母本 2 父本  
			 * */
			mui('#sheet1').popover('toggle');
			this.surveyItem = surveyItem;
			this.surveyItem['type'] = type
		},
		// 切换弹窗显示
		openPopover2: function(match_no, match_operate_no) {
			mui('#sheet2').popover('toggle');
			this.tempMatchNo = match_no;
			this.tempMatchOperateNo = match_operate_no;
		},
		// 修改激活状态
		changeActive: function(index) {
			this.active = index;
		},
		//获取杂交调查（左边列表）
		getHybridSurvey: function() {
			plus.nativeUI.showWaiting();
			if (offlineOpen === 'off') {
				let sql = ''
				if (vm.search_value1) {
					sql += `select * from (`
				}
				sql +=
					`select female_subitem_germplasm_id as subitem_germplasm_id, female_heading_time as heading_time, female_field_no as field_no, female_germplasm_name as germplasm_name, 'M' as flag from breed_hybrid_matches where breed_plan_id = ${vm.breed_plan_id} and delete_flag = 0`
				sql +=
					` union all select male_subitem_germplasm_id as subitem_germplasm_id, male_heading_time as heading_time, male_field_no as field_no, male_germplasm_name as germplasm_name, 'F' as flag from breed_hybrid_matches where breed_plan_id = ${vm.breed_plan_id} and delete_flag = 0`
				if (vm.search_value1) {
					sql += `) where field_no like '%${vm.search_value1}%'`
				}
				plus.sqlite.selectSql({
					name: 'hz',
					sql: sql,
					success: function(e) {
						let result = {}
						let pos = 1
						for (let i = 0; i < e.length; i++) {
							const item = e[i];
							if (!result[item.subitem_germplasm_id]) {
								result[item.subitem_germplasm_id] = pos
								pos++
							}
						}
						let ret = []
						for (const key in result) {
							if (result.hasOwnProperty(key)) {
								ret.push({})
							}
						}
						e.forEach(item => {
							let position = result[item.subitem_germplasm_id] - 1
							if (ret[position].flag) {
								if (ret[position].flag !== item.flag) {
									ret[position].flag = 'F,M'
								}
							} else {
								ret[position] = item
							}
						})
						vm.surveyList = ret
					}
				})
				plus.nativeUI.closeWaiting();
			} else {
				// window.model.post('hzapp/breed/load_hybrid_survey.do', {
				window.model.post('hzapp/breed/load_hybrid_survey2.do', {
					breed_plan_id: vm.breed_plan_id,
					search_value: vm.search_value1
				}, function(res) {
					switch (res.code) {
						case 1:
							vm.surveyList = res.data;
							plus.nativeUI.closeWaiting();
							break;
						default:
							mui.toast(res.message, {
								type: 'div',
								duration: 'long'
							});
							plus.nativeUI.closeWaiting();
							break;
					}
				}, function(error) {
					mui.toast(error.message, {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.closeWaiting();
				});
			}
		},
		//获取杂交配对(中间列表)
		getHybridMatch: function() {
			plus.nativeUI.showWaiting();
			if (offlineOpen === 'off') {
				let sql = ''
				sql += `select * from breed_hybrid_matches where breed_plan_id = ${vm.breed_plan_id} and delete_flag = 0`
				if (vm.search_value2) {
					sql += ` and match_no like '%${vm.search_value2}%'`
				}
				plus.sqlite.selectSql({
					name: 'hz',
					sql: sql,
					success: function(e) {
						vm.matchList = e
					}
				})
				plus.nativeUI.closeWaiting();
			} else {
				window.model.post('hzapp/breed/load_hybrid_match.do', {
					breed_plan_id: vm.breed_plan_id,
					search_value: vm.search_value2
				}, function(res) {
					switch (res.code) {
						case 1:
							vm.matchList = res.data;
							vm.matchList = vm.matchList.map(item => {
								item.operate_time = vm.dateFormat(item.operate_time)
								item.female_operate_time = vm.dateFormat(item.female_operate_time)
								return item
							})
							plus.nativeUI.closeWaiting();
							break;
						default:
							mui.toast(res.message, {
								type: 'div',
								duration: 'long'
							});
							plus.nativeUI.closeWaiting();
							break;
					}

				}, function(error) {
					mui.toast(error.message, {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.closeWaiting();
				});
			}
		},
		//获取实施结果(右边列表)
		getHybridImplement: function() {
			// plus.nativeUI.showWaiting();
			if (offlineOpen === 'off') {
				let sql = `select * from breed_hybrid_implementes where breed_plan_id = ${vm.breed_plan_id} and delete_flag = 0`
				if (vm.search_value3) {
					sql += ` and match_no like '%${vm.search_value3}%'`
				}
				plus.sqlite.selectSql({
					name: 'hz',
					sql: sql,
					success: function(e) {
						vm.implementList = e
					}
				})
			} else {
				window.model.post('hzapp/breed/load_hybrid_implement.do', {
					breed_plan_id: vm.breed_plan_id,
					search_value: vm.search_value3,
					match_no: '',
				}, function(res) {
					switch (res.code) {
						case 1:
							vm.implementList = res.data;
							vm.implementList = vm.implementList.map(item => {
								item.operate_time = vm.dateFormat(item.operate_time)
								item.female_operate_time = vm.dateFormat(item.female_operate_time)
								return item
							})
							plus.nativeUI.closeWaiting();
							break;
						default:
							mui.toast(res.message, {
								type: 'div',
								duration: 'long'
							});
							plus.nativeUI.closeWaiting();
							break;
					}
				}, function(error) {
					mui.toast(error.message, {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.closeWaiting();
				});
			}
		},
		//跳转到新增杂交实施（去雄、授粉）接口
		onJumpDetail: function(matchItem) {
			mui.openWindow({
				url: 'cross-detail.html',
				id: 'cross-detail.html',
				extras: {
					matchItem: matchItem,
					breed_plan_id: vm.breed_plan_id,
				}
			})
		},
		//左侧列表选择时间
		onSelectDate: function(day) {
			let dayTime = day * 24 * 60 * 60 * 1000;
			let nowTime = new Date().getTime();
			let selectDate = new Date(nowTime + dayTime);
			let year = selectDate.getFullYear();
			let month = (selectDate.getMonth() + 1) < 10 ? ('0' + (selectDate.getMonth() + 1)) : selectDate.getMonth() + 1;
			let date = selectDate.getDate() < 10 ? ('0' + selectDate.getDate()) : selectDate.getDate();
			this.surveyItem.heading_time = year + '-' + month + '-' + date;
			mui('#sheet1').popover('toggle');
			vm.updateHeadingTme(); //更新修改抽穗时间接口（左侧一列）
		},
		//更新修改抽穗时间接口（左侧一列）
		updateHeadingTme: function() {

			// plus.nativeUI.showWaiting();
			let sql = `update breed_hybrid_matches set `
			if (vm.surveyItem.flag === 'F') {
				sql +=
					`male_heading_time = '${vm.surveyItem.heading_time}', status = 0 where male_subitem_germplasm_id = ${vm.surveyItem.subitem_germplasm_id} and breed_plan_id = ${vm.breed_plan_id} and male_field_no = '${vm.surveyItem.field_no}'`
				plus.sqlite.executeSql({
					name: 'hz',
					sql: sql,
					success: function(e) {
						vm.getHybridSurvey();
					}
				})
			} else if (vm.surveyItem.flag === 'M') {
				sql +=
					`female_heading_time = '${vm.surveyItem.heading_time}', status = 0 where female_subitem_germplasm_id = ${vm.surveyItem.subitem_germplasm_id} and breed_plan_id = ${vm.breed_plan_id} and female_field_no = '${vm.surveyItem.field_no}'`
				plus.sqlite.executeSql({
					name: 'hz',
					sql: sql,
					success: function(e) {
						vm.getHybridSurvey();
					}
				})
			} else if (vm.surveyItem.flag === 'F,M') {
				let sql1 = sql +
					`male_heading_time = '${vm.surveyItem.heading_time}', status = 0 where male_subitem_germplasm_id = ${vm.surveyItem.subitem_germplasm_id} and breed_plan_id = ${vm.breed_plan_id} and male_field_no = '${vm.surveyItem.field_no}'`
				let sql2 = sql +
					`female_heading_time = '${vm.surveyItem.heading_time}', status = 0 where female_subitem_germplasm_id = ${vm.surveyItem.subitem_germplasm_id} and breed_plan_id = ${vm.breed_plan_id} and female_field_no = '${vm.surveyItem.field_no}'`
				plus.sqlite.executeSql({
					name: 'hz',
					sql: sql1,
					success: function(e) {}
				})
				plus.sqlite.executeSql({
					name: 'hz',
					sql: sql2,
					success: function(e) {
						vm.getHybridSurvey();
					}
				})
			}
			if (offlineOpen !== 'off') {

				var params = [{
					maleSubitemGermplasmId: vm.surveyItem.male_subitem_germplasm_id,
					feMaleSubitemGermplasmId: vm.surveyItem.female_subitem_germplasm_id,
					maleHeadingTime: vm.surveyItem.male_heading_time,
					femaleHeadingTime: vm.surveyItem.female_heading_time,
					matchNo: vm.surveyItem.match_no,
				}]
				if (this.surveyItem.type == 1) {
					params[0].femaleHeadingTime = vm.surveyItem.heading_time;
				} else if (this.surveyItem.type == 2) {
					params[0].maleHeadingTime = vm.surveyItem.heading_time;
				}
				window.model.post('hzapp/breed/update_hybrid_match_headingTme2.do', {
					// window.model.post('hzapp/breed/update_hybrid_match_headingTme.do', {
					// subitem_germplasm_id: vm.surveyItem.subitem_germplasm_id,
					// breed_plan_id: vm.breed_plan_id,
					// heading_time: vm.surveyItem.heading_time,
					breed_plan_id: vm.breed_plan_id,
					data: JSON.stringify(params),
				}, function(res) {
					switch (res.code) {
						case 1:
							mui.toast('成功', {
								type: 'div',
								duration: 'long'
							});
							vm.getHybridSurvey(); //获取杂交调查(左侧列表)
							plus.nativeUI.closeWaiting();
							break;
						default:
							mui.toast('失败', {
								type: 'div',
								duration: 'long'
							});
							vm.getHybridSurvey(); //获取杂交调查(左侧列表)
							plus.nativeUI.closeWaiting();
							break;
					}
				}, function(error) {
					mui.toast(error.message, {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.closeWaiting();
				})
			}
		},
		//删除杂交配对（中间一列）
		onDeleteItem: function(match_no) {
			mui.confirm('确认是否删除本条数据？', '系统提示', ['取消', '确认'], function(e) {
				if (e.index == 1) {
					plus.nativeUI.showWaiting();
					if (offlineOpen === 'off') {
						plus.sqlite.executeSql({
							name: 'hz',
							sql: `update breed_hybrid_matches set delete_flag = 1, status = 0 where match_no = '${match_no}' and breed_plan_id = ${vm.breed_plan_id}`,
							success: function(e) {
								vm.getHybridMatch();
							}
						})
						plus.nativeUI.closeWaiting()
					} else {
						window.model.post('hzapp/breed/remove_hybrid_match.do', {
							match_no: match_no,
							breed_plan_id: vm.breed_plan_id,
						}, function(res) {
							switch (res.code) {
								case 1:
									mui.toast('成功', {
										type: 'div',
										duration: 'long'
									});
									vm.getHybridMatch(); //获取杂交配对(中间列表)
									plus.nativeUI.closeWaiting();
									break;
								default:
									mui.toast('失败', {
										type: 'div',
										duration: 'long'
									});
									vm.getHybridSurvey(); //获取杂交调查(左侧列表)
									plus.nativeUI.closeWaiting();
									break;
							}
						}, function(error) {
							mui.toast(error.message, {
								type: 'div',
								duration: 'long'
							});
							plus.nativeUI.closeWaiting();
						})
					}
				}

			}, 'div')

		},
		//第三列更新杂交状态
		onUpdataStatus: function(statusNum) {
			// plus.nativeUI.showWaiting();
			let sql = `update breed_hybrid_implementes set operate_status = ${statusNum}, status = 0 `
			sql +=
				`where match_no = '${vm.tempMatchNo}' and breed_plan_id = ${vm.breed_plan_id} and match_operate_no = '${vm.tempMatchOperateNo}'`
			plus.sqlite.executeSql({
				name: 'hz',
				sql: sql,
				success: function(e) {
					if (offlineOpen === 'off') {
						vm.openPopover2();
						mui.toast('状态更新成功', {
							type: 'div',
							duration: 'long'
						});
						vm.getHybridImplement();
					}
				}
			})

			if (offlineOpen !== 'off') {
				window.model.post('hzapp/breed/update_hybrid_implement_status.do', {
					match_no: vm.tempMatchNo,
					//match_no:'MC20180041',
					breed_plan_id: vm.breed_plan_id,
					hybrid_status: statusNum,
					match_operate_no: vm.tempMatchOperateNo,
				}, function(res) {
					switch (res.code) {
						case 1:
							plus.nativeUI.closeWaiting();
							vm.openPopover2();
							mui.toast('状态更新成功', {
								type: 'div',
								duration: 'long'
							});
							vm.getHybridImplement(); //获取实施结果(右边列表)
							break;
						default:
							plus.nativeUI.closeWaiting();
							mui.toast('失败', {
								type: 'div',
								duration: 'long'
							});
							break;
					}
				}, function(error) {
					plus.nativeUI.closeWaiting();
				})
			}
		},
		//跳转新增杂交配对
		onJumpAdd: function() {
			mui.openWindow({
				url: 'cross-add.html',
				id: 'cross-add.html',
				extras: {
					breed_plan_id: vm.breed_plan_id,
				}
			})
		},
		// 处理标题数据
		hanldeTitle(data, num) {
			vm.titleList = data;
			if (num >= 0) {
				vm.breed_plan_id = data[num].breedPlanId;
				vm.title = vm.titleList[num];
				localStorage.setItem('breedingCrossIndexTitle', JSON.stringify(vm.titleList[num]));
				vm.closeHeaderList();
			} else {

				vm.breed_plan_id = vm.title.breedPlanId;
			}
			vm.getHybridSurvey(); //获取杂交调查
			vm.getHybridMatch(); //获取杂交配对(中间列表)
			vm.getHybridImplement(); //获取实施结果(右边列表)
			vm.getCircleDate(); //进度条
		},
		//获取标题
		getTitle: function(num) {
			num = vm.title ? num : 0;
			if (offlineOpen === 'off') {
				plus.sqlite.selectSql({
					name: 'hz',
					sql: `select * from breed_plans`,
					success: function(e) {
						if (e.length > 0) {
							vm.hanldeTitle(JSON.parse(e[0].list), num)
						}
					}
				})
			} else {
				plus.nativeUI.showWaiting();
				window.model.post('hzapp/breed/load_breed_plan.do', {}, function(res) {
					if (res.data.length > 0) {
						switch (res.code) {
							case 1:
								plus.nativeUI.closeWaiting();
								vm.hanldeTitle(res.data, num)
								break;
							default:
								plus.nativeUI.closeWaiting();
								break;
						}
					} else {
						window.model.planErr('没有进行中的育种计划');
					}
				}, function(error) {
					plus.nativeUI.closeWaiting();
				})
			}
		},
		//选择标题
		selectTitle(num) {
			vm.getTitle(num);
		},
		//第一列点击编码展示名字
		showName(surveyItem) {
			mui.alert('母本名称:' + surveyItem.female_germplasm_name + '\n父本名称:' + surveyItem.male_germplasm_name, '材料信息',
				function() {});
		},
		// 格式化日期
		dateFormat(date) {
			if (date === undefined) {
				return ''
			}
			return moment(date).format('YYYY-MM-DD')
		}
	},
	mounted() {},
	watch: {
		search_value1(val, old) {
			clearInterval(vm.iv1)
			vm.iv1 = setInterval(() => {
				clearInterval(vm.iv1)
				this.getHybridSurvey()
			}, 800);
		},
		search_value2(val, old) {
			clearInterval(vm.iv2)
			vm.iv2 = setInterval(() => {
				clearInterval(vm.iv2)
				this.getHybridMatch()
			}, 800);
		},
		search_value3(val, old) {
			clearInterval(vm.iv3)
			vm.iv3 = setInterval(() => {
				clearInterval(vm.iv3)
				this.getHybridImplement()
			}, 800);
		}
	}
});

mui.plusReady(function() {
	plus.sqlite.openDatabase({
		name: 'hz',
		path: '_doc/huazhi.db',
		success: function(e) {},
		fail: function(e) {}
	})

	init()
	// let title= localStorage.getItem('breedingCrossIndexTitle');
	// if(title){
	// 	vm.title=JSON.parse(title);
	// }
	// 	vm.getTitle();//获取标题
	// 		vm.getHybridSurvey();//获取杂交调查
	// 		vm.getHybridMatch();//获取杂交配对(中间列表)
	// 		vm.getHybridImplement();//获取实施结果(右边列表)
	// 		vm.getCircleDate();//进度条

});
window.addEventListener('homeRefresh', function(event) {
	init()
})

function init() {
	offlineOpen = localStorage.getItem('offline')
	let title = localStorage.getItem('breedingCrossIndexTitle');
	if (title) {
		vm.title = JSON.parse(title);
	}
	vm.getTitle(); //获取标题
}
mui.back = function() {
	vm.isShowHeaderList = false;
	var offlineOpen = localStorage.getItem('offline')
	if (offlineOpen === 'off') {
		mui.fire(plus.webview.getWebviewById('html/main/home.html'), 'refreshOffline')
	}
	mui.fire(plus.webview.getWebviewById('html/main/home.html'), 'refreshOffline')
	plus.webview.currentWebview().hide("auto", 300);
};
