mui.init();
var aniShow = {};
var voiceText = ''
var vm = new Vue({
	el: "#content",
	data: function() {
		return {
			planList: [],
			isChooseOpen: false,
			currentPlan: null,
			tabs: [{
					url: 'planting-index.html',
					actImg: 'col-act.png',
					defaultImg: 'col-no.png',
					label: '性状采集'
				},
				{
					url: 'task-index.html',
					actImg: 'tas-act.png',
					defaultImg: 'tas-no.png',
					label: '任务采集'
				},
				{
					url: 'picture-collection.html',
					actImg: 'col-act.png',
					defaultImg: 'col-no.png',
					label: '图片采集'
				}
			],
			activeTab: 'planting-index.html',
			tabIndex: 0,
			isShowHeaderList: false,
		}
	},
	methods: {
		// 显示头部列表
		showHeaderList() {
			mui.fire(plus.webview.getWebviewById('plan-choose.html'), 'setLight')
			if (!this.isChooseOpen) {
				var self = this
				mui.openWindow({
					url: 'plan-choose.html',
					id: 'plan-choose.html',
					styles: {
						top: '49px',
						background: 'transparent',
					},
					extras: {
						planList: self.planList
					},
					createNew: false, //是否重复创建同样id的webview，默认为false:不重复创建，直接显示
					show: {
						autoShow: true, //页面loaded事件发生后自动显示，默认为true
						aniShow: 'slide-in-top'
					}
				})
				this.isChooseOpen = true;

			} else {
				let choose = plus.webview.getWebviewById('plan-choose.html')
				if (choose.isVisible()) {
					choose.hide()
				} else {
					choose.show()
				}
			}
		},
		// 获取计划详情
		getPlanDetail() {
			var self = this
			// plus.nativeUI.showWaiting();
			window.model.post('hzapp/breed/load_breed_plan.do', {}, function(res) {
				self.planList = res.data
				let currentTemp = localStorage.getItem('breedingCrossIndexTitle');
				if (currentTemp && currentTemp !== "null") {
					vm.currentPlan = JSON.parse(currentTemp)
				} else {
					vm.currentPlan = res.data[0];
					localStorage.setItem('breedingCrossIndexTitle', JSON.stringify(res.data[0]))
				}
				//self.currentPlan = res.data[0]
				var ViewFrame = window.plus.webview.getWebviewById('planting-index.html')
				mui.fire(ViewFrame, 'getPlan', {
					breedPlan: self.currentPlan
				})
				setTimeout(function() {
					ViewFrame.show()
				}, 150)
				window.plus.nativeUI.closeWaiting()
			}, function() {
				mui.toast('获取获取育种计划列表失败', {
					type: 'div',
					duration: 'long'
				})
				window.plus.nativeUI.closeWaiting()
			})
		},
		// 底部tab切换
		tabChange(item, index) {
			this.tabIndex = index
			//显示目标选项卡
			//若为iOS平台或非首次显示，则直接显示
			var targetTab = item.url
			if (mui.os.ios || aniShow[targetTab]) {
				// plus.webview.show(targetTab);
				var showWebview = window.plus.webview.getWebviewById(targetTab)
				mui.fire(showWebview, 'getPlan', {
					breedPlan: this.currentPlan,
				})
				setTimeout(function() {
					showWebview.show(targetTab)
				}, 150)
			} else {
				//否则，使用fade-in动画，且保存变量
				var temp = {};
				temp[targetTab] = "true";
				mui.extend(aniShow, temp);
				var showWebview = window.plus.webview.getWebviewById(targetTab)
				mui.fire(showWebview, 'getPlan', {
					breedPlan: this.currentPlan,
				})
				setTimeout(function() {
					showWebview.show(targetTab, "fade-in", 300)
				}, 150)
			}
			//隐藏当前;
			window.plus.webview.hide(this.activeTab)
			this.activeTab = item.url
		}
	},
})

//创建子页面，首个选项卡页面显示，其它均隐藏；
var subpages = ['planting-index.html', 'task-index.html', 'picture-collection.html']
var subpage_style = {
	top: '49px',
	bottom: '51px'
};

mui.plusReady(function() {
	if (plus.device.model == "iPHoneXR" || plus.device.model == "iPhoneX" || plus.device.model == "iPhoneXSMax" || plus.device
		.model == "iPhoneXS") {
		subpage_style.bottom = '91px'
	}
	var self = plus.webview.currentWebview();
	for (var i = 0; i < 3; i++) {
		if (!plus.webview.getWebviewById(subpages[i])) {
			var sub = plus.webview.create(subpages[i], subpages[i], subpage_style);
			sub.hide();
			self.append(sub);
		}
	}
	// plus.nativeUI.showWaiting('正在加载中...')
	vm.getPlanDetail()

	plus.key.addEventListener("keydown", function(e) {
		if (e.keyCode === 4) {
			mui.back();
		}

		if (e.keyCode === 24) {
			var options = {
				continue: false, // 是否采用持续模式
				engine: 'baidu', // 语音识别引擎标识
				lang: 'zh-cn', // 语音识别引擎的语言
				nbest: 1, // 指定识别结果识别包括多候选结果
				punctuation: false, // 识别结果中是否包含标点符号
				timeout: 1000, // 语音识别超时时间
				userInterface: true //识别时是否显示用户界面
			}
			voiceText = ''
			window.plus.speech.startRecognize(options)
		}
	})
	// 监听语音识别事件
	plus.speech.addEventListener("start", function() {
		voiceText = ''
	}, false);
	plus.speech.addEventListener("recognition", function(e) {
		voiceText += e.result
	}, false);
	plus.speech.addEventListener("end", function() {
		if (voiceText === '上一个') {
			mui.fire(plus.webview.getWebviewById(vm.activeTab), 'prev')
		}
		if (voiceText === '下一个') {
			mui.fire(plus.webview.getWebviewById(vm.activeTab), 'next')
		}
	})
});
window.addEventListener('refreshPage', function(event) {
	var detail = event.detail
	vm.currentPlan = detail
	mui.fire(plus.webview.getWebviewById(vm.activeTab), 'getPlan', {
		breedPlan: detail
	})
})
window.addEventListener('homeRefresh', function(event) {
	vm.getPlanDetail();
	mui.fire(plus.webview.getWebviewById(vm.activeTab), 'getPlan', {
		breedPlan: JSON.parse(localStorage.getItem('breedingCrossIndexTitle'))
	})
})

function paneHandle(i) {
	vm.tabChange(vm.tabs[i], i)
}
window.addEventListener('pane', function(event) {
	if (event.detail.from === 'taskBreed') {
		vm.tabIndex = 1
	} else if (event.detail.from === 'taskLeft') {
		vm.tabIndex = 0
	} else if (event.detail.from === 'taskRight') {
		vm.tabIndex = 2
	} else if (event.detail.from === 'pictureRight') {
		vm.tabIndex = 1
	}
})
mui.back = function() {
	// 返回事件
	let choose = plus.webview.getWebviewById('plan-choose.html')
	if (choose) {
		choose.hide();
	}
	mui.fire(plus.webview.getWebviewById('html/main/home.html'), 'refreshOffline')
	plus.webview.currentWebview().hide("auto", 300);
};
