mui.init()
var breedPlan = {}
var offlineOpen = localStorage.getItem('offline')
mui.plusReady(function() {
	// 打开数据库
	plus.sqlite.openDatabase({
		name: 'hz',
		path: '_doc/huazhi.db'
	})
	var vm = new Vue({
		el: "#content",
		data: function() {
			return {
				isShowHeaderList: false,
				field: {},
				fieldData: [],
				traitList: [],
				visibleFilter: false, //选择性状
				field_no: 0,
				imageFilesPath: [],
				breedPlan: null,
				dataOption: '{"type":"date","beginYear":2000,"endYear":2200}', //日期类型 
				selectItem: { //下拉框
					text: '',
					picker: {}
				},
				isSelectSingle: false, //选择单株
				isAllHandle: false, //批量
				traitTemp: {}, //temp
				isSelected: false, //批量选择性状
				fieldNoTemp: '', //批量小区前几位
				progress: {
					trait_progress: 0,
				},
				addTrait: [], //增加选择的性状
				batch: { //批量弹窗数据
					from_field: '',
					to_field: '',
				},
				batchPopArr: [], //批量弹窗中的性状
				blockRow: 0,
				blockColumn: 0,
				pop: null,
				tempBox: [], //选择上一个或下一个携带的性状
			}
		},
		methods: {
			// 值范围验证
			judgeMinMax(trait) {
				let val = parseInt(trait.trait_value)
				if (val > trait.max_value || val < trait.min_value) {
					mui.toast(`值范围为${trait.min_value}-${trait.max_value}`, {
						type: 'div',
						duration: 'long'
					})
					trait.trait_value = ''
				} else {
					saveCurrentTrait()
				}
			},
			// 选中列
			selColumn() {
				if (!vm.pop) {
					vm.pop = new mui.PopPicker()
				}
				var rows = []
				for (let i = 1; i <= vm.blockColumn; i++) {
					rows.push({
						text: i,
						value: i
					})
				}
				vm.pop.setData(rows)
				vm.pop.show(function(items) {
					vm.traitTemp.block_column = items[0].value
				})
			},
			// 选中行
			selRow() {
				if (!vm.pop) {
					vm.pop = new mui.PopPicker()
				}
				var rows = []
				for (let i = 1; i <= vm.blockRow; i++) {
					rows.push({
						text: i,
						value: i
					})
				}
				vm.pop.setData(rows)
				vm.pop.show(function(items) {
					vm.traitTemp.block_row = items[0].value
				})
			},
			//上半截数据
			getPlanProgress() {
				// plus.nativeUI.showWaiting()
				window.model.post('hzapp/breed/load_breed_plan_progress.do', {
					breed_plan_id: vm.breedPlan.breedPlanId
				}, function(data) {
					vm.progress = data.data;
					document.getElementById("progress-inner").style.width = data.data.trait_progress + "%";
					plus.nativeUI.closeWaiting()
				}, function() {
					plus.nativeUI.closeWaiting()
				})

			},
			// 跳转扫描界面
			scan: function() {
				mui.openWindow({
					url: '/html/variety/scan.html',
					id: '/html/variety/scan.html',
				});
				// plus.webview.getWebviewById("/html/variety/scan.html").reload(true);
			},
			// 展示头部
			showHeaderList() {
				this.isShowHeaderList = true;
			},
			// 关闭头部
			closeHeaderList() {
				this.isShowHeaderList = false;
			},
			// 上一个的点击事件
			prevTrait: function() {
				saveCurrentTrait()
				getPrevTrait()
			},
			// 下一个的点击事件
			nextTrait: function() {
				saveCurrentTrait()
				getNextTrait()
			},
			// 调用摄像头并拍照
			getImage: function(trait) {
				var cmr = plus.camera.getCamera();
				cmr.captureImage(function(p) {
					plus.io.resolveLocalFileSystemURL(p, function(entry) {
						entry.file(function(file) {
							let sql =
								`insert into breed_trait_image values(${vm.breedPlan.breedPlanId}, ${trait.subitem_germplasm_id}, ${trait.trait_id}, `
							sql +=
								`${trait.block_row || 0}, ${trait.block_column || 0}, '', ${trait.trait_seq}, '${trait.trait_time}', '${file.fullPath}', '${file.name}', '${file.size}', '', '', '', 0)`
							plus.sqlite.executeSql({
								name: 'hz',
								sql: sql,
								success: function(e) {
									mui.toast('保存图片成功！', {
										type: 'div',
										duration: 'long'
									})
									trait.imageCount += 1
								},
								fail: function(e) {
									console.log(e)
								}
							})
							// vm.uploadImage(trait, file)
						})
					}, function(e) {
						plus.nativeUI.toast("读取拍照文件错误：" + e.message);
					});
				}, function(e) {}, {
					filter: 'image'
				});
			},
			//从相册选择照片
			//         galleryImgs: function (trait) {
			//             plus.gallery.pick(function (e) {
			//                 var reader = new plus.io.FileReader(); // 构建文件对象  
			//                 reader.readAsDataURL(e) // 添加文件（此处安卓可以直接添加文件路径，而IOS则需要文件对象）  
			//                 reader.onloadend = function (event) { // 文件加载 完成后的事件回调  
			//                     vm.uploadImage(trait, event.target.result)
			//                 };
			//             }, function (e) {}, {
			//                 filter: "image"
			//             });
			//         },
			// 保存图片
			uploadImage: function(trait, file) {
				var filename = vm.breedPlan.breedPlanId + '_'
				filename += trait.subitem_germplasm_id + '_'
				filename += trait.block_row + '_' // data_seq
				filename += trait.block_column + '_'
				filename += trait.trait_id + '_'
				filename += trait.trait_seq + '_'
				filename += new Date().getTime()
				var formData = new FormData()
				formData.append('file', file);
				formData.append('filename', filename)
				//  formData.append('random_id', trait.random_id)
				// plus.nativeUI.showWaiting();
				window.model.upload('hzapp/breed/save_test_trait_image.do', null, formData, function(data) {
					mui.toast('保存成功', {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.colseWaiting();
				})
			},
			//图片预览
			// 		previewImg(){
			// 			if(vm.imageFilesPath.length>0){
			// 				var imgeGroup = mui.previewImage();  
			// 				/**  
			// 				* 第一个参数是分组中图片的索引，从0开始；  
			// 				* 第二个参数是分组的索引；  
			// 				*/  
			// 				imgeGroup.open(0, 1); 
			// 			}else{
			// 					mui.toast('暂无图片');
			// 			}
			// 			
			// 		},
			//获取已经保存的图片
			// 		getPic(trait){
			// 			window.model.post('hzapp/breed/load_field_image.do',{
			// 				breed_plan_id: vm.breedPlan.breedPlanId,
			// 				subitem_germplasm_id:trait.subitem_germplasm_id||null,
			// 				trait_id:trait.trait_id,
			// 			},function(res){
			// 				
			// 			})
			// 		},
			// 跳转图片展示页面
			getPic: function(trait) {
				mui.openWindow({
					url: '/html/breeding/pictures.html',
					id: '/html/breeding/pictures.html',
					extras: {
						trait: trait,
						breedPlan: vm.breedPlan
					}
				})
			},
			//下拉选择
			changePicker(selectList, key, e) {
				window.scrollTo(0, parseInt(e.currentTarget.offsetTop) - 50)
				if (selectList.length > 0) {
					selectList = selectList.map(x => {
						return {
							value: x.value,
							text: x.value
						}
					});
				};
				common.picker.initPicker(vm, 'selectItem', selectList);
				common.picker.changePicker(vm, 'selectItem', (selectedItem) => {
					vm.fieldData[key].trait_value = selectedItem[0].value;
					saveCurrentTrait()
				})
			},
			//选择日期
			selectData(key) {
				var _self = this;
				if (_self.picker) {
					_self.picker.show(function(rs) {
						vm.fieldData[key].trait_value = rs.text;
						_self.picker.dispose();
						_self.picker = null;
						saveCurrentTrait()
					});
				} else {
					var optionsJson = vm.dataOption || '{}';
					var options = JSON.parse(optionsJson);
					//var id = this.getAttribute('id');
					/*
					 * 首次显示时实例化组件
					 * 示例为了简洁，将 options 放在了按钮的 dom 上
					 * 也可以直接通过代码声明 optinos 用于实例化 DtPicker
					 */
					_self.picker = new mui.DtPicker(options);
					_self.picker.show(function(rs) {
						/*
						 * rs.value 拼合后的 value
						 * rs.text 拼合后的 text
						 * rs.y 年，可以通过 rs.y.vaue 和 rs.y.text 获取值和文本
						 * rs.m 月，用法同年
						 * rs.d 日，用法同年
						 * rs.h 时，用法同年
						 * rs.i 分（minutes 的第二个字母），用法同年
						 */
						vm.fieldData[key].trait_value = rs.text;
						/* 
						 * 返回 false 可以阻止选择框的关闭
						 * return false;
						 */
						/*
						 * 释放组件资源，释放后将将不能再操作组件
						 * 通常情况下，不需要示放组件，new DtPicker(options) 后，可以一直使用。
						 * 当前示例，因为内容较多，如不进行资原释放，在某些设备上会较慢。
						 * 所以每次用完便立即调用 dispose 进行释放，下次用时再创建新实例。
						 */
						_self.picker.dispose();
						_self.picker = null;
						saveCurrentTrait()
					});
				}
			},
			//选择单株
			onSelectSingle(trait) {
				vm.isSelectSingle = true;
				vm.traitTemp = trait;
			},
			//选择单株弹窗确定
			okSelectSingleBtn() {
				vm.isSelectSingle = false;
			},
			//批量弹窗
			onAllHandle(trait) {
				vm.isAllHandle = true;
				vm.fieldNoTemp = vm.field.field_no.slice(0, -4);
				let batchTemp = [];
				let tempArr = [];
				vm.fieldData.forEach(item => {
					if (item.trait_value) {
						if (batchTemp.length == 0) {
							batchTemp.push(Object.assign({
								selected: false
							}, item));
							tempArr.push(item.trait_name);
						} else if (item.trait_name.indexOf(tempArr) == -1) {
							batchTemp.push(Object.assign({
								selected: false
							}, item));
						}
					}
				});
				vm.batchPopArr = batchTemp;
			},
			//选择批量弹窗确定
			okAllHandleBtn() {
				if (!vm.batch.from_field || !vm.batch.to_field) {
					mui.toast("请填写编码", {
						type: 'div',
						duration: 'long'
					});
					return false;
				}
				if (vm.batchPopArr.length > 0) {
					let traitidsArr = [];
					let traitvaluesArr = [];
					vm.batchPopArr.forEach(item => {
						if (item.selected) {
							traitidsArr.push(item.trait_id);
							traitvaluesArr.push(item.trait_value);
						}
					})
					if (traitidsArr.length == 0) {
						mui.toast("请选择性状", {
							type: 'div',
							duration: 'long'
						});
						return false;
					}
					let traitids = traitidsArr.join(',');
					let traitvalues = traitvaluesArr.join(',');
					// plus.nativeUI.showWaiting()
					window.model.post('hzapp/breed/save_batch_field_data.do', {
						breed_plan_id: vm.breedPlan.breedPlanId,
						from_field: vm.fieldNoTemp + vm.batch.from_field,
						to_field: vm.fieldNoTemp + vm.batch.to_field,
						traitids: traitids,
						traitvalues: traitvalues,
					}, function(data) {
						mui.toast(data.message, {
							type: 'div',
							duration: 'long'
						});
						vm.isAllHandle = false;
						plus.nativeUI.closeWaiting()
					}, function(err) {
						mui.toast(err.message, {
							type: 'div',
							duration: 'long'
						});
						plus.nativeUI.closeWaiting()
					})
				}


			},
			//选择性状
			onselectTrait() {
				vm.visibleFilter = true;
				// plus.nativeUI.showWaiting()
				if (offlineOpen === 'off') {
					plus.sqlite.selectSql({
						name: 'hz',
						sql: `select * from breed_traits where breed_plan_id = ${vm.breedPlan.breedPlanId}`,
						success: function(e) {
							let addTrait = e;
							vm.addTrait = addTrait.map(item => {
								item['selected'] = false;
								return item
							})
						}
					})
				} else {
					window.model.post('hzapp/breed/load_breed_subitem_trait.do', {
						breed_plan_id: vm.breedPlan.breedPlanId,
						subitem_id: vm.field.subitem_id,
					}, function(data) {
						let addTrait = data.data;
						vm.addTrait = addTrait.map(item => {
							item['selected'] = false;
							return item
						})

						plus.nativeUI.closeWaiting()
					}, function() {
						plus.nativeUI.closeWaiting()
					})
				}
			},
			// 确定选择性状列表
			confTrait() {
				var temp = []
				for (var i = 0; i < vm.addTrait.length; i++) {
					var traitItem = vm.addTrait[i]
					if (traitItem.selected) {

						let traitTemp = {
							block_column: '',
							block_row: '',
							decimal_digit: traitItem.decimal_digit,
							field_no: vm.field.field_no,
							germplasm_name: vm.field.germplasm_name,
							max_value: traitItem.max_value,
							min_value: traitItem.min_value,
							ranges: traitItem.ranges,
							subitem_germplasm_id: vm.field.subitem_germplasm_id,
							trait_code: traitItem.trait_code,
							trait_id: traitItem.trait_id,
							trait_name: traitItem.trait_name,
							trait_seq: 0,
							trait_time: '',
							trait_type: traitItem.trait_type,
							trait_value: ''

						};

						temp.push(traitTemp)
					}
				}
				vm.tempBox = temp;
				vm.fieldData = vm.fieldData.concat(temp)
				vm.visibleFilter = false
			},
			// 渲染 计划数据
			handlePlanDetail(data) {
				//vm.breedPlan =data[0];
				let currentTemp = localStorage.getItem('breedingCrossIndexTitle');
				if (currentTemp) {
					vm.breedPlan = JSON.parse(currentTemp)
				} else {
					vm.breedPlan = data[0];
				}
				getNextTrait();
				vm.getPlanProgress();
				window.plus.nativeUI.closeWaiting()
			},
			// 获取计划
			getPlanDetail() {
				// plus.nativeUI.showWaiting();
				if (offlineOpen === 'off') {
					plus.sqlite.selectSql({
						name: 'hz',
						sql: `select * from breed_plans`,
						success: function(e) {
							if (e && e.length > 0) {
								vm.handlePlanDetail(JSON.parse(e[0].list))
							}
						}
					})
				} else {
					window.model.post('hzapp/breed/load_breed_plan.do', {}, function(res) {
						vm.handlePlanDetail(res.data)
					}, function() {
						mui.toast('获取获取育种计划列表失败', {
							type: 'div',
							duration: 'long'
						})
						window.plus.nativeUI.closeWaiting()
					})
				}
			},
			// 跳转搜索页
			goSearch() {
				mui.openWindow({
					url: '/html/data/search-list1.html',
					id: '/html/data/search-list1.html',
					extras: {
						breed_plan_id: vm.breedPlan.breedPlanId
					}
				});

				// plus.webview.getWebviewById("/html/data/search-list1.html").reload(true);
			},
			// 验证小数点位数
			limitStr(e, trait) {
				var reg = new RegExp("^\\d*(\\.?\\d{0," + trait.decimal_digit + "})", "g");
				trait.trait_value = trait.trait_value.match(reg)[0]
			}
		},

	})
	// 处理下一个区性状
	function handleNextTrait(data) {
		vm.field = data.field
		vm.blockRow = parseInt(data.field.plant_row)
		vm.blockColumn = parseInt(data.field.plant_col)
		var ret = data.fieldData
		ret.forEach(item => {
			item.value = item.trait_value;
		});
		vm.fieldData = ret;
		if (vm.tempBox.length > 0) {
			vm.tempBox.map((item) => {
				item.field_no = data.field.field_no;
				item.block_column = data.field.block_column
				item.plant_col = data.field.plant_col
				item.germplasm_name = data.field.germplasm_name
				item.subitem_germplasm_id = data.field.subitem_germplasm_id
			})
			vm.fieldData = vm.fieldData.concat(vm.tempBox);
		}
		vm.field_no = data.field.field_no
		getOfflinePictures()
		plus.nativeUI.closeWaiting()
	}

	// 获取离线图片列表
	function getOfflinePictures() {
		var offlineOpen = localStorage.getItem('offline')
		for (let i = 0; i < vm.fieldData.length; i++) {
			const fieldItem = vm.fieldData[i];
			let sql =
				`select * from breed_trait_image where breed_plan_id = ${vm.breedPlan.breedPlanId} and subitem_germplasm_id = ${fieldItem.subitem_germplasm_id} and `
			sql += `trait_id = ${fieldItem.trait_id} `
			if (offlineOpen !== 'off') {
				sql += `and status = 0 `
			}
			if (fieldItem.block_row) {
				sql += `and block_row = ${fieldItem.block_row} `
			}
			if (fieldItem.block_column) {
				sql += `and block_column = ${fieldItem.block_column}`
			}
			plus.sqlite.selectSql({
				name: 'hz',
				sql: sql,
				success: function(e) {
					if (e.length > 0) {
						fieldItem.imageCount += e.length
					}
				},
				fail: function(e) {
					console.log(e)
				}
			})
		}
	}

	// 获取性状数据
	function getTraitData() {
		plus.sqlite.selectSql({
			name: 'hz',
			sql: `select * from breed_trait_data where breed_plan_id = ${vm.breedPlan.breedPlanId} and field_no = '${vm.field.field_no}'`,
			success: function(e) {
				e.forEach(item => {
					if (item.trait_value === 'null') {
						item.trait_value = ''
					}
				});
				vm.fieldData = e
				getOfflinePictures()
			}
		})
	}

	// 获取下一个区性状
	function getNextTrait(flag) {
		// 清空点击下一个携带的性状值
		vm.tempBox.map((item, index) => {
			item.trait_value = '';
		})
		plus.nativeUI.showWaiting()
		if (offlineOpen === 'off') {
			plus.nativeUI.closeWaiting()
			plus.sqlite.selectSql({
				name: 'hz',
				sql: `select * from breed_fields where breed_plan_id = ${vm.breedPlan.breedPlanId}`,
				success: function(e) {
					if (e && e.length > 0) {
						if (vm.field_no === 0) {
							vm.field = e[0]
							vm.field_no = e[0].field_no
						} else {
							let next = ''
							e.forEach((item, itemIndex) => {
								if (item.field_no === vm.field_no) {
									if (itemIndex === (e.length - 1)) {
										vm.field = e[0]
										next = e[0].field_no
									} else {
										vm.field = e[itemIndex + 1]
										next = e[itemIndex + 1].field_no
									}
								}
							});
							vm.field_no = next
						}
					}
					vm.blockRow = parseInt(vm.field.plant_row)
					vm.blockColumn = parseInt(vm.field.plant_col)
					getTraitData()
					plus.nativeUI.closeWaiting()
				},
				fail: function(e) {
					plus.nativeUI.closeWaiting()
				}
			})
		} else {
			if (!vm.breedPlan) {
				window.model.planErr('没有进行中的育种计划');
			}
			window.model.post('hzapp/breed/load_next_field.do', {
				breed_plan_id: vm.breedPlan.breedPlanId,
				field_no: vm.field_no
			}, function(data) {
				switch (data.code) {
					case 1:
						handleNextTrait(data.data)
						break;
					default:
						plus.nativeUI.closeWaiting()
						if (flag) {
							getPrevTrait()
						} else {
							mui.toast("已到最后小区", {
								type: 'div',
								duration: 'long'
							})
						}
						break;
				}
			}, function(err) {
				// mui.toast(err.message, {
				// 	type: 'div',
				// 	duration: 'long'
				// });
				// plus.nativeUI.closeWaiting()
				// plus.webview.currentWebview().hide()
				// var dt = plus.webview.getWebviewById('task-index.html')
				// dt.show('flip-ry', 300)
				// mui.fire(plus.webview.getWebviewById('../breeding/main.html'), 'pane', {
				// 	from: 'taskBreed'
				// })
			})
		}
	}

	// 获取前一个区性状
	function getPrevTrait() {
		// 清空点击下一个携带的性状值
		vm.tempBox.map((item, index) => {
			item.trait_value = '';
		})
		plus.nativeUI.showWaiting()
		if (offlineOpen === 'off') {
			plus.sqlite.selectSql({
				name: 'hz',
				sql: `select * from breed_fields where breed_plan_id = ${vm.breedPlan.breedPlanId}`,
				success: function(e) {
					e.forEach((item, itemIndex) => {
						if (item.field_no === vm.field_no) {
							if (itemIndex === 0) {
								mui.toast('已到最前面', {
									type: 'div',
									duration: 'long'
								})
							} else {
								vm.field = e[itemIndex - 1]
								vm.field_no = e[itemIndex - 1].field_no
							}
						}
					});
					getTraitData()
					plus.nativeUI.closeWaiting()
				},
				fail: function(e) {
					plus.nativeUI.closeWaiting()
				}
			})
		} else {
			window.model.post('hzapp/breed/load_previous_field.do', {
				breed_plan_id: vm.breedPlan.breedPlanId,
				field_no: vm.field_no
			}, function(data) {
				switch (data.code) {
					case 1:
						vm.field = data.data.field
						vm.blockRow = parseInt(data.data.field.plant_row)
						vm.blockColumn = parseInt(data.data.field.plant_col)
						var ret = data.data.fieldData
						ret.forEach(item => {
							item.value = item.trait_value;
						});
						vm.fieldData = ret
						if (vm.tempBox.length > 0) {
							vm.tempBox.map((item) => {
								item.field_no = data.data.field.field_no;
								item.block_column = data.data.field.block_column
								item.plant_col = data.data.field.plant_col
								item.germplasm_name = data.data.field.germplasm_name
								item.subitem_germplasm_id = data.data.field.subitem_germplasm_id
							})
							vm.fieldData = vm.fieldData.concat(vm.tempBox);
						}
						vm.field_no = data.data.field.field_no
						getOfflinePictures()
						plus.nativeUI.closeWaiting()
						break;
					default:
						plus.nativeUI.closeWaiting()
						mui.toast('已到第一个小区', {
							type: 'div',
							duration: 'long'
						});
						break;
				}
			}, function(err) {
				mui.toast(err.message, {
					type: 'div',
					duration: 'long'
				});
				plus.nativeUI.closeWaiting()
			})
		}
	}

	// 保存当前数据
	function saveCurrentTrait() {
		var params = []
		let status = 1
		if (offlineOpen === 'off') {
			status = 0
		}
		vm.fieldData.forEach((item) => {
			if (item.trait_value) {
				params.push({
					'subitemGermplasmId': item.subitem_germplasm_id,
					'traitId': item.trait_id,
					'blockRow': item.block_row || 0,
					'blockColumn': item.block_column || 0,
					'traitValue': item.trait_value,
					'traitTime': moment().format('YYYY-MM-DD HH:mm:ss'),
					'traitSeq': 1
				})
			}
		})
		plus.sqlite.selectSql({
			name: 'hz',
			sql: `select * from breed_trait_data where breed_plan_id = ${vm.breedPlan.breedPlanId} and field_no = '${vm.field.field_no}' and subitem_germplasm_id = ${vm.field.subitem_germplasm_id}`,
			success: function(e) {
				if (e && e.length > 0) {
					vm.fieldData.forEach((item, index) => {
						if (item.trait_value) {
							let sql = `update breed_trait_data set `
							sql +=
								`trait_value = '${item.trait_value}', status = ${status} where breed_plan_id = ${vm.breedPlan.breedPlanId} and field_no = '${vm.field.field_no}' and subitem_germplasm_id = ${vm.field.subitem_germplasm_id} and trait_name = '${item.trait_name}' and block_column = ${item.block_column} and block_row = ${item.block_row}`
							plus.sqlite.executeSql({
								name: 'hz',
								sql: sql
							})
						}
					})
				} else {
					let sql = `insert into breed_trait_data values `
					let count = 0
					vm.fieldData.forEach((item, index) => {
						if (item.trait_value) {
							if (count > 0) {
								sql += ','
							}
							count++
							sql +=
								`(${vm.breedPlan.breedPlanId}, ${item.subitem_germplasm_id}, ${item.trait_id}, ${item.block_row || 0}, ${item.block_column || 0}, '${item.trait_code}', '${item.trait_value}', `
							sql +=
								`${item.trait_seq}, '${item.trait_time}', '', '', ${status}, ${item.decimal_digit}, '${item.field_no}', '${item.germplasm_name}', '${item.ranges}', '${item.trait_name}', ${item.trait_type})`
						}
					})
					plus.sqlite.executeSql({
						name: 'hz',
						sql: sql
					})
				}
			}
		})
		if (offlineOpen !== 'off') {
			window.model.post('hzapp/breed/save_field_data.do', {
				breed_plan_id: vm.breedPlan.breedPlanId,
				data: JSON.stringify(params)
			}, function(data) {}, function() {

			})
		}
	}

	// 	let breedPlan= localStorage.getItem('breedingCrossIndexTitle');
	// 	vm.breedPlan=JSON.parse(breedPlan)
	vm.getPlanDetail();
	// 	getNextTrait();
	// 	vm.getPlanProgress();
// 获取计划
	window.addEventListener('getPlan', function(event) {
		vm.breedPlan = event.detail.breedPlan
		vm.field_no = 0;
		offlineOpen = localStorage.getItem('offline')
		localStorage.setItem('breedingCrossIndexTitle', JSON.stringify(event.detail.breedPlan));
		getNextTrait(true);
		vm.getPlanProgress();
	})
	// 上一个事件
	window.addEventListener('prev', function(event) {
		vm.prevTrait()
	})
	// 下一个事件
	window.addEventListener('next', function(event) {
		vm.nextTrait();
	})
	// 左滑事件
	window.addEventListener('swipeleft', function() {
		getNextTrait()
	})
	// 右滑事件
	window.addEventListener('swiperight', function() {
		getPrevTrait()
	})
// 处理小区编号数据
	window.addEventListener('setData', function(event) {
		let extrasParams = JSON.parse(localStorage.getItem("extrasParams"));
		if (offlineOpen === 'off') {
			plus.sqlite.selectSql({
				name: 'hz',
				sql: `select * from breed_fields where breed_plan_id = ${vm.breedPlan.breedPlanId}`,
				success: function(e) {
					if (e && e.length > 0) {
						if (vm.field_no === 0) {
							vm.field = e[0]
							vm.field_no = e[0].field_no
						} else {
							e.forEach((item, itemIndex) => {
								if (item.field_no === extrasParams.field_no) {
									if (itemIndex === (e.length - 1)) {
										vm.field = e[0]
									} else {
										vm.field = e[itemIndex]
									}
								}
							});
							vm.field_no = extrasParams.field_no
						}
					}
					vm.blockRow = parseInt(vm.field.plant_row)
					vm.blockColumn = parseInt(vm.field.plant_col)
					getTraitData()
					plus.nativeUI.closeWaiting()
				},
				fail: function(e) {
					plus.nativeUI.closeWaiting()
				}
			})
		} else {
			window.model.post('hzapp/breed/load_breed_field.do', {
				breed_plan_id: vm.breedPlan.breedPlanId,
				field_no: extrasParams.field_no,
			}, function(data) {
				switch (data.code) {
					case 1:
						handleNextTrait(data.data)
						break;
					default:
						plus.nativeUI.closeWaiting()
						mui.toast(data.message, {
							type: 'div',
							duration: 'long'
						});
						break;
				}
			}, function(err) {
				mui.toast(err.message, {
					type: 'div',
					duration: 'long'
				});
				plus.nativeUI.closeWaiting()
			})
		}
	})


})
