(function(mui, w, document, $) {
	mui.ready(function() {
		mui.init({});
		//点击查看更多
		const onMoreBtn = function() {
			mui('.mui-card').on('tap', '.mui-card-footer', function() {
				mui.openWindow({
					url: 'progress-report-detail.html',
					id: 'progress-report-detail.html',
					extras: {
						test_id: $(this).data('testid')
					}
				})
			});
		};
		/*获取试验测试点状态报告*/
		var getTestReport = function() {
			plus.nativeUI.showWaiting();
			w.model.post('hzapp/fieldtest/load_test_report.do', {}, function(data) {
				switch (data.code) {
					case 1:
						let html = '';
						let res = data.data.tests;
						for (let htmlKey in res) {
							html +=
								`<div class="mui-card">
								<div class="mui-card-header">
									<img src="../../images/icon/test.png" />
									<p>${res[htmlKey].test_name}</p>
								</div>
								<div class="mui-card-content">
									<div class="mui-card-content-inner card-cell-half clearfix">
										<p>试验类型：${res[htmlKey].testType}</p>
										<p>负 责 人：${res[htmlKey].createUser}</p>
										<p>创建日期：${res[htmlKey].createDate}</p>
										<p>试验状态：${res[htmlKey].status}</p>
										<p>测试点数：${res[htmlKey].pointRefSize}</p>
										<p>实验组数：${res[htmlKey].groupsize}</p>
										<p>品种个数：${res[htmlKey].varietyRefSize}</p>
									</div>
								</div>
								<div class="mui-card-footer" data-testid=\"${res[htmlKey].test_id}\"><img src="../../images/icon/more.png" />查看详情</div>
							</div>`;
						}
						$('.mui-content').html(html);
						onMoreBtn(); //点击更多按钮
						plus.nativeUI.closeWaiting();
						break;
					default:
						mui.toast(data.message, {
							type: 'div',
							duration: 'long'
						});
						plus.nativeUI.closeWaiting();
						break;
				}
			}, function(error) {
				mui.toast(error.message, {
					type: 'div',
					duration: 'long'
				});
				plus.nativeUI.closeWaiting();
			})
		};

		mui.plusReady(function() {
			getTestReport(); //获取试验测试点状态报告	
		});
	})
})(mui, window, document, $)
