var offlineOpen = localStorage.getItem('offline')
var vm = new Vue({
	el: "#content",
	data: function() {
		return {
			isShowHeaderList: false,
			current: {},
			breadList: [],
			search_value: '',
			executionList: [],
			status: 0,
			selectExcution: [],
			selAll: false,
			queryTime: 800000,
			iv: '',
			verifyFlag: {
				1: '可收',
				2: '不可收'
			},
			breeding: {}
		}
	},
	methods: {
		openPopover() {
			mui('#sheet1').popover('toggle');
		},
		showHeaderList() {
			this.isShowHeaderList = !this.isShowHeaderList;
		},
		closeHeaderList() {
			this.isShowHeaderList = false;
		},
		selectBread(bread) {
			vm.current = bread
			localStorage.setItem('breedingCrossIndexTitle', JSON.stringify(bread));
			vm.isShowHeaderList = false
			getCollectionList()
		},
		// 跳转编辑页面
		editExcution(excution) {
			mui.openWindow({
				url: '/html/breeding/seed-collection-update.html',
				id: '/html/breeding/seed-collection-update.html',
				extras: {
					excution: excution,
					breedPlanId: vm.current.breedPlanId
				}
			})
		},
		addExcution() {
			mui.openWindow({
				url: '/html/breeding/seed-collection-update.html',
				id: '/html/breeding/seed-collection-update.html',
				extras: {
					excution: {
						field_no: '',
						plan_block_row: '',
						plan_block_column: '',
						plan_collect_number: '',
						actual_block_row: '',
						actual_block_column: ''
					},
					breedPlanId: vm.current.breedPlanId
				}
			})
		},
		// 操作育种选择
		maniSeed() {
			if (vm.status === 0) {
				vm.status = 1
			} else {
				vm.status = 0
			}
		},
		maniFail() {
			updateStatus('2')
		},
		maniSuccess() {
			updateStatus('1')
		},
		changeVerifyFlagPopover(breeding) {
			vm.breeding = breeding
			mui('#sheet1').popover('toggle')
		},
		changeVerifyFlag(type) {
			updateBreeding(type)
		}
	},
	watch: {
		selAll(val) {
			if (val) {
				let ret = []
				for (let i = 0; i < vm.executionList.length; i++) {
					ret.push(i + '')
				}
				vm.selectExcution = ret
			} else {
				vm.selectExcution = []
			}
		},
		search_value(val, old) {
			clearInterval(vm.iv)
			vm.iv = setInterval(() => {
				clearInterval(vm.iv)
				getCollectionList()
			}, 800);
		}
	}
})

// 更新失败状态
function updateStatus(status) {
	var params = []
	plus.nativeUI.showWaiting()
	var executionList = vm.executionList
	for (let i = 0; i < executionList.length; i++) {
		const execution = executionList[i];
		if (vm.selectExcution.indexOf(i) !== -1) {
			execution.collect_status = status
			params.push({
				subitemGermplasmId: execution.subitem_germplasm_id,
				planBlockRow: execution.plan_block_row,
				planBlockColumn: execution.plan_block_column,
				collectStatus: status
			})
		}
	}
	vm.executionList = executionList
	let statusDone = 1
	if (offlineOpen === 'off') {
		statusDone = 0
	}
	params.forEach(item => {
		let sql =
			`update breed_collect_execute set collect_status = '${status}', status = ${statusDone} where breed_plan_id = ${vm.current.breedPlanId} and subitem_germplasm_id = ${item.subitemGermplasmId}`
		sql += ` and plan_block_column = ${item.planBlockColumn || 0} and plan_block_row = ${item.planBlockRow || 0}`
		plus.sqlite.executeSql({
			name: 'hz',
			sql: sql,
			success: function(e) {
				if (offlineOpen === 'off') {
					mui.toast('更新成功！', {
						type: 'div',
						duration: 'long'
					})
				}
			}
		})
	});

	if (offlineOpen !== 'off') {
		window.model.post('hzapp/breed/update_collect_status.do', {
			breed_plan_id: vm.current.breedPlanId,
			data: JSON.stringify(params)
		}, function(data) {
			if (data.code === 1) {
				mui.toast('修改状态成功!', {
					type: 'div',
					duration: 'long'
				})
			} else {
				mui.toast('修改状态失败!', {
					type: 'div',
					duration: 'long'
				})
			}
			plus.nativeUI.closeWaiting()
			vm.status = 0
			vm.selectExcution = []
			mui('#sheet1').popover('hide')
			getBreadList();
		}, function(error) {
			mui.toast(error.message), {
				type: 'div',
				duration: 'long'
			};
			plus.nativeUI.closeWaiting()
		})
	} else {
		plus.nativeUI.closeWaiting()
	}
}

// 更新可收状态
function updateBreeding(type) {
	plus.nativeUI.showWaiting()
	let status = 1
	if (offlineOpen === 'off') {
		status = 0
	}
	let sql =
		`update breed_collect_execute set collect_status = '${vm.verifyFlag[type]}', status = ${status} where breed_plan_id = ${vm.current.breedPlanId} and subitem_germplasm_id = ${vm.breeding.subitem_germplasm_id}`
	sql += ` and plan_block_column = ${vm.breeding.plan_block_column} and plan_block_row = ${vm.breeding.plan_block_row}`
	plus.sqlite.executeSql({
		name: 'hz',
		sql: sql,
		success: function(e) {
			if (offlineOpen === 'off') {
				vm.breeding.verify_flag = type
				mui.toast('更新成功！', {
					type: 'div',
					duration: 'long'
				})
				mui('#sheet1').popover('hide')
			}
			plus.nativeUI.closeWaiting()
		},
		fail: function(e) {
			plus.nativeUI.closeWaiting()
		}
	})
	if (offlineOpen !== 'off') {
		console.log(JSON.stringify({
			subitemGermplasmId: vm.breeding.subitem_germplasm_id,
			planBlockRow: vm.breeding.plan_block_row,
			planBlockColumn: vm.breeding.plan_block_column,
			verifyFlag: type
		}))
		window.model.post('hzapp/breed/update_collect_verifyflag.do', {
			breed_plan_id: vm.current.breedPlanId,
			data: JSON.stringify([{
				subitemGermplasmId: vm.breeding.subitem_germplasm_id,
				planBlockRow: vm.breeding.plan_block_row,
				planBlockColumn: vm.breeding.plan_block_column,
				matchNo: vm.breeding.match_no,
				matchOperateNo: vm.breeding.match_operate_no,
				verifyFlag: type
			}])
		}, function(data) {

			if (data.code === 1) {
				vm.breeding.verify_flag = type
				mui.toast('修改状态成功!', {
					type: 'div',
					duration: 'long'
				})
				mui('#sheet1').popover('hide')
			} else {
				mui.toast(data.message, {
					type: 'div',
					duration: 'long'
				})
			}
			plus.nativeUI.closeWaiting()
		}, function(error) {
			mui.toast(error.message), {
				type: 'div',
				duration: 'long'
			};
			plus.nativeUI.closeWaiting()
		})
	}
}

// 获取收种执行
function getCollectionList() {
	if (offlineOpen === 'off') {
		let sql = `select * from breed_collect_execute where breed_plan_id = '${vm.current.breedPlanId}'`
		if (vm.search_value) {
			sql += ` and field_no = '${vm.search_value}'`
		}
		plus.sqlite.selectSql({
			name: 'hz',
			sql: sql,
			success: function(e) {
				if (e && e.length > 0) {
					e.forEach(item => {
						if (item.field_no === 'null') {
							item.field_no = ''
						}
						if (item.plan_collect_number === 'null') {
							item.plan_collect_number = ''
						}
					});
				}
				vm.executionList = e
			}
		})
		plus.nativeUI.closeWaiting()
	} else {
		if (!vm.current) {
			window.model.planErr('没有进行中的育种计划');
		}
		window.model.post('hzapp/breed/load_collect_execution.do', {
			breed_plan_id: vm.current.breedPlanId,
			search_value: vm.search_value
		}, function(data) {
			vm.executionList = data.data
			plus.nativeUI.closeWaiting()
		}, function(error) {
			mui.toast(error.message), {
				type: 'div'
			};
			plus.nativeUI.closeWaiting()
		})
	}
}

// 渲染育种计划列表
function handleBreeds(data) {
	vm.breadList = data
	let currentTemp = localStorage.getItem('breedingCrossIndexTitle');
	if (currentTemp) {
		vm.current = JSON.parse(currentTemp)
	} else {
		vm.current = data[0]
	}
	getCollectionList()
	plus.nativeUI.closeWaiting()
}

// 获取育种计划列表
function getBreadList() {
	plus.nativeUI.showWaiting()
	if (offlineOpen === 'off') {
		plus.sqlite.selectSql({
			name: 'hz',
			sql: `select * from breed_plans`,
			success: function(e) {
				if (e && e.length > 0) {
					handleBreeds(JSON.parse(e[0].list))
				}
			}
		})
		plus.nativeUI.closeWaiting()
	} else {
		window.model.post('hzapp/breed/load_breed_plan.do', {}, function(data) {
			vm.breadList = data.data
			let currentTemp = localStorage.getItem('breedingCrossIndexTitle');
			if (currentTemp) {
				vm.current = JSON.parse(currentTemp)
			} else {
				vm.current = data.data[0];
			}
			getCollectionList()
			plus.nativeUI.closeWaiting()
		}, function() {
			plus.nativeUI.closeWaiting()
		})
	}
}

mui.plusReady(function() {
	plus.sqlite.openDatabase({
		name: 'hz',
		path: '_doc/huazhi.db',
		success: function(e) {},
		fail: function(e) {}
	})
	getBreadList()
})
// 刷新数据
window.addEventListener('homeRefresh', function(event) {
	offlineOpen = localStorage.getItem('offline')
	getBreadList()
})
mui.back = function() {
	// 返回事件
	vm.isShowHeaderList = false;
	var offlineOpen = localStorage.getItem('offline')
	if (offlineOpen === 'off') {
		mui.fire(plus.webview.getWebviewById('html/main/home.html'), 'refreshOffline')
	}
	plus.webview.currentWebview().hide("auto", 300);
};

window.addEventListener('refresh', function(e) { //执行刷新
	location.reload();
});
