mui.init({})
var offlineOpen = localStorage.getItem('offline')
var vm = new Vue({
	el: '#content',
	data: function() {
		return {
			breedPlan: {},
			breed: {},
			field_no: '',
			fieldData: [1],
			field: {},
			traitConfig: null, //性状输入的配置
			dataOption: '{"type":"date","beginYear":2000,"endYear":2200}', //日期类型 
			selectItem: { //下拉框
				text: '',
				picker: {}
			},
			isSelectSingle: false,
			traitTemp: {},
			pop: null,
			blockRow: 0,
			blockColumn: 0,
			tabIndex: 1,
		}
	},
	methods: {
		// 保存性状
		saveCurrentTrait() {
			plus.nativeUI.showWaiting();
			var params = []
			let status = 1
			if (offlineOpen === 'off') {
				status = 0
			}
			vm.fieldData.forEach((item) => {
				if (item.trait_value) {
					params.push({
						'subitemGermplasmId': item.subitem_germplasm_id || '',
						'traitId': vm.traitConfig.trait_id || '',
						'blockRow': item.block_row || '',
						'blockColumn': item.block_column || '',
						'traitValue': item.trait_value || '',
						'traitTime': item.trait_time || '',
						'traitSeq': 1
					})
				}
			})

			plus.sqlite.selectSql({
				name: 'hz',
				sql: `select * from breed_trait_data where breed_plan_id = ${vm.breedPlan.breedPlanId} and field_no = '${vm.field.field_no}'`,
				success: function(e) {
					if (e && e.length > 0) {
						vm.fieldData.forEach((item, index) => {
							if (item.trait_value) {
								let sql = `update breed_trait_data set `
								sql +=
									`trait_value = '${item.trait_value}' where breed_plan_id = ${vm.breedPlan.breedPlanId} and field_no = '${vm.field.field_no}' and trait_name = '${item.trait_name}' and block_column = ${item.block_column} and block_row = ${item.block_row}`
								plus.sqlite.executeSql({
									name: 'hz',
									sql: sql,
									success: function(e) {
										if (offlineOpen === 'off') {
											mui.toast('保存成功', {
												type: 'div',
												duration: 'long'
											})
										}
									},
									fail: function(e) {
										console.log(e)
									}
								})
							}
						})
					} else {
						let sql = `insert into breed_trait_data values `
						let count = 0
						vm.fieldData.forEach((item, index) => {
							if (item.trait_value) {
								if (count > 0) {
									sql += ','
								}
								count++
								sql +=
									`(${vm.breedPlan.breedPlanId}, ${item.subitem_germplasm_id}, ${vm.traitConfig.trait_id}, ${item.block_row || 0}, ${item.block_column || 0}, '${vm.traitConfig.trait_code}', '${item.trait_value}', `
								sql +=
									`${item.trait_seq}, '${item.trait_time}', '', '', ${status}, ${vm.traitConfig.decimal_digit}, '${item.field_no}', '${vm.traitConfig.germplasm_name}', '${vm.traitConfig.ranges}', '${vm.traitConfig.trait_name}', ${vm.traitConfig.trait_type})`
							}
						})
						plus.sqlite.executeSql({
							name: 'hz',
							sql: sql,
							success: function(e) {
								if (offlineOpen == 'off') {
									plus.nativeUI.closeWaiting()
									mui.toast('保存成功', {
										type: 'div',
										duration: 'long'
									})
								}
							},
							fail: function(e) {
								console.log(e)
							}
						})
					}
				}
			})

			if (offlineOpen !== 'off') {
				window.model.post('hzapp/breed/save_field_data.do', {
					breed_plan_id: vm.breedPlan.breedPlanId,
					data: JSON.stringify(params)
				}, function(data) {
					plus.nativeUI.closeWaiting()
					mui.toast('保存成功！', {
						type: 'div',
						duration: 'short'
					})
				}, function() {
					plus.nativeUI.closeWaiting()
				})
			}
		},
		// 跳转图片展示页面
		getPic: function(trait) {
			let traitInfo = Object.assign({
				trait_id: vm.traitConfig.trait_id
			}, trait)
			mui.openWindow({
				url: '/html/breeding/pictures.html',
				id: '/html/breeding/pictures.html',
				extras: {
					trait: traitInfo,
					breedPlan: vm.breedPlan
				}
			})
		},
		// 值范围验证
		judgeMinMax(trait) {
			let val = parseInt(trait.trait_value)
			if (val > vm.traitConfig.max_value || val < vm.traitConfig.min_value) {
				mui.toast(`值范围为${vm.traitConfig.min_value}-${vm.traitConfig.max_value}`, {
					type: 'div',
					duration: 'short'
				})
				trait.trait_value = '';
			}
		},
		// 选中列事件
		selColumn() {
			if (!vm.pop) {
				vm.pop = new mui.PopPicker()
			}
			var rows = []
			for (let i = 1; i <= vm.blockColumn; i++) {
				rows.push({
					text: i,
					value: i
				})
			}
			vm.pop.setData(rows)
			vm.pop.show(function(items) {
				vm.traitTemp.block_column = items[0].value
			})
		},
		// 选中行事件
		selRow() {
			if (!vm.pop) {
				vm.pop = new mui.PopPicker()
			}
			var rows = []
			for (let i = 1; i <= vm.blockRow; i++) {
				rows.push({
					text: i,
					value: i
				})
			}
			vm.pop.setData(rows)
			vm.pop.show(function(items) {
				vm.traitTemp.block_row = items[0].value
			})
		},
		//选择单株弹窗确定
		okSelectSingleBtn() {
			vm.isSelectSingle = false;
		},
		//选择单株
		onSelectSingle(trait) {
			vm.blockColumn = trait.plant_col
			vm.blockRow = trait.plant_row
			vm.isSelectSingle = true;
			vm.traitTemp = trait;
		},
		// 调用摄像头并拍照
		getImage: function(trait) {
			var cmr = plus.camera.getCamera();
			cmr.captureImage(function(p) {
				plus.io.resolveLocalFileSystemURL(p, function(entry) {
					entry.file(function(file) {
						let sql =
							`insert into breed_trait_image values(${vm.breedPlan.breedPlanId}, ${trait.subitem_germplasm_id}, ${vm.traitConfig.trait_id}, `
						sql +=
							`${trait.block_row}, ${trait.block_column}, '', ${trait.trait_seq}, '${trait.trait_time}', '${file.fullPath}', '${file.name}', '${file.size}', '', '', '', 0)`
						plus.sqlite.executeSql({
							name: 'hz',
							sql: sql,
							success: function(e) {
								trait.imageCount += 1
								mui.toast('保存图片成功！', {
									type: 'div',
									duration: 'long'
								})
							}
						})
					})
				}, function(e) {
					plus.nativeUI.toast("读取拍照文件错误：" + e.message);
				});
			}, function(e) {}, {
				filter: 'image'
			});
		},
		//从相册选择照片
		galleryImgs: function(trait) {
			plus.gallery.pick(function(e) {
				var reader = new plus.io.FileReader(); // 构建文件对象  
				reader.readAsDataURL(e) // 添加文件（此处安卓可以直接添加文件路径，而IOS则需要文件对象）  
				reader.onloadend = function(event) { // 文件加载 完成后的事件回调  
					vm.uploadImage(trait, event.target.result)
				};
			}, function(e) {}, {
				filter: "image"
			});
		},
		// 保存图片
		uploadImage: function(trait, file) {
			var filename = trait.breedPlanId + '_'
			filename += trait.group_code + '_'
			filename += trait.data_seq + '_' // data_seq
			filename += trait.trait_id + '_'
			filename += trait.random_id + '_'
			filename += new Date().getTime()
			var formData = new FormData()
			formData.append('file', file);
			formData.append('filename', filename)
			formData.append('random_id', trait.random_id)
			window.model.upload('hzapp/breed/save_test_trait_image.do', formData, function(data) {
				mui.toast('保存成功', {
					duration: 'long',
					type: 'div'
				});
			})
		},
		//下拉选择
		changePicker(selectList, key) {

			// selectList=selectList[0].split(',');
			if (selectList.length > 0) {
				selectList = selectList.map(x => {
					return {
						value: x.value,
						text: x.value
					}
				});
			};
			common.picker.initPicker(vm, 'selectItem', selectList);
			common.picker.changePicker(vm, 'selectItem', (selectedItem) => {
				vm.fieldData[key].trait_value = selectedItem[0].value;
			})
		},
		//选择日期
		selectData(key) {
			var _self = this;
			if (_self.picker) {
				_self.picker.show(function(rs) {
					vm.fieldData[key].value = rs.text;
					_self.picker.dispose();
					_self.picker = null;
				});
			} else {
				var optionsJson = vm.dataOption || '{}';
				var options = JSON.parse(optionsJson);
				//var id = this.getAttribute('id');
				/*
				 * 首次显示时实例化组件
				 * 示例为了简洁，将 options 放在了按钮的 dom 上
				 * 也可以直接通过代码声明 optinos 用于实例化 DtPicker
				 */
				_self.picker = new mui.DtPicker(options);
				_self.picker.show(function(rs) {
					/*
					 * rs.value 拼合后的 value
					 * rs.text 拼合后的 text
					 * rs.y 年，可以通过 rs.y.vaue 和 rs.y.text 获取值和文本
					 * rs.m 月，用法同年
					 * rs.d 日，用法同年
					 * rs.h 时，用法同年
					 * rs.i 分（minutes 的第二个字母），用法同年
					 */
					vm.fieldData[key].trait_value = rs.text;
					/* 
					 * 返回 false 可以阻止选择框的关闭
					 * return false;
					 */
					/*
					 * 释放组件资源，释放后将将不能再操作组件
					 * 通常情况下，不需要示放组件，new DtPicker(options) 后，可以一直使用。
					 * 当前示例，因为内容较多，如不进行资原释放，在某些设备上会较慢。
					 * 所以每次用完便立即调用 dispose 进行释放，下次用时再创建新实例。
					 */
					_self.picker.dispose();
					_self.picker = null;
				});
			}
		},
		// 小数点位数验证
		limitStr(e, trait) {
			var reg = new RegExp("^\\d*(\\.?\\d{0," + vm.traitConfig.decimal_digit + "})", "g");
			trait.trait_value = trait.trait_value.match(reg)[0]
		}
	}
})

// 获取下一个区性状
function getNextTrait() {
	plus.nativeUI.showWaiting();
	window.model.post('hzapp/breed/load_next_field.do', {
		breed_plan_id: vm.breedPlan.breedPlanId,
		field_no: vm.field_no
	}, function(data) {
		vm.field = data.data.field
		var ret = data.data.fieldData
		ret.forEach(item => {
			item.trait_value = ''
		});
		vm.fieldData = ret
		vm.field_no = data.data.field.field_no
		getOfflinePictures()
		plus.nativeUI.closeWaiting()
	}, function() {
		plus.nativeUI.closeWaiting()
	})
}

// 获取前一个区性状
function getPrevTrait() {
	window.model.post('hzapp/breed/load_previous_field.do', {
		breed_plan_id: vm.breedPlan.breedPlanId,
		field_no: vm.field_no
	}, function(data) {
		vm.field = data.data.field
		var ret = data.data.fieldData
		ret.forEach(item => {
			item.trait_value = ''
		});
		vm.fieldData = ret
		vm.field_no = data.data.field.field_no
		getOfflinePictures()
		plus.nativeUI.closeWaiting()
	}, function() {
		plus.nativeUI.closeWaiting()
	})
}

// 获取离线图片列表
function getOfflinePictures() {
	var offlineOpen = localStorage.getItem('offline')
	for (let i = 0; i < vm.fieldData.length; i++) {
		const fieldItem = vm.fieldData[i];
		let sql =
			`select * from breed_trait_image where breed_plan_id = ${vm.breedPlan.breedPlanId} and subitem_germplasm_id = ${fieldItem.subitem_germplasm_id} and `
		sql += `trait_id = ${vm.traitConfig.trait_id} `
		if (offlineOpen !== 'off') {
			sql += `and status = 0 `
		}
		if (fieldItem.block_row) {
			sql += `and block_row = ${fieldItem.block_row} `
		}
		if (fieldItem.block_column) {
			sql += `and block_column = ${fieldItem.block_column}`
		}
		plus.sqlite.selectSql({
			name: 'hz',
			sql: sql,
			success: function(e) {
				if (e.length > 0) {
					fieldItem.imageCount += e.length
				}
			},
			fail: function(e) {
				console.log(e)
			}
		})
	}
}

// 保存当前数据
function saveCurrentTrait() {
	var params = []
	vm.fieldData.forEach(item => {
		params.push({
			'subitemGermplasmId': item.subitem_germplasm_id,
			'traitId': item.trait_id,
			'blockRow': item.block_row,
			'blockColumn': item.block_column,
			'traitValue': item.trait_value,
			'traitTime': item.trait_time
		})
	})
	window.model.post('hzapp/breed/save_field_data.do', {
		breed_plan_id: vm.breedPlan.breedPlanId,
		data: JSON.stringify(params)
	}, function(data) {

	}, function() {

	})
}

// 获取任务详情
function getDetail(type) {
	vm.tabIndex = type
	window.model.post('hzapp/breed/load_breed_task_detail.do', {
		breed_plan_id: vm.breedPlan.breedPlanId,
		task_id: vm.breed.task_id,
		type: type,
	}, function(data) {
		if (data.data && data.data.trait) {
			vm.fieldData = data.data.taskdetail
			vm.traitConfig = data.data.trait
			getOfflinePictures()
		}
	}, function() {

	})
}

mui.plusReady(function() {
	var self = plus.webview.currentWebview()
	vm.breed = self.breed
	vm.breedPlan = self.breedPlan
	vm.field_no = self.breed.field_no
	// getNextTrait()
	getDetail(1)
	plus.key.addEventListener("keydown", function(e) {
		if (e.keyCode === 4) {
			mui.back();
		}
	})
})
