mui.init()
var offlineOpen = localStorage.getItem('offline')
var myApp = {
	initCircle: function(id, val) {
		$(id).empty()
		$(id).radialIndicator({
			initValue: val,
			radius: 25
		});
	},
	init: function() {
		this.initCircle();
	}
}

var vm = new Vue({
	el: '#content',
	data() {
		return {
			breedPlan: {},
			breedTasks: [],
			progress: {},
		}
	},
	methods: {
		//上半截数据
		getPlanProgress() {
			plus.nativeUI.showWaiting()
			window.model.post('hzapp/breed/load_breed_plan_progress.do', {
				breed_plan_id: vm.breedPlan.breedPlanId
			}, function(data) {
				vm.progress = data.data
				document.getElementById("progress-inner").style.width = data.data.trait_progress + "%";
				plus.nativeUI.closeWaiting()
			}, function() {
				plus.nativeUI.closeWaiting()
			})

		},
		// 跳转详情
		goDetail(breed) {
			mui.openWindow({
				url: '/html/breeding/task-collection.html',
				id: '/html/breeding/task-collection.html',
				extras: {
					breedPlan: vm.breedPlan,
					breed: breed
				}
			})
		},
		// 渲染图标数据
		handleTask(data) {
			vm.breedTasks = data
			setTimeout(() => {
				vm.breedTasks.forEach((task, index) => {
					myApp.initCircle('#task' + index, 20);
				});
			}, 250);
			plus.nativeUI.closeWaiting();
		},
		// 获取任务列表
		getTaskList() {
			// plus.nativeUI.showWaiting();
			if (offlineOpen === 'off') {
				plus.sqlite.selectSql({
					name: 'hz',
					sql: `select * from breed_tasks where breed_plan_id = ${vm.breedPlan.breedPlanId}`,
					success: function(e) {
						vm.handleTask(e)
					}
				})
			} else {
				window.model.post('hzapp/breed/load_breed_tasks.do', {
					breed_plan_id: vm.breedPlan.breedPlanId
				}, function(res) {
					vm.handleTask(res.data)
				}, function() {
					plus.nativeUI.closeWaiting();
				})
			}
		}
	}
})

mui.plusReady(function() {
	plus.sqlite.openDatabase({
		name: 'hz',
		path: '_doc/huazhi.db'
	})
	let breedPlan = localStorage.getItem('breedingCrossIndexTitle');
	vm.breedPlan = JSON.parse(breedPlan)
	vm.getTaskList()
	vm.getPlanProgress();
})

// 右滑事件
window.addEventListener('swiperight', function() {
	plus.webview.currentWebview().hide()
	var dt = plus.webview.getWebviewById('planting-index.html')
	dt.show('flip-ry', 300)
	mui.fire(plus.webview.getWebviewById('/html/breeding/main.html'), 'pane', {
		from: 'taskLeft'
	})
})
// 左滑事件
window.addEventListener('swipeleft', function() {
	plus.webview.currentWebview().hide()
	var dt = plus.webview.getWebviewById('picture-collection.html')
	dt.show('flip-ry', 300)
	mui.fire(plus.webview.getWebviewById('/html/breeding/main.html'), 'pane', {
		from: 'taskRight'
	})
})

// 获取计划
window.addEventListener('getPlan', function(event) {
	if (!event.detail.breedPlan) {
		window.model.planErr('没有进行中的育种计划');
	}
	vm.breedPlan = event.detail.breedPlan
	localStorage.setItem('breedingCrossIndexTitle', JSON.stringify(event.detail.breedPlan));
	vm.getTaskList()
	vm.getPlanProgress();
})
