(function(mui, w, document, $) {
	mui.ready(function() {
		mui.init();

		var vm = new Vue({
			el: "#content",
			data: function() {
				return {
					checkOutId: '',
					remark: '',
					status: '',
					approvalMessage: '',
					detail: [],
				}
			},
			computed: {
				statusName: function() {
					switch (parseInt(this.status)) {
						case 0:
							return '待审批';
							break;
						case 1:
							return '通过';
							break;
						case 2:
							return '驳回';
							break;
						case 3:
							return '完成';
							break;
						case 4:
							return '取消';
							break;
						default:
							break;
					}
				},
			},
			methods: {
				// 取消申请
				onCancelApply: function() {
					let checkOutId = this.checkOutId;
					mui.confirm('确定取消申请么？', '系统提示', ['取消', '确认'], function(e) {
						if (e.index === 1) {
							plus.nativeUI.showWaiting();
							w.model.post('hzapp/germplasm/operation_storehouse_checkout.do', {
								checkoutListId: checkOutId,
								action: '4',
								message: '用户自行取消'
							}, function(data) {
								plus.nativeUI.closeWaiting();
							}, function(error) {
								mui.toast(error.message, {
									type: 'div',
									duration: 'long'
								});
								plus.nativeUI.closeWaiting();
							})
						}
					}, 'div')

				},
			},

		});

		//出库申请详情
		function getStorageDetail(checkOutId) {
			plus.nativeUI.showWaiting();
			w.model.post('hzapp/germplasm/load_storehouse_checkout_log.do', {
				checkout_list_id: checkOutId
			}, function(data) {
				vm.remark = data.remark;
				vm.approvalMessage = data.approvalMessage;
				vm.status = data.status;

				vm.detail = data.data;
				plus.nativeUI.closeWaiting();
			}, function(error) {
				mui.toast(error.message, {
					type: 'div',
					duration: 'long'
				});
				plus.nativeUI.closeWaiting();
			})
		};

		mui.plusReady(function() {
			const self = plus.webview.currentWebview();
			const checkOutId = self.checkOutId;
			vm.checkOutId = self.checkOutId;
			getStorageDetail(checkOutId); //出库申请详情	
		})

	})
})(mui, window, document, $)
