(function(mui, w, document, $) {
	mui.ready(function() {
		mui.init();

		var vm = new Vue({
			el: "#content",
			data: function() {
				return {
					checkId: '',
					storehouseName: '',
					remark: '',
					status: '',
					approvalMessage: '',
					telephone: '',
					linkMan: '',
					detail: [],
					popHD: false, //弹窗隐藏，false默认隐藏
					msgResult: '', //驳回理由
					applicant: '' // 入库单编号
				}
			},
			computed: {
				statusName: function() {
					switch (parseInt(this.status)) {
						case 0:
							bottomBtns.className = "examine-bottom-bar"
							return '待审批';
							break;
						case 1:
							return '通过';
							break;
						case 2:
							return '驳回';
							break;
						case 3:
							return '完成';
							break;
						case 4:
							return '取消';
							break;
						default:
							bottomBtns.className = "examine-bottom-bar hidden"
							break;
					}
				},
			},
			methods: {
					// 通过点击方法
				btnOk: function() {
					plus.nativeUI.showWaiting()
					w.model.post('hzapp/germplasm/operation_storehouse_checkin.do', {
						checkinListId: this.checkId,
						action: '1',
						message: '通过',
					}, function(data) {
						mui.toast(data.message, {
							type: 'div',
							duration: 'long'
						});
						plus.nativeUI.closeWaiting()

						if (data.code === 1) {
							mui.fire(plus.webview.getWebviewById('/html/data/examine-index.html'), 'refresh')
							if (data.code === 1) {
								setTimeout(() => {
									plus.webview.currentWebview().close()
								}, 1500);
							}
						}

					}, function() {
						plus.nativeUI.closeWaiting()
					})
				},
				btnNo: function() {
					// 拒绝点击方法
					// mask.style.display = "block";
					this.popHD = true;
				},
				submitCancel: function() {
					// mask.style.display = "none";
					this.popHD = false;
				},
				submitOk: function() {
					// 提交驳回意见
					if (!this.msgResult) {
						mui.toast("请输入意见", {
							type: 'div',
							duration: 'long'
						});
						return false;
					}

					plus.nativeUI.showWaiting()
					w.model.post('hzapp/germplasm/operation_storehouse_checkin.do', {
						checkinListId: this.checkId,
						action: '2',
						message: this.msgResult,
					}, function(data) {
						// mask.style.display = "none";
						vm.popHD = false;
						mui.toast(data.message, {
							type: 'div',
							duration: 'long'
						});
						this.msgResult = " "

						plus.nativeUI.closeWaiting()
						mui.fire(plus.webview.getWebviewById('/html/data/examine-index.html'), 'refresh')
						if (data.code === 1) {
							setTimeout(() => {
								plus.webview.currentWebview().close()
							}, 1500);
						}
					}, function(error) {
						mui.toast(error.message, {
							type: 'div',
							duration: 'long'
						});
						plus.nativeUI.closeWaiting();
					})
				},
			}

		});
		mui('#btnNo')[0].addEventListener('tap', function() {
			vm.btnNo();
		})
		mui('#btnOk')[0].addEventListener('tap', function() {
			vm.btnOk();
		})
		mui.plusReady(function() {
			const self = plus.webview.currentWebview();
			const checkId = self.checkId;
			vm.checkId = self.checkId;
			getStorageDetail(); //入库申请详情

			//入库申请详情
			function getStorageDetail() {
				plus.nativeUI.showWaiting();
				w.model.post('hzapp/germplasm/load_storehouse_checkin_log.do', {
					checkin_list_id: checkId
				}, function(data) {
					vm.storehouseName = data.storehouseName;
					vm.applicant = data.applicant;
					vm.remark = data.remark;
					vm.message = data.message;
					vm.telephone = data.telephone;
					vm.linkMan = data.linkMan;
					vm.status = data.status;
					vm.approvalMessage = data.approvalMessage;
					vm.detail = data.data;
					plus.nativeUI.closeWaiting();
				}, function(error) {
					mui.toast(error.message, {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.closeWaiting();
				})
			};

		})

	})
})(mui, window, document, $)
