(function(mui, w, document, $) {
	mui.ready(function() {
		mui.init();

		var vm = new Vue({
			el: "#content",
			data: function() {
				return {
					active: 0,
					search_value: '',
					search_value1: '',
				}
			},
			methods: {
				// 搜索
				search() {
					switch (this.active) {
						case 0:
							if (this.search_value == "") {
								plus.nativeUI.toast("请输入编号", {
									duration: "short", // 持续3.5s，short---2s
								});
								return false;
							}
							getStorageList(this.search_value); //获取入库审批单

							break;
						case 1:
							if (this.search_value1 == "") {
								plus.nativeUI.toast("请输入编号", {
									duration: "short", // 持续3.5s，short---2s
								});
								return false;
							}
							getDeliverList(this.search_value1); //获取出库审批单
							break;
						default:
							break;
					}
				},
			}
		});

// 修改激活状态
		function changeActive() {
			mui('.normal-tab-title').on('tap', '.normal-tab-title-item', function() {
				vm.active = $(this).data('idx');
				if ($(this).data('idx') == 0) {
					vm.search_value1 = ""; // 清空文本框
					getStorageList(); //获取入库审批单
				} else {

					vm.search_value = ""; // 清空文本框
					getDeliverList(); //获取出库审批单

				}
			});
		};

		//获取入库审批单
		function getStorageList(search_value) {
			plus.nativeUI.showWaiting()
			let params = {
				isApproval: true
			};
			if (search_value) {
				params['searchValue'] = search_value;
			} else {
				params = {
					isApproval: true
				};
			}
			w.model.post('hzapp/germplasm/load_storehouse_checkin_list.do', params, function(data) {
				if (!data.success) {
					plus.nativeUI.closeWaiting()
					plus.nativeUI.toast(data.message, {
						duration: "short", // 持续3.5s，short---2s
					});
					return false;
				}
				let res = data.data;
				let html = '';
				for (let htmlKey in res) {
					html +=
						`<a class="quality-item" data-checkid='${res[htmlKey].checkinListId}'>
                                <div class="top-part">
                                    <div class="left-part">
                                        <img src="../../images/order.png">
                                        <span>入库单编号：${res[htmlKey].applicant}</span>
                                    </div>
                                    <div class="right-part">
                                        <span class="status-label ${showStatus(res[htmlKey].statusCode)}">
                                           ${res[htmlKey].status}
                                        </span>
                                    </div>
                                </div>
                                <div class="bottom-part">
                                    <div>
                                        入库仓库：  ${res[htmlKey].storehouseName}
                                    </div>
                                    <div>
                                        材料数目：${res[htmlKey].materialRefCount}
                                    </div>
                                    <div>
                                        申请人：${res[htmlKey].approver}
                                    </div>
                                    <div>
                                        申请日期：${res[htmlKey].applyDate}
                                    </div>
                                </div>
                            </a>`;
				}
				plus.nativeUI.closeWaiting()
				$('#storageList').html(html);
			}, function() {
				plus.nativeUI.closeWaiting()
			})
		};

		//获取出库审批单
		function getDeliverList(search_value) {
			plus.nativeUI.showWaiting()
			let params = {
				isApproval: true
			};
			if (search_value) {
				params['searchValue'] = search_value;
			} else {
				params = {
					isApproval: true
				};
			}
			w.model.post('hzapp/germplasm/load_storehouse_checkout_list.do', params, function(data) {
				if (!data.success) {
					plus.nativeUI.closeWaiting()
					plus.nativeUI.toast(data.message, {
						duration: "long", // 持续3.5s，short---2s
					});
					return false;
				}
				let res = data.data;
				let html = '';
				for (let htmlKey in res) {
					html +=
						`<a class="quality-item" data-checkid='${res[htmlKey].checkoutListId}'>
			                    <div class="top-part">
			                        <div class="left-part">
			                            <img src="../../images/order.png">
			                            <span>出库单编号：${res[htmlKey].applicant}</span>
			                        </div>
			                        <div class="right-part">
			                            <span class="status-label ${showStatus(res[htmlKey].statusCode)}">
			                               ${res[htmlKey].status}
			                            </span>
			                        </div>
			                    </div>
			                    <div class="bottom-part">
			                        <div>
			                            入库仓库：  ${res[htmlKey].storehouseName}
			                        </div>
			                        <div>
			                            材料数目：${res[htmlKey].materialRefCount}
			                        </div>
			                        <div>
			                            申请人：${res[htmlKey].approver}
			                        </div>
			                        <div>
			                            申请日期：${res[htmlKey].applyDate}
			                        </div>
			                    </div>
			                </a>`;
				}
				plus.nativeUI.closeWaiting()
				$('#deliverList').html(html);
			}, function() {
				plus.nativeUI.closeWaiting()
			})
		};

		//状态展示
		function showStatus(statusCode) {
			switch (parseInt(statusCode)) {
				case 0:
					return 'label-orange-color';
					break;
				case 1:
					return 'label-green-color';
					break;
				case 2:
					return 'label-red-color';
					break;
				case 3:
					return 'label-gray-color';
					break;
				case 4:
					return 'label-red-color';
					break;
				default:
					break;
			}
		};

		mui.plusReady(function() {
			getStorageList(); //获取入库审批单
			changeActive();
			mui('#storageList').on('tap', 'a', function() {
				mui.openWindow({
					url: 'examine-in-detail.html',
					id: 'examine-in-detail.html',
					extras: {
						checkId: $(this).data('checkid')
					}
				})
			});

			mui('#deliverList').on('tap', 'a', function() {
				mui.openWindow({
					url: 'examine-out-detail.html',
					id: 'examine-out-detail.html',
					extras: {
						checkOutId: $(this).data('checkid')
					}
				})
			});

			window.addEventListener('refresh', function(event) {
				getStorageList();
				getDeliverList();
			})
		})

	})
})(mui, window, document, $)
