(function(mui, w, document, $) {
	mui.init();
	mui.ready(function() {
		var vm = new Vue({
			el: "#content",
			data: function() {
				return {
					checkOutId: '',
					storehouseName: '',
					remark: '',
					status: '',
					approvalMessage: '',
					telephone: '',
					linkMan: '',
					detail: [],
					popHD: false, //弹窗隐藏，false默认隐藏
					msgResult: '', //驳回理由
					applicant: '' // 出库单编号
				}
			},
			computed: {
				statusName: function() {
					switch (parseInt(this.status)) {
						case 0:
							bottomBtns.className = "examine-bottom-bar"
							return '待审批';
							break;
						case 1:
							return '通过';
							break;
						case 2:
							return '驳回';
							break;
						case 3:
							return '完成';
							break;
						case 4:
							return '取消';
							break;
						default:
							bottomBtns.className = "examine-bottom-bar hidden"
							break;
					}
				},
			},
			methods: {
				an() {
					mui.fire(plus.webview.getWebviewById('/html/data/examine-index.html'), 'refresh')
					setTimeout(() => {
						plus.webview.currentWebview().close()
					}, 1500);
				},
				btnOk: function() {
					// 通过点击方法
					plus.nativeUI.showWaiting()
					w.model.post('hzapp/germplasm/operation_storehouse_checkout.do', {
						checkoutListId: this.checkOutId,
						action: '1',
						message: '通过',
					}, function(data) {
						mui.toast(data.message, {
							type: 'div',
							duration: 'long'
						});
						this.msgResult = " ";
						plus.nativeUI.closeWaiting()
						if (data.code === 1) {
							mui.fire(plus.webview.getWebviewById('/html/data/examine-index.html'), 'refresh')
							setTimeout(() => {
								plus.webview.currentWebview().close()
							}, 1500);
						}
					}, function() {
						plus.nativeUI.closeWaiting()
					})
				},
				btnNo: function() {
					// 拒绝点击方法
					mask.style.display = "block";
					this.popHD = true;
				},
				// 关闭取消弹窗
				submitCancel: function() {
					mask.style.display = "none";
					this.popHD = false;
				},
				submitOk: function() {
					// 提交驳回意见
					if (!this.msgResult) {
						mui.toast("请输入意见", {
							type: 'div',
							duration: 'long'
						});
						return false;
					}
					mask.style.display = "none";
					this.popHD = false;
					plus.nativeUI.showWaiting()
					w.model.post('hzapp/germplasm/operation_storehouse_checkout.do', {
						checkoutListId: this.checkOutId,
						action: '2',
						message: this.msgResult,
					}, function(data) {
						mui.toast(data.message, {
							type: 'div',
							duration: 'long'
						});
						this.msgResult = "";
						plus.nativeUI.closeWaiting()
						if (data.code === 1) {
							mui.fire(plus.webview.getWebviewById('/html/data/examine-index.html'), 'refresh')
							setTimeout(() => {
								plus.webview.currentWebview().close()
							}, 1500);
						}
					}, function() {
						plus.nativeUI.closeWaiting()
					})
				},
			}

		});
		mui('#btnNo')[0].addEventListener('tap', function() {
			vm.btnNo();
		})
		mui('#btnOk')[0].addEventListener('tap', function() {
			vm.btnOk();
		})
		mui.plusReady(function() {
			const self = plus.webview.currentWebview();
			const checkOutId = self.checkOutId;
			vm.checkOutId = self.checkOutId;
			getStorageDetail(); //出库申请详情

			//出库申请详情
			function getStorageDetail() {
				plus.nativeUI.showWaiting()
				w.model.post('hzapp/germplasm/load_storehouse_checkout_log.do', {
					checkout_list_id: checkOutId
				}, function(data) {
					vm.storehouseName = data.storehouseName;
					vm.applicant = data.applicant;
					vm.remark = data.remark;
					vm.approvalMessage = data.approvalMessage;
					vm.telephone = data.telephone;
					vm.linkMan = data.linkMan;
					vm.status = data.status;
					vm.detail = data.data;
					plus.nativeUI.closeWaiting()
				}, function() {
					plus.nativeUI.closeWaiting()
				})
			};

		})

	})
})(mui, window, document, $)
