// 常量
const LIST_MIDDLE_MATERIALS = 1
const LIST_HIGH_YIELD = 2
const LIST_RESISTANCE = 3
// 字段对应关系字典
const dict = [
	{
		label: '田间编码',
		value: 'fieldCode',
		permission: [LIST_MIDDLE_MATERIALS]
	},
	{
		label: '项目编码',
		value: 'projectCode',
		permission: []
	},
	{
		label: '扫描类型',
		value: 'scanType',
		permission: []
	},
	{
		label: '材料名称',
		value: 'germplasmName',
		permission: []
	},
	{
		label: '播种期',
		value: 'seedingTiime',
		permission: [LIST_MIDDLE_MATERIALS, LIST_HIGH_YIELD, LIST_RESISTANCE]
	},
	{
		label: '移栽期',
		value: 'transplantingTime',
		permission: [LIST_HIGH_YIELD, LIST_RESISTANCE]
	},
	{
		label: '抽穗期',
		value: 'headingTime',
		permission: [LIST_HIGH_YIELD]
	},
	{
		label: '插值规格',
		value: 'plantingSpecification',
		permission: [LIST_HIGH_YIELD, LIST_RESISTANCE]
	},
	{
		label: '基本苗',
		value: 'basicSeedling',
		permission: [LIST_HIGH_YIELD]
	},
	{
		label: '最高苗',
		value: 'highestSeedling',
		permission: [LIST_HIGH_YIELD]
	},
	{
		label: '种植地点',
		value: 'plantingPlace',
		permission: [LIST_MIDDLE_MATERIALS, LIST_HIGH_YIELD, LIST_RESISTANCE]
	},
	{
		label: '种植经纬度',
		value: 'plantingSpace',
		permission: [LIST_MIDDLE_MATERIALS, LIST_HIGH_YIELD, LIST_RESISTANCE]
	},
	{
		label: '种植海拔',
		value: 'plantingAltitude',
		permission: [LIST_MIDDLE_MATERIALS, LIST_HIGH_YIELD, LIST_RESISTANCE]
	},
	{
		label: '恢复系',
		value: 'restorer',
		permission: [LIST_HIGH_YIELD, LIST_RESISTANCE]
	},
	{
		label: '不育系',
		value: 'sterile',
		permission: [LIST_HIGH_YIELD, LIST_RESISTANCE]
	},
	{
		label: '恢复系系谱',
		value: 'restorerPedigree',
		permission: [LIST_HIGH_YIELD, LIST_RESISTANCE]
	},
	{
		label: '恢复系携带抗性基因',
		value: 'restorerResistanceGene',
		permission: [LIST_HIGH_YIELD, LIST_RESISTANCE]
	},
	{
		label: '接种时间',
		value: 'inoculabilityTime',
		permission: [LIST_RESISTANCE]
	},
	{
		label: '接种菌株',
		value: 'inoculabilityStrains',
		permission: [LIST_RESISTANCE]
	},
	{
		label: '目标性状',
		value: 'targetTraits',
		permission: [LIST_MIDDLE_MATERIALS]
	},
	{
		label: '抗性目标基因数量',
		value: 'resistanceGenesNumber',
		permission: [LIST_MIDDLE_MATERIALS]
	},
	{
		label: '材料/背景信息描述',
		value: 'backgroundInfo',
		permission: [LIST_MIDDLE_MATERIALS]
	},
	{
		label: '最后更新人',
		value: 'lastCommitUserid',
		permission: []
	},
	{
		label: '最后更新时间',
		value: 'lastCommitTime',
		permission: []
	}
]
var self = null

function extractData(data, dict, listType) {
	return dict.filter(item => {
		return item.permission.indexOf(listType) != -1
	}).map(item => {
		return {
			key: item.label,
			value: data[item.value]
		}
	})
}

var vm = new Vue({
	el: '#content',
	data: {
		title: '',
		listType: 0,
		data: null,
		mainInfo: [
			{
				label: "播种期",
				value: '2020/5/22'
			},
			{
				label: "目标性状",
				value: '抗稻瘟病'
			},
			{
				label: "抗性目标基因数量",
				value: '1'
			}
		]
	},
	methods: {
		getGermplasmInfo(fieldCode) {
			var self = this
			window.model.post('hzapp/germplasm/getScanInfo.do', { fieldCode: fieldCode }, function(res) {
				// console.log('success1321!!!' + JSON.stringify(res))
				// console.log(typeof(res))
				const data = res.data
				const fieldCode = data.fieldCode
				const listType = data.scanType
				switch (data.scanType) {
					case LIST_MIDDLE_MATERIALS:
						self.title = data.fieldCode
						break
					default:
						self.title = data.germplasmName
				}
				self.fieldCode = fieldCode
				self.listType = listType
				//self.data = extractData(data, dict, listType)
				self.data = res.data
			}, function(xhr, type, errorThrown) {
				console.log('xhr')
				console.log(JSON.stringify(xhr))
			})
		}
	}
})

mui.plusReady(function() {
	// 获取从扫描页面获得的编码
	self = plus.webview.currentWebview();
	// 根据编码请求数据
	vm.getGermplasmInfo(self.fieldCode)
})