mui.init({
	beforeback: function() {

		// var list = plus.webview.getWebviewById('/html/data/manage-quality.html');　　　　
		//refresh是A页面自定义事件
		// mui.fire(list, 'refresh');
		//返回true,继续页面关闭逻辑
		return true;
	},
	gestureConfig: {
		longtap: true, //默认为false-------长按事件
	}
})
var vm = new Vue({
	el: "#content",
	data() {
		return {
			// 分组页面
			selectList: [{
				name: "基本信息",
			
			}, {
				name: "性状信息"
			}, {
				name: "图片信息",
			}],
			active: 0,
			germplasmTraitList: [],
			
			baseUrl: '',
			fromPath: '',
			cropId: null,
			germplasmId: null,
			imageFiles: [], // 文件[{path:'',name:''}]
			imageFilesPath: [], // 纯图片路径
			germplasmForm: {
				// orgId: 1, // TODO:机构ID
				cropId: '', //作物ID
				germplasmName: '', //种质名称
				germplasmNickName: '', //种质别名
				germplasmCode: '', // 种质编码 ,系统生成
				// germplasmId: '', //种质ID
				germplasmTypeCode: '', //种质类型
				breedPedigree: '', //世代
				gene: '', //基因
				performance: '', //特性
				protectionLevelCode: '', //保护级别
				corporation: '', //引种单位
				corporationTime: '', //引种时间（YYYY-MM-DD HH:mm:ss）
				source: '', //来源地
				fieldId: '', //杂交编码
				strainTrackingNo: '', //组合编号
				materialTypeCode: '' //材料类型
			},
			germplasmType: {
				text: '',
				picker: {}
			},
			materialType: {
				text: '',
				picker: {}
			},
			protectionLevel: {
				text: '',
				picker: {}
			},
			germplasmTrait: [],
			dateTimePicker: null
		}
	},
	methods: {
		// 修改激活状态
		changeActive: function(index) {
			this.active = index;
		},
		
		// 切换种质
		changeGermplasmType() {
			common.picker.changePicker(this, 'germplasmType', (selectedItem) => {
				this.germplasmForm.germplasmTypeCode = selectedItem[0].value
			})
		},
		// 切换类型
		changeMaterialType() {
			common.picker.changePicker(this, 'materialType', (selectedItem) => {
				this.germplasmForm.materialTypeCode = selectedItem[0].value
			})
		},
		// 切换级别
		changeProtectionLevel() {
			common.picker.changePicker(this, 'protectionLevel', (selectedItem) => {
				this.germplasmForm.protectionLevelCode = selectedItem[0].value
			})
		},
		// 展示日期选择弹窗
		showDateTimePick() {
			if (!this.dateTimePicker) {
				this.dateTimePicker = new mui.DtPicker({
					type: 'date'
				})
			}
			this.dateTimePicker.show((rs) => {
				this.germplasmForm.corporationTime = rs.value
			})
		},
		// 展示图片来源弹窗
		handleUploadImage() {
			var bts = [{
				title: "拍照"
			}, {
				title: "从相册选择"
			}]
			var self = this
			window.plus.nativeUI.actionSheet({
					cancel: "取消",
					buttons: bts
				},
				function(e) {
					if (e.index == 1) {
						self.getImage()
					} else if (e.index == 2) {
						self.galleryImgs()
					}
				}
			)
		},
		//拍照  
		getImage() {
			var self = this
			var cmr = window.plus.camera.getCamera()
			cmr.captureImage(function(p) {
				window.plus.io.resolveLocalFileSystemURL(p, function(entry) {
					var localurl = entry.toLocalURL()
					//               self.imageFilesPath.push({localurl)

					vm.getGermplasmDetail();
					entry.file(function(file) {
						self.imageFiles.push(file)
					})
					var dstname = "_downloads/" + Math.random().toString(16).substring(2) + 'germplasm.jpg' //设置压缩后图片的路径  
					self.compressImage(localurl, dstname)
				})
			})
		},
		// 从相册中选择图片  
		galleryImgs() {
			var self = this
			window.plus.gallery.pick(function(e) {
				console.log("选择了" + e.files.length + "个图片");
				for (var i = 0; i < e.files.length; i++) {
					if (i < 9) {
						self.imageFilesPath.push(e.files[i])
						var dstname = "_downloads/" + Math.random().toString(16).substring(2) + 'germplasm.jpg' //设置压缩后图片的路径  
						
						// ios直接上传
						if (plus.os.name === 'iOS') {
							console.log('a')
							self.iosUpload(e.files[i], dstname)
						} else {
							self.compressImage(e.files[i], dstname)
						}
					}
				}
			}, function(e) {
				console.log("取消选择图片");
			}, {
				filter: "image",
				multiple: true
			});
		},

		//压缩图片，这个比较变态的方法，无法return  
		compressImage(src, dstname) {
			var self = this
			//var dstname="_downloads/"+getUid()+".jpg";  
			window.plus.zip.compressImage({
					src: src,
					dst: dstname,
					overwrite: true,
					quality: 20,
					rotate: 0
				},
				function(e) {
					var reader = new plus.io.FileReader(); // 构建文件对象  
					reader.readAsDataURL(e.target) // 添加文件（此处安卓可以直接添加文件路径，而IOS则需要文件对象）  
					reader.onloadend = function(e) { // 文件加载 完成后的事件回调  

						var file = (function(path, name) {
							var arr = path.split(','),
								mime = arr[0].match(/:(.*?);/)[1],
								bstr = atob(arr[1]),
								n = bstr.length,
								u8arr = new Uint8Array(n);
							while (n--) {
								u8arr[n] = bstr.charCodeAt(n);
							}
							return new File([u8arr], name, {
								type: mime
							});
						})(e.target.result, dstname);
						self.upload(file)
						// self.imageFiles.push(file)
					}
				},
				function(error) {
					console.log(error)
				});
		},
		// 上传文件  
		upload(file) {
			var self = this
			var wt = window.plus.nativeUI.showWaiting('上传中...')
			var formData = new FormData()
			formData.append('files', file)
			if (mui.os.ios) {
				
			} else {
				window.model.upload('hzapp/germplasm/images_upload.do', '&germplasmId=' + this.germplasmId, formData, function(res) {
					if (res.code === 1) {
						vm.getGermplasmDetail();
						self.imageFiles.push(res.data[0])
					}
					wt.close(); //关闭等待提示按钮
				})
			}
			
		},
		iosUpload(filePath, fileName) {
			const formData = [
				{
					/* key: 'germplasmId',
					value: this.germplasmId */
				}
			]
			const registerFiles = [
				{
					key: 'files',
					name: fileName,
					path: filePath
				}
			]
			// 发送请求
			var wt = window.plus.nativeUI.showWaiting('上传中...')
			window.model.iOSFileForm('hzapp/germplasm/images_upload.do?germplasmId='+this.germplasmId, registerFiles, formData, function(response) {
				mui.toast(response.message, {
					type: 'div'
				})
				wt.close(); //关闭等待提示按钮
			}, function(xhr) {
				wt.close(); //关闭等待提示按钮
			})
		},
		// 获取数据
		getGermplasmDetail() {
			if (!this.germplasmId) return
			var self = this
			window.model.post('hzapp/germplasm/load_germplasm_data.do', {
				germplasm_id: self.germplasmId
			}, function(res) {
				if (res.code !== 1 || !res.germplasmData || !res.germplasmData.length) return

				let result = res.germplasmData[0]
				self.germplasmTrait = res.germplasmTrait;
				
				let traitList = []
				res.germplasmTrait.forEach(list => {
					list.items.forEach(item => {
						// item.traitValue = item.traitValue + ' ' + item.unit
						traitList.push(item)
					})
				})
				self.germplasmTraitList = traitList
				
				self.germplasmForm = {
					// orgId: 1, // TODO:机构ID
					germplasmId: result.germplasmId,
					germplasmCode: result.germplasmCode,
					germplasmName: result.germplasmName,
					germplasmNickName: result.germplasmNickName,
					source: result.source,
					corporation: result.corporation,
					corporationTime: result.corporationTime, // .substring(0, result.corporationTime.indexOf(':00')),
					performance: result.performance,
					gene: result.gene,
					fieldId: result.fieldId,
					materialTypeCode: result.materialTypeCode,
					protectionLevelCode: result.protectionLevelCode,
					// germplasmTypeCode: result.germplasmType,
					germplasmTypeCode: result.germplasmTypeCode,
					breedPedigree: result.breedPedigree,
					breedPlantNumbexr: result.breedPlantNumbexr,
					strainTrackingNo: result.strainTrackingNo
				}
				self.germplasmType.text = result.germplasmType
				self.materialType.text = result.materialType
				self.protectionLevel.text = result.protectionLevel
			}, function(err) {})
			window.model.post('hzapp/germplasm/get_images.do', {
				germplasmId: self.germplasmId
			}, function(res) {
				if (res.data || res.data.length) {

					self.imageFilesPath = res.data.map(x => {
						x.url = window.model.imgUrl() + x.url
						x.thumbnailUrl = window.model.imgUrl() + x.thumbnailUrl
						return {
							url: x.url,
							thumbnailUrl: x.thumbnailUrl,
							mapId: x.mapId,
							germplasmId: x.germplasmId,
							name: x.name
						}
					})
				}
			}, function(err) {})


		},
		// 初始化数据展示
		initData() {
			var self = this
			window.model.post('hzapp/germplasm/getGermplasmBaseData.do', {
				cropId: self.cropId
			}, function(res) {
				let germplasmTypeList = res.germplasmTypeList || [] // 种质类型
				let materialTypeList = res.materialTypeList || [] // 材料类型
				let protectionLevelList = res.protectionLevelList || [] // 保护级别

				if (res.germplasmTypeList.length > 0) {
					germplasmTypeList = germplasmTypeList.map(x => {
						return {
							value: x.referenceCode,
							text: x.referenceName
						}
					})
				}
				if (res.materialTypeList.length > 0) {
					materialTypeList = materialTypeList.map(x => {
						return {
							value: x.referenceCode,
							text: x.referenceName
						}
					})
				}
				if (res.protectionLevelList.length > 0) {
					protectionLevelList = protectionLevelList.map(x => {
						return {
							value: x.referenceCode,
							text: x.referenceName
						}
					})
				}
				common.picker.initPicker(self, 'germplasmType', germplasmTypeList)
				common.picker.initPicker(self, 'materialType', materialTypeList)
				common.picker.initPicker(self, 'protectionLevel', protectionLevelList)
			}, function(err) {})
		},
		// 数据提交
		submitForm() {
			var self = this
			this.germplasmForm.cropId = this.cropId
			if (this.germplasmForm.corporationTime) {
				this.germplasmForm.corporationTime = this.germplasmForm.corporationTime + " 00:00:00"
			}

			if (!vm.germplasmForm.germplasmName) {
				mui.toast('请输入种质名称', {
					type: 'div',
					duration: 'long'
				});
				return;
			}
			if (!vm.protectionLevel.text) {
				mui.toast('请选择保护级别', {
					type: 'div',
					duration: 'long'
				});
				return;
			}
			if (!vm.germplasmType.text) {
				mui.toast('请选择种质类型', {
					type: 'div',
					duration: 'long'
				});
				return;
			}
			if (!vm.materialType.text) {
				mui.toast('请选择材料类型', {
					type: 'div',
					duration: 'long'
				});
				return;
			}
			plus.nativeUI.showWaiting();
			window.model.postAboutRAW('hzapp/germplasm/update_germplasm_data.do', this.germplasmForm, function(data) {
				switch (data.code) {
					case 1:
						mui.toast('成功', {
							type: 'div',
							duration: 'long'
						});
						//self.getGermplasmDetail()
						plus.nativeUI.closeWaiting();
						setTimeout(() => {
							mui.back();
							// 						   mui.openWindow({
							// 								url: '/html/data/manage-quality.html',
							// 								id: '/html/data/manage-quality.html',
							// 							})
						}, 1000);

						break;
					default:
						mui.toast(data.message, {
							type: 'div',
							duration: 'long'
						});
						plus.nativeUI.closeWaiting();
						break;
				}
			}, function(err) {
				mui.toast(err.message, {
					type: 'div',
					duration: 'long'
				});
				plus.nativeUI.closeWaiting();
			})
		},
		// uploadImage: function(trait, file) {
		//     var filename = trait.test_id + '_'
		//     filename += trait.test_point_id + '_'
		//     filename += trait.group_code + '_'
		//     filename += trait.data_seq + '_' // data_seq
		//     filename += trait.trait_id + '_'
		//     filename += trait.random_id + '_'
		//     filename += new Date().getTime()
		//     var formData = new FormData()
		//     formData.append('file', file);
		//     formData.append('filename', filename)
		//     formData.append('random_id', trait.random_id)
		//     window.model.upload('hzapp/fieldtest/save_test_trait_image.do', formData, function(data) {
		//         console.log('保存结果', data)
		//         mui.toast('保存成功',, {type: 'div'} {
		//             duration: 'short',
		//             type: 'div'
		//         });
		//     })
		// },

		//删除种质数据
		deleteData() {
			var btnArray = ['否', '是'];
			mui.confirm('确认是否删除本条数据？', '确认', btnArray, function(e) {
				if (e.index == 1) {
					plus.nativeUI.showWaiting();
					window.model.post('hzapp/germplasm/remove_germplasm_data.do', {
						germplasm_id: vm.germplasmId
					}, function(data) {
						switch (data.code) {
							case 1:
								mui.toast('成功', {
									type: 'div',
									duration: 'long'
								});
								plus.nativeUI.closeWaiting();
								setTimeout(() => {
									mui.openWindow({
										url: '/html/data/manage-quality.html',
										id: '/html/data/manage-quality.html',
									})
								}, 1000);
								break;
							default:
								mui.toast(data.message, {
									type: 'div',
									duration: 'long'
								});
								plus.nativeUI.closeWaiting();
								break;
						}
					}, function(error) {})
				}
			})
		},

	},
	mounted() {}
})

// 事件监听
mui('#submitForm')[0].addEventListener('tap', function(e) {
	vm.submitForm();
})

mui.plusReady(function() {
	var self = plus.webview.currentWebview()
	vm.germplasmId = self.germplasmId;
	vm.cropId = self.cropId;
	vm.fromPath = self.fromPath;
	// 图片的baseUrl
	let baseUrl = window.model.urlHandle('hzapp/germplasm/showImage.do')
	baseUrl += '&image_path='
	vm.baseUrl = baseUrl
	
	vm.initData();
	vm.getGermplasmDetail();
	mui.previewImage();
	setTimeout(function() {
		mui("#picture-box").on('longtap', "img", function(e) {
			let self = this;
			let selfData = this.dataset;
			let germplasmId = selfData.germplasmid;
			let mapid = selfData.mapid;
			mui.confirm('确认删除图片么？', '提示', ['确定', '取消'], function(e) {
				if (e.index == 0) {
					if (!germplasmId && !mapid) {
						self.parentElement.remove()
					} else {
						window.model.post('hzapp/germplasm/imageDelete.do', {
							germplasmId: germplasmId,
							mapId: mapid,
						}, function(data) {
							if (data.code === 1) {
								vm.getGermplasmDetail();
								// self.removeChild(self)
							}
						}, function() {

						})
					}

				}
			}, 'div')
		});
	}, 0)
})
