mui.init()
var vm = new Vue({
	el: "#content",
	data() {
		return {
			currentCrop: null,
			visibleFilter: false,
			statisticData: [],
			cropList: [],
			search_value: '',
			totailOption: {
				title: {
					textStyle: {
						color: '#858585',
						fontSize: '12'
					}
				},
				backgroundColor: "#FFF",
				xAxis: {
					show: false,
					type: 'category',
					data: ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10'],
					axisLabel: {
						show: false
					},
					axisTick: {
						interval: 0
					}
				},
				yAxis: {
					show: false,
					type: 'value'
				},
				grid: {
					top: 30,
					bottom: 20
				},
				series: [{
					data: [],
					type: 'bar',
					barMinHeight: 2,
					barWidth: '50%',
					itemStyle: {
						normal: {
							color: new echarts.graphic.LinearGradient(
								0, 0, 0, 1,
								[{
										offset: 0,
										color: '#00b572'
									},
									{
										offset: 1,
										color: '#02d65e'
									}
								]
							)
						}
					}
				}]
			},
			yearOption: {
				backgroundColor: "#FFF",
				title: {
					textStyle: {
						color: '#858585',
						fontSize: '12'
					}
				},
				grid: {
					top: 30,
					bottom: 20
				},
				xAxis: {
					show: false,
					type: 'category',
					data: ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12'],
					axisLabel: {
						show: false
					},
					axisTick: {
						interval: 0
					}
				},
				yAxis: {
					type: 'value',
					show: false
				},
				series: [{
					data: [],
					type: 'bar',
					barMinHeight: 2,
					barWidth: '50%',
					itemStyle: {
						normal: {
							color: new echarts.graphic.LinearGradient(
								0, 0, 0, 1,
								[{
										offset: 0,
										color: '#f09819'
									},
									{
										offset: 1,
										color: '#ff5311'
									}
								]
							)
						}
					}
				}]
			},
			totalEchart: null,
			yearEchart: null
		}
	},
	methods: {
		// 返回
		goBack() {
			mui.back()
		},
		// 跳转详情
		linkToQuality(item) {
			mui.openWindow({
				url: '/html/data/manage-quality.html',
				id: '/html/data/manage-quality.html',
				extras: {
					cropId: this.currentCrop.id,
					searchValue: item.materialType, // item.materialName
					type: "2",
				}
			})
		},
		// 显示种质类型弹窗
		showCropPop() {
			mui('#topPopover').popover('show')
		},
		// 获取列表数据
		getCropList() {
			var self = this
			window.model.post('hzapp/germplasm/cropSelect.do', {}, function(res) {
				self.cropList = res.data;
				self.visibleFilter = true;
				let currentCrop = localStorage.getItem('manageIndexCurrentCrop');

				if (currentCrop) {
					self.currentCrop = JSON.parse(currentCrop);
					vm.getManageIndex();
				} else {
					mui('#topPopover').popover('show')
				}
			})
		},
		// 加载该种质类型的所有数据
		handleStatistic(item) {
			var self = this
			self.currentCrop = item
			localStorage.setItem('manageIndexCurrentCrop', JSON.stringify(item));
			vm.getManageIndex();
		},
		// 加载该种质类型的所有数据
		getManageIndex() {
			plus.nativeUI.showWaiting();
			var self = this;
			window.model.post('hzapp/germplasm/load_germplasm_statistics_data_list.do', {
				crop_id: self.currentCrop.id
			}, function(res) {
				mui('#topPopover').popover('hide')
				self.totailOption.title.text = '总计：' + res.total
				self.totailOption.series[0].data = res.per_year_number
				self.totalEchart.setOption(self.totailOption)

				self.yearOption.title.text = '本年度：' + res.current_year
				self.yearOption.series[0].data = res.month_map
				self.yearEchart.setOption(self.yearOption)
				self.statisticData = res.data
				plus.nativeUI.closeWaiting();
			}, function() {
				plus.nativeUI.closeWaiting();
			})
		},
		// 跳转种质列表
		searchBtn() {
			var self = this;
			mui.openWindow({
				url: '/html/data/manage-quality.html',
				id: '/html/data/manage-quality.html',
				extras: {
					cropId: this.currentCrop.id,
					searchValue: self.search_value,
					type: "1"
				}
			})
			self.search_value = "";
		},
	},
	mounted() {
		this.totalEchart = echarts.init(document.getElementById('echartTotal'));
		this.yearEchart = echarts.init(document.getElementById('echartYear'));
	}
})

mui.plusReady(function() {
	vm.getCropList()

	document.querySelector('body').addEventListener('tap', function(e) {
		var backdrop = document.querySelector('.mui-backdrop');
		e.preventDefault();
		e.stopPropagation();
	}, true)
})
