mui.init({
	pullRefresh: {
		swipeBack: false,
		container: "#refreshContainer",
		up: {
			height: 50, //可选.默认50.触发上拉加载拖动距离
			auto: true, //可选,默认false.自动上拉加载一次
			contentrefresh: "正在加载...", //可选，正在加载状态时，上拉加载控件上显示的标题内容
			contentnomore: '没有更多数据了', //可选，请求完毕若没有更多数据时显示的提醒内容；
			callback: pulluploading
		}
	}
});
var vm = new Vue({
	el: '#content',
	data() {
		return {
			loaded: false,
			cropId: null,
			searchValue: null,
			germplasmDatas: [],
			searchValueInit: '', //从前一页传过来的
			jumpType: '', // 跳转进入类型
			isInit: true, // 是否由其它页面进入
			pageNum: 1,
			pageSize: 10
		}
	},
	methods: {
		// 跳转详情
		linkToQualityDetail(item) {
			mui.openWindow({
				url: '/html/data/manage-detail.html',
				id: '/html/data/manage-detail.html',
				extras: {
					cropId: this.cropId,
					germplasmId: item.germplasmId || null, // item.materialName
					fromPath: 'dataDetail', //来源新增与详情同页
				}
			})
		},
		// 跳转详情新增页
		linkToQualityDetailAdd() {
			mui.openWindow({
				url: '/html/data/manage-detail.html',
				id: '/html/data/manage-detail.html',
				extras: {
					cropId: this.cropId,
					germplasmId: null, // item.materialName
					fromPath: 'newCreate', //来源新增与详情同页
				}
			})
		},
		// 加载搜素结果
		getGermplasmDataList() {
			/**
			 * 跳转进入类型
			 * @param {jumpType}  
			 * 等于1由搜索跳转进入 传search_value
			 * 等于2由列表点击跳转进入 传referenceCode 
			 * */
			plus.nativeUI.showWaiting();
			let param = {};

			if (this.isInit) {
				if (this.jumpType == 1) {
					param = {
						search_value: this.searchValueInit,
						cropId: this.cropId,
						pageNum: this.pageNum,
						pageSize: this.pageSize
					}
				} else if (this.jumpType == 2) {
					param = {
						referenceCode: this.searchValueInit,
						cropId: this.cropId,
						pageNum: this.pageNum,
						pageSize: this.pageSize
					}
				}
			} else {
				param = {
					search_value: this.searchValue,
					cropId: this.cropId,
					pageNum: this.pageNum,
					pageSize: this.pageSize
				}
			}
			window.model.post('hzapp/germplasm/load_germplasm_data_list.do', param, function(res) {
				switch (res.code) {
					case 1:
						vm.germplasmDatas = vm.germplasmDatas.concat(res.data.list);
						plus.nativeUI.closeWaiting();
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
						mui('#refreshContainer').pullRefresh().refresh(true);
						vm.pageNum++;
						break;
					default:
						plus.nativeUI.closeWaiting();
						mui.toast(res.message, {
							type: 'div',
							duration: 'long'
						});
						mui('#refreshContainer').pullRefresh().endPullupToRefresh(true);
						break;
				}
			}, function(err) {
				plus.nativeUI.closeWaiting();
				mui.toast(err.message, {
					type: 'div',
					duration: 'long'
				});
			})
		},
		// 搜索
		search() {
			this.pageNum = 1;
			this.isInit = false;
			this.getGermplasmDataList();
			this.germplasmDatas.length = 0;
		}
	}
})

function pulluploading() {
	// 下拉加载
	setTimeout(function() {
		vm.getGermplasmDataList()
	}, 0);
}
mui.plusReady(function() {
	var self = plus.webview.currentWebview()
	vm.cropId = self.cropId
	vm.searchValueInit = self.searchValue
	vm.jumpType = self.type;
})
