var vm = new Vue({
	el: "#content",
	data: function() {
		return {
			active: 0,
			categoryList: [],
			allList: [],
			rightList: [],
		}
	},
	methods: {
		// 修改激活元素
		changeActive(index) {
			this.active = index;
			this.rightList = this.allList[index].childCatalogList;
		},
		onJumpDetail(id, parentId, data_type, catalogView, catalogText) {
			// 跳转详情
			if (data_type == 2 && catalogView !== "") {
				mui.openWindow({
					url: 'pageBox.html',
					id: 'pageBox.html',
					extras: {
						catalogView: catalogView,
						catalogText: catalogText,
					}
				})
			} else {
				mui.openWindow({
					url: 'theme-list.html',
					id: 'theme-list.html',
					extras: {
						para: id,
						parentId: parentId, //暂时用于气象与地区不可点击到数据详情页
					}
				})
			}

		},
	},
})

// 获取目录
function getCatalogList() {
	plus.nativeUI.showWaiting();
	window.model.post('hzapp/datacenter/loadCatalogList.do', {}, function(data) {
		console.log(JSON.stringify(data));
		switch (data.code) {
			case 1:
				let res = data.data[0].childCatalogList;
				let leftArr = [];
				for (let i in res) {
					leftArr.push(res[i].catalogText);
				};
				vm.categoryList = leftArr;
				vm.allList = res;
				vm.rightList = res[0].childCatalogList;
				plus.nativeUI.closeWaiting();
				break;
			default:
				plus.nativeUI.closeWaiting();
				mui.toast(data.message, {
					type: 'div',
					duration: 'long'
				});
				break;
		}
	}, function(error) {
		plus.nativeUI.closeWaiting();
		mui.toast(error.message, {
			type: 'div',
			duration: 'long'
		});
	})
}

mui.plusReady(function() {
	getCatalogList(); // 获取目录
})
