mui.init();
mui.plusReady(function() {
	var vm = new Vue({
		el: "#content",
		data: function() {
			return {
				themeList: [],
				catalogName: '',
				crop_sn: '',
				fieldsList: '',
				first: '', //种子来源地
				second: '', //产地来源
				third: '', //水稻仅有	
			}
		},
		methods: {
			// 获取专题数据
			getThemeData: function() {
				plus.nativeUI.showWaiting();
				window.model.post('hzapp/datacenter/getCatelogView.do', {
					catalogId: catalogId,
					viewId: viewId
				}, function(data) {
					switch (data.code) {
						case 1:
							vm.catalogName = data.catalogName;
							vm.crop_sn = data.data.crop_sn;
							vm.themeList = data.data;
							vm.fieldsList = data.fields;

							vm.first = data.data.trial_add ? data.data.trial_add : '无';
							vm.second = data.data.trial_unit ? data.data.trial_unit : '无';
							vm.third = data.data.type_plant;
							plus.nativeUI.closeWaiting();
							break;
						default:
							mui.toast(data.message, {
								type: 'div',
								duration: 'long'
							});
							plus.nativeUI.closeWaiting();
							break;
					}
				}, function(error) {
					if (error.message) {
						mui.toast(error.message, {
							type: 'div',
							duration: 'long'
						});
					} else {
						mui.toast('未加载到数据！', {
							type: 'div',
							duration: 'long'
						})
					}
					plus.nativeUI.closeWaiting();
				})
			},
		},
	});

	const self = plus.webview.currentWebview(),
		catalogId = self.catalogId,
		viewId = self.viewId;
	vm.getThemeData(); // 获取专题数据
});
