// console.log('home utils')
// count数据字典
const countDictionary = [
	{
		id: 'countTraitTrait',
		countSectionName: 'offTraitCount',
		countModuleName: 'trait',
		sectionName: '品种测试',
		moduleName: '性状采集'
	},
	{
		id: 'countTraitField',
		countSectionName: 'offTraitCount',
		countModuleName: 'field',
		sectionName: '品种测试',
		moduleName: '田间管理'
	},
	{
		id: 'countTraitEval',
		countSectionName: 'offTraitCount',
		countModuleName: 'eval',
		sectionName: '品种测试',
		moduleName: '综合评价'
	},
	{
		id: 'countTrait',
		countSectionName: 'offBreedCount',
		countModuleName: 'trait',
		sectionName: '材料繁育',
		moduleName: '性状采集'
	},
	{
		id: 'countHybrid',
		countSectionName: 'offBreedCount',
		countModuleName: 'hybrid',
		sectionName: '材料繁育',
		moduleName: '杂交实施'
	},
	{
		id: 'countSeed',
		countSectionName: 'offBreedCount',
		countModuleName: 'seed',
		sectionName: '材料繁育',
		moduleName: '收种执行'
	},
	{
		id: 'countField',
		countSectionName: 'offBreedCount',
		countModuleName: 'field',
		sectionName: '材料繁育',
		moduleName: '田间管理'
	}
]

// 处理模块权限
function processPermission (totalModuleList, accessibleModuleList) {
	let accessibleSectionIDList = []
	let accessibleModuleIDList = []
	for (let accessibleSection of accessibleModuleList) {
		accessibleSectionIDList.push(accessibleSection.res_id)
		for (let accessibleModule of accessibleSection.modules) {
			accessibleModuleIDList.push(accessibleModule.res_id)
		}
	}
	let moduleList = totalModuleList.map(section => {
		section.accessPermission = accessibleSectionIDList.includes(section.res_id)
		section.modules.map(module => {
			module.accessPermission = accessibleModuleIDList.includes(module.res_id)
		})
		return section
	})
	return moduleList
}

// 生成Home Module的innerHTML
function HomeModuleHTML(moduleList, countData, countDictionary, moduleUrl) {
	this.generateSectionHTMLs = function(moduleList) {
		return moduleList.map(section => {
			return new SectionHTML(section, countData, countDictionary, moduleUrl)
		})
	}
	this.generateHTMLText = function(sectionHTMLs) {
		let startFragmentStr = '<div class="item home-module-item">'
		let contentStr = sectionHTMLs.map(sectionHTML => {
			return sectionHTML.generateHTMLText()
		}).join('')
		let endFragmentStr = '</div>'
		return startFragmentStr + contentStr + endFragmentStr
	}
	this.sectionHTMLs = this.generateSectionHTMLs(moduleList)
	this.HTMLText = this.generateHTMLText(this.sectionHTMLs)
}

// 生成section的innerHTML
function SectionHTML(section, countData, countDictionary, moduleUrl) {
	this.id = section.res_id
	this.name = section.res_text
	this.titleHTMLText = ''
	this.contentHTMLText = ''
	this.HTMLText = ''
	this.generateUploadButtonHTMLText = function() {
		let uploadButtonStr = ''
		if (this.name === '品种测试') {
			uploadButtonStr += '<div'
			uploadButtonStr += ' id="' + this.id + '"'
			uploadButtonStr += ' class="item-action yellow submit-variety">上传提交</div>'
		} else if (this.name === '材料繁育') {
			uploadButtonStr += '<div'
			uploadButtonStr += ' id="' + this.id + '"'
			uploadButtonStr += ' class="item-action green submit-breed">上传提交</div>'
		}
		return uploadButtonStr
	}
	this.generateTitleHTMLText = function() {
		let startFragmentStr = '<div class="item-title">'
		let sectionTitleStr = '<div class="item-name">' + this.name + '</div>'
		let uploadButtonStr = this.generateUploadButtonHTMLText()
		let endFragmentStr = '</div>'
		this.titleHTMLText = startFragmentStr + sectionTitleStr + uploadButtonStr + endFragmentStr
		return this.titleHTMLText
	}
	this.generateContentHTMLText = function() {
		let startFragmentStr = '<div class="item-content"><div class="item-content-wrap">'
		let contentStr = this.moduleHTMLs.map(moduleHTML => {
			return moduleHTML.HTMLText
		}).join('')
		let endFragmentStr = '</div></div>'
		this.titleHTMLText = startFragmentStr + contentStr + endFragmentStr
		return this.titleHTMLText
	}
	this.generateHTMLText = function() {
		let titleHTMLText = this.generateTitleHTMLText()
		let contentHTMLText = this.generateContentHTMLText()
		this.HTMLText = titleHTMLText + contentHTMLText
		return this.HTMLText
		
	}
	this.generateModuleHTMLs = function(modules) {
		return modules.map(module => {
			module.sectionName = this.name
			let moduleHTML = new ModuleHTML(module)
			moduleHTML.readCount(countData, countDictionary)
			moduleHTML.readResouceURL(moduleUrl)
			moduleHTML.generateHTMLText()
			return moduleHTML
		})
	}
	this.moduleHTMLs = this.generateModuleHTMLs(section.modules)
}

// 生成module的innerHTML
function ModuleHTML(module) {
	this.id = module.res_id
	this.name = module.res_text
	this.sectionName = module.sectionName
	this.href = ''
	this.icon = ''
	this.pathFrom = ''
	this.badgeID = ''
	this.count = 0
	this.HTMLText = ''
	this.classNames = ["item-sub", "dp-flex-col-xy-center"]
	this.style = "position: relative;"
	this.readResouceURL = function(moduleResouces) {
		const moduleKey = this.sectionName + '-' + this.name
		const moduleResouce = moduleResouces[moduleKey]
		this.href = moduleResouce.href
		this.icon = moduleResouce.icon
		this.pathFrom = moduleResouce.pathFrom
	}
	this.readCount = function(countData, countDictionary) {
		for (let item of countDictionary) {
			//if (item.id === this.badgeID) {
			if (item.sectionName === this.sectionName && item.moduleName === this.name) {
				this.count = countData[item.countSectionName][item.countModuleName]
			}
		}
	}
	this.generateHTMLText = function() {
		let startTagStr = ''
		let contentStr = ''
		let endTagStr = ''
		
		startTagStr += '<div'
		startTagStr += ' class=' + '"' + this.classNames.join(' ') + '"'
		startTagStr += ' style=' + '"' + this.style + '"'
		startTagStr += ' id=' + '"' + this.id + '"'
		startTagStr += ' target-href=' + '"' + this.href + '"'
		startTagStr += ' data-pathfrom="' + '"' + this.pathFrom || '' + '"'
		startTagStr += '>'
		
		if (this.count > 0) {
			contentStr += '<span class="mui-badge mui-badge-upload mui-badge-danger" id="countTrait" style="right: 10px;">' + this.count+ '</span>'
		}
		contentStr += '<img src="' + this.icon + '" class="item-sub-icon">'
		contentStr += '<p class="item-sub-name">' + this.name + '</p>'
		
		endTagStr += '</div>'
		
		this.HTMLText = startTagStr + contentStr + endTagStr
		return this.HTMLText
	}
}

// 生成离线模式的模块列表
function filterOfflineModuleList(moduleList) {
	const offlineSectionList = [
		'材料繁育',
		'品种测试'
	]
	return moduleList.filter(section => {
		return offlineSectionList.includes(section.res_text)
	}).map(section => {
		section.modules = section.modules.filter(module => {
			return module.res_mode === "OFFLINE"
		})
		return section
	})
}

// 新模块渲染方法
function renderModule2(moduleList) {
	const countData = {
		offBreedCount,
		offTraitCount
	}
	let homeModuleHTML = new HomeModuleHTML(moduleList, countData, countDictionary, moduleUrl)
	// console.log('h html txt: ' + homeModuleHTML.HTMLText)
	document.getElementById('modules').innerHTML = homeModuleHTML.HTMLText
}

// 权限判断
function hasPermission(moduleList, type, id) {
	let permission = {
		id,
		type,
		level: '',
		result: false
	}
	
	for (let section of moduleList) {
		if (section.res_id.toString() === id) {
			permission.level = 'section'
			if (type === 'access') {
				permission.result = section.accessPermission
			}
			return permission
		}
		for (let module of section.modules) {
			if (module.res_id.toString() === id) {
				permission.level = 'module'
				if (type === 'access') {
					permission.result = module.accessPermission
				}
				return permission
			}
		}
	}
	
	return permission
}