'use strict';
(function(w, mui) {
	let tempFlage = true;
	var model = {
		baseUrl: function() {
			// 获取服务器信息
			var server = localStorage.getItem('server')
			if (server) {
				server = JSON.parse(server)
				var baseUrl = `${server.protocol}://${server.ip}`
				if (server.port) {
					baseUrl += ':' + server.port + "/"
				}
				if (server.catalog && server.catalog !== "") {
					baseUrl += `${server.catalog}/`
				}
				return baseUrl
				// return "http://172.18.11.204:8080/bioplatform-dev/"
				// return "http://172.18.11.102:8080/bioplatform-dev/"
				// return "http://172.18.11.141:8080/bioplatform-dev/"
			} else {
				mui.openWindow('/html/user/login.html', '/html/user/login.html', {})
			}
		},
		imgUrl: function() {
			// 获取服务器信息
			var server = localStorage.getItem('server')
			if (server) {
				server = JSON.parse(server)
				var baseUrl = `${server.protocol}://${server.ip}`
				if (server.port) {
					baseUrl += ':' + server.port
				}
				return baseUrl
			}
		},
		toCamelCase(str) {
			return str.replace(/_(\w)/g, function($0, $1) {
				return $1.toUpperCase();
			})
		}
		// baseUrl: 'http://222.240.147.230:8081/bioplatform-qa/'
	};
	// 统一添加access
	model.urlHandle = function(url) {
		if (url.indexOf('hzappunlimit') !== -1 || url === 'oauth/token.do') {
			return this.baseUrl() + url
		} else {
			if (new Date().getTime() > parseInt(localStorage.getItem('expires'))) {
				mui.openWindow('/html/user/login.html', '/html/user/login.html', {})
			} else {
				let accessUrl = ''
				if (url.indexOf('?') !== -1) {
					accessUrl = '&access_token=' + localStorage.getItem('token')
				} else {
					accessUrl = '?access_token=' + localStorage.getItem('token')
				}
				return this.baseUrl() + url + accessUrl
			}
		}
	}
	// 验证token是否存在
	function overDutyToken() {
		if (localStorage.getItem("token") !== null) {
			mui.alert('授权信息已过期，请重新登录', '提示框', function() {
				mui.openWindow('/html/user/login.html', '/html/user/login.html', {})
				plus.nativeUI.closeWaiting();
			});
			return false
		}
		mui.openWindow('/html/user/login.html', '/html/user/login.html', {})
		return false // 过期了
	}

	// 通用post处理方法
	model.post = function(url, params, successCallback, errorCallback) {
		mui.ajax(this.urlHandle(url), {
			data: params,
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 30000, //超时时间设置为30秒；
			success: function(data) {
				if (data.error && data.error === 'invalid_token') overDutyToken();
				if (typeof successCallback === 'function') {
					successCallback(data)
				}
			},
			error: function(xhr, type, errorThrown) {
				if (type === 'timeout') {
					if (tempFlage) {
						mui.alert('连接超时', '提示框', function() {
							mui.openWindow('/html/user/login.html', '/html/user/login.html', {})
							plus.nativeUI.closeWaiting();
						});
						tempFlage = false;
					}
				}
				if (errorThrown === 'Unauthorized') {
					overDutyToken();
				}
				if (typeof errorCallback === 'function') {
					errorCallback(xhr, type, errorThrown)
				}
			}
		});
	}

	// 通用post处理方法请求为10秒
	model.postSenc10 = function(url, params, successCallback, errorCallback) {
		mui.ajax(this.urlHandle(url), {
			data: params,
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
				if (data.error && data.error === 'invalid_token') overDutyToken();
				if (typeof successCallback === 'function') {
					successCallback(data)
				}
			},
			error: function(xhr, type, errorThrown) {
				if (type === 'timeout') {
					if (tempFlage) {
						mui.alert('连接超时', '提示框', function() {
							mui.openWindow('/html/user/login.html', '/html/user/login.html', {})
							plus.nativeUI.closeWaiting();
						});
						tempFlage = false;
					}
				}
				if (errorThrown === 'Unauthorized') {
					overDutyToken();
				}
				if (typeof errorCallback === 'function') {
					errorCallback(xhr, type, errorThrown)
				}
			}
		});
	}

	// 通用post处理方法,raw格式提交
	model.postAboutRAW = function(url, params, successCallback, errorCallback) {
		mui.ajax(this.urlHandle(url), {
			data: JSON.stringify(params),
			contentType: 'application/json',
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 30000, //超时时间设置为30秒；
			success: function(data) {
				if (data.error && data.error === 'invalid_token') overDutyToken();
				if (typeof successCallback === 'function') {
					successCallback(data)
				}
			},
			error: function(xhr, type, errorThrown) {
				if (type === 'timeout') {
					if (tempFlage) {
						mui.alert('连接超时', '提示框', function() {
							mui.openWindow('/html/user/login.html', '/html/user/login.html', {})
							plus.nativeUI.closeWaiting();
						});
						tempFlage = false;
					}
				}
				if (errorThrown === 'Unauthorized') {
					overDutyToken();
				}
				if (typeof errorCallback === 'function') {
					errorCallback(xhr, type, errorThrown)
				}
			}
		});
	}
	// 通用UploadImage
	model.upload = function(url, query, params, successCallback, errorCallback) {
		url = this.urlHandle(url)
		if (query) {
			url += query
		}
		mui.ajax(url, {
			data: params,
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 0, //超时时间设置为30秒；
			processData: false,
			contentType: false,
			success: function(data) {
				if (data.error && data.error === 'invalid_token') overDutyToken();
				if (typeof successCallback === 'function') {
					successCallback(data)
				}
			},
			error: function(xhr, type, errorThrown) {
				if (typeof errorCallback === 'function') {
					errorCallback(xhr, type, errorThrown)
				}
			}
		});
	}

	// form表单上次, params需要为 new FormData
	model.form = function(url, params, successCallback, errorCallback) {
		mui.ajax(this.urlHandle(url), {
			data: params,
			// dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 0, //超时时间设置为30秒；
			processData: false,
			contentType: false,
			success: function(data) {
				if (data.error && data.error === 'invalid_token') overDutyToken();
				if (typeof successCallback === 'function') {
					successCallback(data)
				}
			},
			error: function(xhr, type, errorThrown) {
				if (typeof errorCallback === 'function') {
					errorCallback(xhr, type, errorThrown)
				}
			}
		});
	}
	
	model.iOSFileForm = function(url, files, params, successCallback, errorCallback) {
		var task = plus.uploader.createUpload(this.urlHandle(url), {
				method: "POST",
				blocksize: 204800,
				priority: 100
			},
			function(t, status) {
				// 上传完成
				if (status == 200) {
					if (typeof successCallback === 'function') {
						successCallback(JSON.parse(t.responseText))
					}
				} else {
					if (typeof errorCallback === 'function') {
						errorCallback(t)
					}
				}
			}
		);
		if (files && files.length > 0) {
			for (let file of files) {
				task.addFile(file.path, {
					key: file.key,
					name: file.name
				})
			}
		}
		if (params && params.length > 0) {
			for (let param of params) {
				task.addData(param.key, param.value)
			}
		}
		
		task.start();
	}

	// 文件上传
	model.file = function(url, file, success, fail) {
		var task = plus.uploader.createUpload(window.model.urlHandle(url), {
				method: "POST",
				blocksize: 204800,
				priority: 100
			},
			function(t, status) {
				// 上传完成
				if (status == 200) {
					if (typeof success === 'function') {
						success(t, status)
					}
				} else {
					if (typeof fail === 'function') {
						fail(t, status)
					}
				}
			}
		);
		task.addFile(file.fullPath, {
			key: 'file',
			name: file.name
		});
		task.start();
	}

	// 通用post处理方法同步
	model.postSyn = function(url, params, successCallback, errorCallback) {
		mui.ajax(this.urlHandle(url), {
			data: params,
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 30000, //超时时间设置为30秒；
			async: false,
			success: function(data) {
				if (data.error && data.error === 'invalid_token') overDutyToken();
				if (typeof successCallback === 'function') {
					successCallback(data)
				}
			},
			error: function(xhr, type, errorThrown) {
				if (typeof errorCallback === 'function') {
					errorCallback(xhr, type, errorThrown)
				}
			}
		});
	}

	// 没有育种计划的展示
	model.planErr = function(msg) {
		plus.nativeUI.closeWaiting()
		mui.confirm(msg, '系统提示', ['确认'], function(e) {
			mui.openWindow({
				url: "index.html",
				id: "index.html",
			});
		}, 'div')
		return;
	}
	w.model = model;
})(window, mui);
