var recorder = null
let OS_NAME = ''
const PUBLIC_DOCMENTS_URL = ''

mui.plusReady(function() {
	recordManager.OS_NAME = plus.os.name
	OS_NAME = plus.os.name
	console.log(OS_NAME)
	console.log('11111: ' + recordManager.OS_NAME)
	// 获取_documents/目录地址
	if (recordManager.OS_NAME === 'iOS') {
		recordManager.PUBLIC_DOCMENTS_URL = plus.io.convertLocalFileSystemURL('_documents/audio/') + '/'
	} else if (recordManager.OS_NAME === 'Android') {
		recordManager.PUBLIC_DOCMENTS_URL = plus.io.convertLocalFileSystemURL('_documents/audio/')
	} else {
		// 内部报告错误信息
		console.log('在使用plus.os.name获取操作系统信息时，出现了“iOS”和“Android”之外的系统名，' + OS_NAME)
		// 外部向客户提示信息
		alert('APP暂时仅支持IOS和Android')
	}
})

var recordManager = {
	url: '',
	PUBLIC_DOCMENTS_URL: '',
	recordFilename: '',
	setPublicDocumentsURL: function () {
		if (OS_NAME === 'iOS') {
			this.PUBLIC_DOCMENTS_URL = plus.io.convertLocalFileSystemURL('_documents/audio/') + '/'
		} else if (OS_NAME === 'Android') {
			this.PUBLIC_DOCMENTS_URL = plus.io.convertLocalFileSystemURL('_documents/audio/')
		} else {
			// 内部报告错误信息
			console.log('在使用plus.os.name获取操作系统信息时，出现了“iOS”和“Android”之外的系统名，' + OS_NAME)
			// 外部向客户提示信息
			alert('APP暂时仅支持IOS和Android')
		}
	},
	start: function (setting, successCallback, failCallback) {
		this.url = setting.url
		var self = this
		if (recorder == null) {
			// console.log("Device not ready!")
			recorder = plus.audio.getRecorder();
		}
		this.recordFilename = setting.filenamePreffix + (new Date()).valueOf()
		const baseURL = "_documents/audio/"
		if (OS_NAME === 'iOS') {
			recorder.record( {filename: baseURL + this.recordFilename, format: 'wav', samplerate: 16000}, function () {
				console.log("Audio record success!")
				self.upload(successCallback, failCallback)
			}, function ( e ) {
				console.log("Audio record failed: " + e.message)
			});
		} else if (OS_NAME === 'Android') {
			recorder.record( {filename: baseURL + this.recordFilename, format: 'amr', samplerate: 16000}, function () {
				console.log("Audio record success!")
				self.upload(successCallback, failCallback)
			}, function ( e ) {
				console.log("Audio record failed: " + e.message)
			});
		} else {
			// 内部报告错误信息
			console.log('在使用plus.os.name获取操作系统信息时，出现了“iOS”和“Android”之外的系统名，' + OS_NAME)
			// 外部向客户提示信息
			alert('APP暂时仅支持IOS和Android')
		}
	},
	stop: function() {
		console.log('stop recording')
		recorder.stop();
	},
	upload: function(successCallback, failCallback) {
		console.log('start upload')
		var self = this
		let filePath = ''
		let file = {}
		if (this.OS_NAME === 'iOS') {
			file.fullPath = "file://" + this.PUBLIC_DOCMENTS_URL + this.recordFilename;
			file.name = this.recordFilename + '.wav'
		} else if (this.OS_NAME === 'Android') {
			file.fullPath = "file://" + this.PUBLIC_DOCMENTS_URL + this.recordFilename + '.amr';
			file.name = this.recordFilename + '.amr'
		} else {
			// 内部报告错误信息
			console.log('在使用plus.os.name获取操作系统信息时，出现了“iOS”和“Android”之外的系统名，' + OS_NAME)
			// 外部向客户提示信息
			alert('APP暂时仅支持IOS和Android')
		}
		
		window.model.file(this.url, file, (t, status) => {
			console.log('upload success')
			console.log(JSON.stringify(t.responseText))
			successCallback(JSON.parse(t.responseText))
		}, () => {
			console.log('upload fail')
		})
	}
}