(function(mui, w, document) {
	mui.init();
	var vm = new Vue({
		el: '#content',
		data: function() {
			return {
				OS_NAME: '',
				isIOS: false,
				isAndroid: false,
				register_type: '1',
				protocol: '1',
				user: {
					login_name: '',
					password: '',
					password_conf: '',
					company_name: '',
					user_name: '',
					mobile: '',
					valide_code: '',
					email: '',
					module: [],
					register_type: '1',
				},
				company: {
					login_name: '',
					password: '',
					password_conf: '',
					company_name: '',
					user_name: '',
					mobile: '',
					valide_code: '',
					email: '',
					orgFile: '',
					sourceFile: '',
					module: [],
					register_type: '2'
				},
				imageFiles: [], // 文件[{path:'',name:''}]
				imageFilesPath: [], // 纯图片路径
				tempSource: '', //营业执照/机构
				sourceFile: null,
				orgFile: null,
				registerFiles: [
					{
						key: 'sourceFile',
						path: '',
						name: ''
					},
					{
						key: 'orgFile',
						path: '',
						name: ''
					}
				]
			}
		},
		methods: {
			// 当出现手机系统不是iOS或安卓时的情况
			systemError() {
				console.log('手机系统不是iOS或Android，代码执行出错')
				mui.toast('请使用iOS或者Android系统手机', {
					type: 'div'
				})
			},
			// 个人获取注册码
			getUserValidate: function() {
				if (!vm.user.mobile) {
					mui.toast('请先输入手机号', {
						type: 'div'
					})
				}
				window.model.post('hzappunlimit/getIdentifycode.do', {
					mobile: vm.user.mobile
				}, function(data) {
					if (data.message && data.message.length > 10) {
						mui.toast(data.message, {
							type: 'div'
						})
					}
				}, function() {

				})
			},
			// 公司获取注册码
			getCompanyValide() {
				if (!vm.company.mobile) {
					mui.toast('请先输入手机号', {
						type: 'div'
					})
				}
				window.model.post('hzappunlimit/getIdentifycode.do', {
					mobile: vm.company.mobile
				}, function(data) {
					mui.toast(data.message, {
						type: 'div'
					});
				}, function(err) {
					mui.toast(err.message, {
						type: 'div'
					});
				})
			},
			// 进入协议
			goProtocol() {
				mui.openWindow({
					url: '/html/user/register-protocol.html',
					id: '/html/user/register-protocol.html',
					extras: {}
				})
			},
			// 展示图片来源弹窗
			handleUploadImage(type) {
				vm.tempSource = type; //sourceFile-营业执照 orgFile-机构代码
				var bts = [{
					title: "拍照"
				}, {
					title: "从相册选择"
				}]
				var self = this
				window.plus.nativeUI.actionSheet({
						cancel: "取消",
						buttons: bts
					},
					function(e) {
						if (e.index == 1) {
							self.getImage()
						} else if (e.index == 2) {
							self.galleryImgs()
						}
					}
				)
			},
			setImageInfo(filePath) {
				const tempSourceKey = vm.tempSource
				this.imageFilesPath.push(filePath)
				if (this.isIOS) {
					const fileName = window.util.commonFilePathProcessor.getFileName(filePath)
					const timestamp = new Date().getTime()
					vm.company[tempSourceKey] = filePath  // 这个是用来展示图片的地址
					vm.registerFiles.map(file => {
						if (file.key === tempSourceKey) {
							file.path = filePath
							file.name = timestamp + fileName
						}
					})
				} else if (this.isAndroid) {
					var dstname = "_downloads/" + Math.random().toString(16).substring(2) + 'type.jpg' //设置压缩后图片的路径
					this.compressImage(filePath, dstname)
				} else {
					this.systemError()
				}
			},
			//拍照  
			getImage() {
				var self = this
				var cmr = window.plus.camera.getCamera()
				cmr.captureImage(function(p) {
					window.plus.io.resolveLocalFileSystemURL(p, function(entry) {
						var localurl = entry.toLocalURL()
						// self.imageFilesPath.push(localurl)
						// entry.file(function(file) {
						// 	self.imageFiles.push(file)
						// })
						// var dstname = 'headpic.jpg' //设置压缩后图片的路径  
						// self.compressImage(localurl, dstname)
						self.setImageInfo(localurl)
					})
				})
			},
			// 从相册中选择图片  
			galleryImgs() {
				var self = this
				window.plus.gallery.pick(function(e) {
					// console.log("选择了" + e.files.length + "个图片");
					for (var i = 0; i < e.files.length; i++) {
						if (i < 1) {
							// self.imageFilesPath.push(e.files[i])
							// var dstname = "_downloads/" + Math.random().toString(16).substring(2) + 'type.jpg' //设置压缩后图片的路径  
							// self.compressImage(e.files[i], dstname)
							self.setImageInfo(e.files[i])
						}
					}
				}, function(e) {
					console.log("取消选择图片");
				}, {
					filter: "image",
					multiple: true
				});
			},

			//压缩图片，这个比较变态的方法，无法return  
			compressImage(src, dstname) {
				var self = this
				//var dstname="_downloads/"+getUid()+".jpg";  
				window.plus.zip.compressImage({
						src: src,
						dst: dstname,
						overwrite: true,
						quality: 20,
						rotate: 0
					},
					function(e) {
						var reader = new plus.io.FileReader(); // 构建文件对象  
						reader.readAsDataURL(e.target) // 添加文件（此处安卓可以直接添加文件路径，而IOS则需要文件对象）  
						// 						if(mui.os.ios){
						// 							reader.readAsDataURL(e.target.replace('file://',''))
						// 						}else{
						// 							reader.readAsDataURL(e.target) // 添加文件（此处安卓可以直接添加文件路径，而IOS则需要文件对象）  
						// 						}
						reader.onloadend = function(e) { // 文件加载 完成后的事件回调  
							if (vm.tempSource === 'sourceFile') {
								vm.company.sourceFile = (function(path, name) {
									var arr = path.split(','),
										mime = arr[0].match(/:(.*?);/)[1],
										bstr = atob(arr[1]),
										n = bstr.length,
										u8arr = new Uint8Array(n);
									while (n--) {
										u8arr[n] = bstr.charCodeAt(n);
									}
									return new File([u8arr], name, {
										type: mime
									});
								})(e.target.result, dstname);
								vm.sourceFile = vm.company.sourceFile;
							} else {
								vm.company.orgFile = (function(path, name) {
									var arr = path.split(','),
										mime = arr[0].match(/:(.*?);/)[1],
										bstr = atob(arr[1]),
										n = bstr.length,
										u8arr = new Uint8Array(n);
									while (n--) {
										u8arr[n] = bstr.charCodeAt(n);
									}
									return new File([u8arr], name, {
										type: mime
									});
								})(e.target.result, dstname);
								vm.orgFile = vm.company.orgFile;
							}

							self.viewPic()
							// self.imageFiles.push(file)
						}
					},
					function(error) {
						console.log(error)
					});
			},

			//预览图片
			viewPic() {
				var r = new FileReader();
				if (vm.tempSource === 'sourceFile') {
					var f = vm.company.sourceFile;
				} else {
					var f = vm.company.orgFile;
				}
				r.readAsDataURL(f);
				r.onload = function(e) {
					if (vm.tempSource === 'sourceFile') {
						vm.company.sourceFile = r.result;
					} else {
						vm.company.orgFile = r.result;
					}
				};
			},
			//图片浏览
			previewImg() {
				var imgeGroup = mui.previewImage();
				/**  
				 * 第一个参数是分组中图片的索引，从0开始；  
				 * 第二个参数是分组的索引；  
				 */
				// imgeGroup.open(0, 1); 

			},

			//未输入的提示
			alertPop(message) {
				mui.alert(message, '提示框', function() {});
			},
		},
		created() {
			document.addEventListener('plusready', function() {
				vm.OS_NAME = plus.os.name
				vm.isIOS = vm.OS_NAME === 'iOS'
				vm.isAndroid = vm.OS_NAME === 'Android'
			})
		}
	})
	
	// iOS注册事件
	function handleIOSRegister(formData, files) {
		const REGISTER_KEYS = [
			'register_type',
			'login_name',
			'password',
			'company_name',
			'user_name',
			'mobile',
			'valide_code',
			'email',
			'module',
		]
		// 生成表单数据
		const registerFormData = REGISTER_KEYS.map(key => {
			let value = formData[key]
			if (value instanceof Array) {
				value = value.join(',')
			}
			return {
				key,
				value
			}
		})
		// 生成文件数据
		const registerFiles = files.filter(item => {
			return item.name !== ''
		})
		// 发送请求
		window.model.iOSFileForm('hzappunlimit/register.do', registerFiles, registerFormData, function(response) {
			mui.toast(response.message, {
				type: 'div'
			})
			plus.nativeUI.closeWaiting();
			if (response.code === 1) {
				setTimeout(() => {
					mui.back()
				}, 2000);
			}
		}, function(xhr) {
			plus.nativeUI.closeWaiting();
			mui.confirm('注册失败', '注册失败', ['取消', '确认'], function(e) {
				if (e.index == 1) {}
			}, 'div')
		})
	}
	
	// Android注册事件
	function handleAndroidRegister(params) {
		plus.nativeUI.showWaiting();
		window.model.form('hzappunlimit/register.do', params, function(data) {
			mui.toast(data.message, {
				type: 'div'
			})
			plus.nativeUI.closeWaiting();
			if (data.code === 1) {
				setTimeout(() => {
					mui.back()
				}, 2000);
			}
		}, function() {
			//mui.toast('注册失败！')
			plus.nativeUI.closeWaiting();
			mui.confirm('注册失败', '注册失败', ['取消', '确认'], function(e) {
				if (e.index == 1) {}
			}, 'div')
		})
	}

	// 注册弹窗
	document.getElementById("alertBtn").addEventListener('tap', function() {
		var params = new FormData()
		// 校验
		
		params.set('register_type', '1')
		params.set('login_name', vm.user.login_name)
		params.set('password', vm.user.password)
		params.set('mobile', vm.user.mobile)
		params.set('valide_code', vm.user.valide_code)
		params.set('email', vm.user.email)
		params.set('module', vm.user.module.join(','))
		
		if (mui('#sliderSegmentedControl .mui-active span')[0].innerHTML === '个人注册') {
			if (!vm.user.login_name) {
				//mui.toast('请输入登录账号')
				vm.alertPop('请输入登录账号');
				return
			}
			if (!vm.user.password) {
				//mui.toast('请输入登录密码')
				vm.alertPop('请输入登录密码');
				return
			}
			if (!vm.user.password_conf) {
				//mui.toast('请输入确认密码')
				vm.alertPop('请输入确认密码');
				return
			}
			if (vm.user.password !== vm.user.password_conf) {
				//mui.toast('登录密码和确认密码不一致！')
				vm.alertPop('登录密码和确认密码不一致');
				return
			}
			if (!vm.user.user_name) {
				//mui.toast('请输入确认密码')
				vm.alertPop('请输入真实名称');
				return
			}
			if (!vm.user.mobile) {
				//mui.toast('请输入手机号')
				vm.alertPop('请输入手机号');
				return
			}
			if (vm.user.mobile) {
				var reg = /^[1][3456789][0-9]{9}$/;
				if (!(vm.user.mobile.length == 11 && reg.test(vm.user.mobile))) {
					//mui.toast('请正确输入手机号')
					vm.alertPop('请正确输入手机号');
					return
				}
			}
			if (!vm.user.email) {
				//mui.toast('请输入手机号')
				vm.alertPop('请输入邮箱地址');
				return
			}
			if (vm.user.email) {
				var reg = /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
				if (!reg.test(vm.user.email)) {
					//mui.toast('请正确输入邮箱地址')
					vm.alertPop('请正确输入邮箱地址');
					return
				}
			}
			if (!vm.user.valide_code) {
				//mui.toast('请输入验证码')
				vm.alertPop('请输入验证码');
				return
			}
			if (!vm.user.module) {
				//mui.toast('请选择试用系统')
				vm.alertPop('请选择试用系统');
				return
			}
			if (!vm.protocol) {
				//mui.toast('未同意协议')
				vm.alertPop('未同意协议');
				return
			}
			params.set('register_type', '1')
			params.set('login_name', vm.user.login_name)
			params.set('user_name', vm.user.user_name)
			params.set('password', vm.user.password)
			params.set('mobile', vm.user.mobile)
			params.set('valide_code', vm.user.valide_code)
			params.set('email', vm.user.email)
			params.set('module', vm.user.module.join(','))
		} else {
			params.register_type = '2'
			if (!vm.company.login_name) {
				//mui.toast('请输入登录账号')
				vm.alertPop('请输入登录账号');
				return
			}
			if (!vm.company.password) {
				//mui.toast('请输入登录密码')
				vm.alertPop('请输入登录密码');
				return
			}
			if (!vm.company.password_conf) {
				//mui.toast('请输入确认密码')
				vm.alertPop('请输入确认密码');
				return
			}
			if (vm.company.password !== vm.company.password_conf) {
				//mui.toast('登录密码和确认密码不一致！')
				vm.alertPop('登录密码和确认密码不一致！');
				return
			}
			if (!vm.company.company_name) {
				//mui.toast('请输入公司名称')
				vm.alertPop('请输入公司名称');
				return
			}
			if (!vm.company.user_name) {
				//mui.toast('请输入真实姓名')
				vm.alertPop('请输入真实姓名');
				return
			}
			if (!vm.company.mobile) {
				//mui.toast('请输入手机号') 
				vm.alertPop('请输入手机号');
				return
			}
			if (vm.company.mobile) {
				var reg = /^[1][3456789][0-9]{9}$/;
				if (!(vm.company.mobile.length == 11 && reg.test(vm.company.mobile))) {
					//mui.toast('请正确输入手机号')
					vm.alertPop('请正确输入手机号');
					return
				}
			}
			if (!vm.user.email) {
				//mui.toast('请输入手机号')
				vm.alertPop('请输入邮箱地址');
				return
			}
			if (vm.company.email) {
				var reg = /^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
				if (!reg.test(vm.company.email)) {
					//mui.toast('请正确输入邮箱地址')
					vm.alertPop('请正确输入邮箱地址');
					return
				}
			}
			if (!vm.company.login_name) {
				//mui.toast('请输入验证码')
				vm.alertPop('请输入验证码');
				return
			}
			if (!vm.company.module) {
				//mui.toast('请选择试用系统')
				vm.alertPop('请选择试用系统');
				return
			}
			if (!vm.protocol) {
				//mui.toast('未同意协议')
				vm.alertPop('未同意协议');
				return
			}
			params.set('login_name', vm.company.login_name)
			params.set('password', vm.company.password)
			params.set('mobile', vm.company.mobile)
			params.set('valide_code', vm.company.valide_code)
			params.set('email', vm.company.email)
			params.set('company_name', vm.company.company_name)
			params.set('user_name', vm.company.user_name)
			params.set('module', vm.company.module.join(','))
			params.set('sourceFile', vm.sourceFile)
			params.set('orgFile', vm.orgFile)
			params.set('register_type', vm.company.register_type)
		}
		
		if (vm.isIOS) {
			const formData = mui('#sliderSegmentedControl .mui-active span')[0].innerHTML === '个人注册' ? vm.user : vm.company
			handleIOSRegister(formData, vm.registerFiles)
		} else if (vm.isAndroid) {
			handleAndroidRegister(params)
		} else {
			vm.systemError()
		}
	});

})(mui, window, document)
