_.templateSettings.interpolate = /{{([\s\S]+?)}}/g;
(function(mui, w, document, $) {
	mui.plusReady(function() {
		mui('.top-menu').on('tap', '#map', function() {
			mui.openWindow({
				url: 'map.html',
				id: 'map',
				extras: {

				}
			})
		})
		// 获取实验相关特性和性状分组
		var testPoint = {}

		function getTestFeature() {
			plus.nativeUI.showWaiting();
			w.model.post('hzapp/fieldtest/load_test_traits.do', {
				test_id: testPoint.test_id,
				org_id: testPoint.org_id,
				crop_id: testPoint.crop_id
			}, function(data) {
				let traitStr = ''
				for (let traitKey in data.data) {
					for (var i = 0; i < data.data[traitKey].length; i++) {
						var traitItem = data.data[traitKey][i]
						traitStr += '<div class="item" data-info=\'' + JSON.stringify(traitItem) + '\'>' + traitItem.trait_name + '</div>'
					}
				}

				document.getElementById('traitPoints').innerHTML = traitStr
				plus.nativeUI.closeWaiting();
			},function(error){
				mui.toast(error.message, {type: 'div', duration:'long'});
				plus.nativeUI.closeWaiting();
			})
		}

		getTestFeature()

		// 相关性状点击
		mui('#traitPoints').on('tap', '.item', function() {
			$(this).toggleClass('active')
		})


		// 筛选的性状列表
		var itemTemp = `
		<div class="main-item">
			<div class="item-hd" data-point=\'{{ info }}\'>{{ pointName }}:</div>
			<input type="text" class="item-bd">
			<div class="item-ft">
				<img src="../../images/camera.png" alt="拍摄图片" class="camera-icon">
				<img src="../../images/photo.png" alt="查看图片" class="photo-icon">
			</div>
		</div>
		`
		// 弹窗点击事件
		mui('#maskContainer').on('tap', '#maskBtn', function() {
			let selecteds = $('#traitPoints').children('.active')
			let traitStr = ''
			for (var i = 0; i < selecteds.length; i++) {
				var el = $(selecteds[i])
				var pointInfo = el.data('info')
				traitStr += _.template(itemTemp)({
					info: JSON.stringify(pointInfo),
					pointName: pointInfo.trait_name
				})
			}

			$('.main-container .main-list').html(traitStr)
			mui('#maskContainer')[0].classList.toggle('popup-show');
		})
	})
})(mui, window, document, $)