mui.init();
var offlineOpen = localStorage.getItem('offline')
var titleInterval = null
// 头部标题滚动
function scroll() {
	var info = document.getElementById('info');
	var div = info.getElementsByTagName('div')[0];
	var p = document.getElementsByTagName('p')[0];
	var p_w = p.offsetWidth;
	var div_w = info.offsetWidth;
	if (div_w > p_w) {
		return false;
	}
	div.innerHTML += div.innerHTML;

	titleInterval = setInterval(function() {
		if (p_w <= info.scrollLeft) {
			info.scrollLeft -= p_w;
		} else {
			info.scrollLeft++;
		}
	}, 30);
}
var vm = new Vue({
	el: "#content",
	data: function() {
		return {
			dataOption: '{"type":"date","beginYear":2000,"endYear":2200}', //日期类型
			testPoint: '',
			configList: {}, //排版配置
			defaultList: {}, //默认数据
			selectItem: { //下拉框
				text: '',
				picker: {}
			},
			key: '', //暂存下拉选择
			inputLengthObj: [], //限制输入长度的
		}
	},
	methods: {
		/*获取排版配置数据*/
		getFieldConfig() {
			if (offlineOpen === 'off') {
				plus.sqlite.selectSql({
					name: 'hz',
					sql: `select * from field_config where test_id = ${vm.testPoint.test_id} and test_point_id = ${vm.testPoint.test_point_id}`,
					success: function(e) {
						if (e.length >= 1) {
							vm.configList = JSON.parse(e[0].list)
							vm.getDefaultData(); //获取默认数据
						}
					}
				})
			} else {
				plus.nativeUI.showWaiting();
				window.model.post('hzapp/fieldtest/load_field_config.do', {
					test_id: this.testPoint.test_id,
					test_point_id: this.testPoint.test_point_id,
					//crop_id:this.testPoint.crop_id,
				}, function(res) {
					vm.configList = res.data;
					vm.getDefaultData(); //获取默认数据
					plus.nativeUI.closeWaiting();
				}, function(error) {
					mui.toast(error.message, {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.closeWaiting();
				})
			}
		},
		// 处理默认数据
		handleDefaultData(data) {
			if (data.length > 0) {
				vm.defaultList = data[0];
			} else {
				vm.configList.forEach((item, index, arr) => {
					item.modules.map((x, i, array) => {
						vm.defaultList[x.propertyName] = '';
					})
				});
				vm.defaultList = Object.assign({}, vm.defaultList, {
					test_id: vm.testPoint.test_id,
					test_point_id: vm.testPoint.test_point_id
				});
			}
		},
		/*获取默认数据*/
		getDefaultData() {
			if (offlineOpen === 'off') {
				plus.sqlite.selectSql({
					name: 'hz',
					sql: `select * from test_field_data where test_id = ${vm.testPoint.test_id} and test_point_id = ${vm.testPoint.test_point_id}`,
					success: function(e) {
						if (e.length > 0) {
							let ret = {}
							e.forEach(item => {
								ret[item.property_name] = item.value
							});
							vm.handleDefaultData([ret])
						} else {
							vm.handleDefaultData([])
						}
					},
					fail: function(e) {

					}
				})
			} else {
				plus.nativeUI.showWaiting();
				window.model.post('hzapp/fieldtest/load_field_data.do', {
					test_id: this.testPoint.test_id,
					test_point_id: this.testPoint.test_point_id,
					// 				test_id:539,
					// 				test_point_id:2554
				}, function(res) {
					vm.handleDefaultData(res.data)
					plus.nativeUI.closeWaiting();
				}, function(error) {
					mui.toast(error.message, {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.closeWaiting();
				})
			}
		},
		//下拉选择
		changePicker(selectList, key) {
			selectList = selectList.split(',');
			if (selectList.length > 0) {
				selectList = selectList.map(x => {
					return {
						value: x,
						text: x
					}
				});
			};
			common.picker.initPicker(vm, 'selectItem', selectList);
			common.picker.changePicker(vm, 'selectItem', (selectedItem) => {
				vm.defaultList[key] = selectedItem[0].value;
			})
		},
		//保存
		saveBtn() {
			let status = 1
			if (offlineOpen === 'off') {
				status = 0
			}
			for (const key in vm.defaultList) {
				if (vm.defaultList.hasOwnProperty(key)) {
					const propValue = vm.defaultList[key];
					if (['test_id', 'test_point_id'].indexOf(key) === -1 && propValue) {
						plus.sqlite.selectSql({
							name: 'hz',
							sql: `select * from test_field_data where test_id = ${vm.testPoint.test_id} and test_point_id = ${vm.testPoint.test_point_id} and property_name = '${key}'`,
							success: function(e) {
								if (e.length > 0) {
									plus.sqlite.executeSql({
										name: 'hz',
										sql: `update test_field_data set value = '${propValue}', status = ${status} where test_id = ${vm.testPoint.test_id} and test_point_id = ${vm.testPoint.test_point_id} and property_name = '${key}'`,
										success: function(e) {
											// mui.toast('保存成功!', {type: 'div'})
										}
									})
								} else {
									plus.sqlite.executeSql({
										name: 'hz',
										sql: `insert into test_field_data values(${vm.testPoint.test_id}, ${vm.testPoint.test_point_id}, '${key}', '${propValue}', 0, ${status}, '', '')`,
										success: function(e) {
											// mui.toast('保存成功!', {type: 'div'})
										}
									})
								}
							}
						})
					}
				}
			}
			if (offlineOpen === 'off') {
				mui.toast('保存成功！', {
					type: 'div'
				})
			}
			if (offlineOpen !== 'off') {
				plus.nativeUI.showWaiting();
				window.model.post('hzapp/fieldtest/save_field_data.do', {
					data: JSON.stringify(vm.defaultList),
				}, function(res) {
					plus.nativeUI.closeWaiting();
					mui.toast('保存成功', {
						type: 'div',
						duration: 'long'
					});
				}, function(error) {
					mui.toast(error.message, {
						type: 'div',
						duration: 'long'
					});
					plus.nativeUI.closeWaiting();
				})
			}
		},
		//选择日期
		selectData(key) {
			var _self = this;
			if (_self.picker) {
				_self.picker.show(function(rs) {
					vm.defaultList[key] = rs.text;
					_self.picker.dispose();
					_self.picker = null;
				});
			} else {
				var optionsJson = vm.dataOption || '{}';
				var options = JSON.parse(optionsJson);
				//var id = this.getAttribute('id');
				/*
				 * 首次显示时实例化组件
				 * 示例为了简洁，将 options 放在了按钮的 dom 上
				 * 也可以直接通过代码声明 optinos 用于实例化 DtPicker
				 */
				_self.picker = new mui.DtPicker(options);
				_self.picker.show(function(rs) {
					/*
					 * rs.value 拼合后的 value
					 * rs.text 拼合后的 text
					 * rs.y 年，可以通过 rs.y.vaue 和 rs.y.text 获取值和文本
					 * rs.m 月，用法同年
					 * rs.d 日，用法同年
					 * rs.h 时，用法同年
					 * rs.i 分（minutes 的第二个字母），用法同年
					 */
					vm.defaultList[key] = rs.text;
					/* 
					 * 返回 false 可以阻止选择框的关闭
					 * return false;
					 */
					/*
					 * 释放组件资源，释放后将将不能再操作组件
					 * 通常情况下，不需要示放组件，new DtPicker(options) 后，可以一直使用。
					 * 当前示例，因为内容较多，如不进行资原释放，在某些设备上会较慢。
					 * 所以每次用完便立即调用 dispose 进行释放，下次用时再创建新实例。
					 */
					_self.picker.dispose();
					_self.picker = null;
				});
			}
		},
	}
})

// 设置标题内容
var isSetTitle = false
// 设置标题
function setTitle(title) {
	if (!isSetTitle) {
		document.getElementById('testDot').innerHTML = title
		scroll();
		isSetTitle = true
	} else {
		[].forEach.call(document.getElementsByClassName('testDot'), function(item) {
			item.innerHTML = title
		})
	}
}
var fireHome = false
mui.plusReady(function() {
	plus.sqlite.openDatabase({
		name: 'hz',
		path: '_doc/huazhi.db',
		success: function(e) {},
		fail: function(e) {}
	})
	if (!fireHome) {
		getTestDotList()
	}
	fireHome = false
});
// 返回事件
mui.back = function() {
	let choose = plus.webview.getWebviewById('place-choose.html')
	if (choose) {
		choose.hide();
	}
	var offlineOpen = localStorage.getItem('offline')
	if (offlineOpen === 'off') {
		mui.fire(plus.webview.getWebviewById('html/main/home.html'), 'refreshOffline')
	}
	plus.webview.currentWebview().hide("auto", 300);
};
// 试验列表处理
function handleTestDotList(data) {
	if (data.length > 0) {
		testPointList = data
		let tp = localStorage.getItem('testPoint')
		let currentTestPoint = data[0]
		if (tp) {
			currentTestPoint = JSON.parse(tp)
		}
		setTitle(currentTestPoint.test_point_name + '-' + currentTestPoint.test_name)
		vm.testPoint = currentTestPoint;
		plus.nativeUI.closeWaiting()
		vm.getFieldConfig(); //获取排版配置数据
	} else {
		window.model.planErr('没有进行中的试验')
	}

}
//  获取试验测试点列表
function getTestDotList() {
	if (offlineOpen === 'off') {
		plus.sqlite.selectSql({
			name: 'hz',
			sql: `select * from test_testpoint_info`,
			success: function(e) {
				if (e.length > 0) {
					handleTestDotList(e)
				}
			}
		})
	} else {
		plus.nativeUI.showWaiting();
		window.model.post('hzapp/fieldtest/load_test_testpoint_info.do', {}, function(data) {
			handleTestDotList(data.data)
		}, function() {
			mui.toast('获取试验点列表失败', {
				type: 'div',
				duration: 'long'
			})
			plus.nativeUI.closeWaiting()
		})
	}
}

var isChooseOpen = false
window.addEventListener('refreshPage', function(event) {
	isChooseOpen = false
	vm.testPoint = JSON.parse(localStorage.getItem('testPoint'));
	setTitle(vm.testPoint.test_point_name + '-' + vm.testPoint.test_name)
	vm.getFieldConfig(); //获取排版配置数据
})
window.addEventListener('homeRefresh', function(event) {
	fireHome = true
	isChooseOpen = false
	offlineOpen = localStorage.getItem('offline')
	getTestDotList()
})
// 切换头部, 打开标题内容列表
mui('#titleWrap')[0].addEventListener('tap', function() {
	if (!isChooseOpen) {
		mui.openWindow({
			url: 'place-choose.html',
			id: 'place-choose.html',
			styles: {
				top: '49px',
				background: 'transparent',
			},
			extras: {
				testPointList: testPointList,
				currentTestPoint: vm.testPoint
				//自定义扩展参数，可以用来处理页面间传值
			},
			createNew: false, //是否重复创建同样id的webview，默认为false:不重复创建，直接显示
			show: {
				autoShow: true, //页面loaded事件发生后自动显示，默认为true
				aniShow: 'slide-in-top',
			}
		})
		isChooseOpen = true
	} else {
		let choose = plus.webview.getWebviewById('place-choose.html')
		if (choose.isVisible()) {
			choose.hide()
		} else {
			choose.show()
		}
	}
})
