let testPoint = JSON.parse(localStorage.getItem('testPoint'));
(function(mui, w, document, $) {
	// 标题滚动
	function scroll() {
		var info = document.getElementById('info');
		var div = info.getElementsByTagName('div')[0];
		var p = document.getElementsByTagName('p')[0];
		var p_w = p.offsetWidth;
		var div_w = info.offsetWidth;
		if (div_w > p_w) {
			return false;
		}
		div.innerHTML += div.innerHTML;

		titleInterval = setInterval(function() {
			if (p_w <= info.scrollLeft) {
				info.scrollLeft -= p_w;
			} else {
				info.scrollLeft++;
			}
		}, 30);
	}
	mui.ready(function() {
		mui.init({});
		var offlineOpen = localStorage.getItem('offline')

		//遍历
		const dealNodesContent = function(data) {
			let html = '';
			for (let htmlKey in data) {
				html += `<p>${data[htmlKey].content}</p>`;
			}
			return html;
		};

		/*获取实验手册*/
		const getManualInfo = function(testPoint) {
			if (offlineOpen === 'off') {
				plus.sqlite.selectSql({
					name: 'hz',
					sql: `select * from test_handbook where test_id = ${testPoint.test_id} and test_point_id = ${testPoint.test_point_id}`,
					success: function(e) {
						if (e.length === 1) {
							render(JSON.parse(e[0].list))
						} else {
							$('.content').html(
								'<div style="margin: auto; background-color: #fff; position: absolute; left: 0; top: 0; right: 0; bottom: 0; padding: 100px 0; text-align: center; color: #999;">暂无手册</div>'
							)
						}
					}
				})
			} else {
				plus.nativeUI.showWaiting();
				w.model.post('hzapp/fieldtest/load_test_handbook.do', {
					test_id: testPoint.test_id,
					test_point_id: testPoint.test_point_id
				}, function(data) {
					render(data.data)
					plus.nativeUI.closeWaiting();
				})
			}
		};

		function render(data) {
			if (data.content == null) {
				let html = `<p style="color:#e5e5e5;text-align:center;font-weight:500">暂无试验手册</p>`;
				$('.content').html(html);
				return false;
			}
			let html = `<h5>${data.content}</h5>`;
			for (let htmlKey in data.nodes) {
				html += `<h6>${data.nodes[htmlKey].content}</h6>
				${dealNodesContent(data.nodes[htmlKey].nodes)}`;
			}
			$('.content').html(html);
		}

		var isSetTitle = false

		function setTitle(title) {
			let titleNames = document.getElementsByClassName('title-txt-name')
			for (let i = 0; i < titleNames.length; i++) {
				const titleName = titleNames[i];
				titleName.innerHTML = title
			}
			if (!isSetTitle) {
				scroll();
				isSetTitle = true
			}
		}

		var fireHome = false
		mui.plusReady(function() {
			plus.sqlite.openDatabase({
				name: 'hz',
				path: '_doc/huazhi.db'
			})
			if (!fireHome) {
				getTestDotList()
			}
			fireHome = false
		});
		//  获取试验测试点列表
		function getTestDotList() {
			if (offlineOpen === 'off') {
				plus.sqlite.selectSql({
					name: 'hz',
					sql: `select * from test_testpoint_info`,
					success: function(e) {
						if (e.length > 0) {
							let data = e
							testPointList = data
							currentTestPoint = JSON.parse(localStorage.getItem('testPoint')) || data[0]
							setTitle(currentTestPoint.test_point_name + '-' + currentTestPoint.test_name)
							testPoint = currentTestPoint;
							plus.nativeUI.closeWaiting()
							getManualInfo(testPoint); //获取实验手册
						}
					}
				})
			} else {
				window.model.post('hzapp/fieldtest/load_test_testpoint_info.do', {}, function(data) {
					testPointList = data.data
					currentTestPoint = JSON.parse(localStorage.getItem('testPoint')) || data.data[0]
					if (testPointList.length > 0) {
						setTitle(currentTestPoint.test_point_name + '-' + currentTestPoint.test_name)
						testPoint = currentTestPoint;
						plus.nativeUI.closeWaiting()
						getManualInfo(testPoint); //获取实验手册
					} else {
						window.model.planErr('没有进行中的试验')
					}
				}, function() {
					mui.toast('获取试验点列表失败', {
						type: 'div',
						duration: 'long'
					})
					plus.nativeUI.closeWaiting()
				})
			}
		}

		var isChooseOpen = false
		window.addEventListener('refreshPage', function(event) {
			isChooseOpen = false
			var detail = event.detail;
			testPoint = detail
			currentTestPoint = testPoint
			setTitle(currentTestPoint.test_point_name + '-' + currentTestPoint.test_name);
			getManualInfo(testPoint); //获取实验手册
		})
		window.addEventListener('homeRefresh', function(event) {
			isChooseOpen = false
			fireHome = true
			offlineOpen = localStorage.getItem('offline')
			getTestDotList()
		})
		// 切换头部, 打开标题内容列表
		mui('#titleWrap')[0].addEventListener('tap', function() {
			if (!isChooseOpen) {
				mui.openWindow({
					url: 'place-choose.html',
					id: 'place-choose.html',
					styles: {
						top: '49px',
						background: 'transparent',
					},
					extras: {
						testPointList: testPointList,
						currentTestPoint: currentTestPoint
						//自定义扩展参数，可以用来处理页面间传值
					},
					createNew: false, //是否重复创建同样id的webview，默认为false:不重复创建，直接显示
					show: {
						autoShow: true, //页面loaded事件发生后自动显示，默认为true
						aniShow: 'slide-in-top',
					}
				})
				isChooseOpen = true
			} else {
				let choose = plus.webview.getWebviewById('place-choose.html')
				if (choose.isVisible()) {
					choose.hide()
				} else {
					choose.show()
				}
			}
		});
		mui.back = function() {
			// 返回事件
			let choose = plus.webview.getWebviewById('place-choose.html')
			if (choose) {
				choose.hide();
			}
			mui.fire(plus.webview.getWebviewById('html/main/home.html'), 'refreshOffline')
			plus.webview.currentWebview().hide("auto", 300);
		};

	})
})(mui, window, document, $)
