(function(mui, w, document) {
	//mui初始化
	mui.init();
	var offlineOpen = localStorage.getItem('offline')

	// 头部标题滚动
	function scroll() {
		var info = document.getElementById('info');
		var div = info.getElementsByTagName('div')[0];
		var p = document.getElementsByTagName('p')[0];
		var p_w = p.offsetWidth;
		var div_w = info.offsetWidth;
		if (div_w > p_w) {
			return false;
		}
		div.innerHTML += div.innerHTML;

		setInterval(function() {
			if (p_w <= info.scrollLeft) {
				info.scrollLeft -= p_w;
			} else {
				info.scrollLeft++;
			}
		}, 30);
	}

	var aniShow = {};

	// 设置标题内容
	var isSetTitle = false;

	function setTitle(title) {
		//document.getElementById('testDot').innerHTML = title;
		document.getElementsByClassName('testDot')[0].innerHTML = title;
		if (document.getElementsByClassName('testDot')[1]) {
			document.getElementsByClassName('testDot')[1].innerHTML = title;
		}

		if (!isSetTitle) {
			scroll();
			isSetTitle = true;
		}
	}

	mui.plusReady(function() {
		plus.sqlite.openDatabase({
			name: 'hz',
			path: '_doc/huazhi.db'
		})

		//  获取试验测试点列表
		var testPointList = [];
		var currentTestPoint = {};

		function getTestDotList() {
			if (offlineOpen === 'off') {
				plus.sqlite.selectSql({
					name: 'hz',
					sql: `select * from test_testpoint_info`,
					success: function(e) {
						if (e.length > 0) {
							let data = JSON.parse(e[0].list)
							testPointList = data;
							//综合评价,整个品种测试
							let evaluateTitle = localStorage.getItem('testPoint');
							if (evaluateTitle) {
								currentTestPoint = JSON.parse(evaluateTitle);
							} else {
								currentTestPoint = data[0];
							}
							setTitle(currentTestPoint.test_point_name + '-' + currentTestPoint.test_name);
						}
					}
				})
			} else {
				w.model.post('hzapp/fieldtest/load_test_testpoint_info.do', {}, function(data) {
					testPointList = data.data;
					//综合评价,整个品种测试
					let evaluateTitle = localStorage.getItem('testPoint');
					if (evaluateTitle) {
						currentTestPoint = JSON.parse(evaluateTitle);
					} else {
						currentTestPoint = data.data[0];
					}
					setTitle(currentTestPoint.test_point_name + '-' + currentTestPoint.test_name);
				}, function() {})
			}
		}
		getTestDotList();

		// 切换头部, 打开标题内容列表
		mui('#titleWrap')[0].addEventListener('tap', function() {
			mui.openWindow({
				url: 'place-choose.html',
				id: 'place-choose.html',
				styles: {
					top: '49px',
					background: 'transparent',
				},
				extras: {
					testPointList: testPointList
					//自定义扩展参数，可以用来处理页面间传值
				},
				createNew: false, //是否重复创建同样id的webview，默认为false:不重复创建，直接显示
				show: {
					autoShow: true, //页面loaded事件发生后自动显示，默认为true
					aniShow: 'slide-in-top',
				}
			})
		})

		window.addEventListener('refreshPage', function(event) {
			var detail = event.detail
			setTitle(detail.test_point_name + '-' + detail.test_name)
		})

	});


})(mui, window, document)
