var vm = new Vue({
	el: "#content",
	data: function() {
		return {
			breedPlan: null,
			imageList: []
		}
	},
	methods: {
		// 显示图片来源选择框
		handleUploadImage() {
			var bts = [{
				title: "拍照"
			}, {
				title: "从相册选择"
			}]
			var self = this
			window.plus.nativeUI.actionSheet({
					cancel: "取消",
					buttons: bts
				},
				function(e) {
					if (e.index == 1) {
						self.getImage()
					} else if (e.index == 2) {
						self.galleryImgs()
					}
				}
			)
		},
		//拍照  
		getImage() {
			var self = this
			var cmr = window.plus.camera.getCamera()
			cmr.captureImage(function(p) {
				window.plus.io.resolveLocalFileSystemURL(p, function(entry) {
					var localurl = entry.toLocalURL()
					self.imageList.push(localurl)
					var dstname = self.breedPlan.breedPlanId + '_' + new Date().getTime() + Math.random().toString(16).substring(
						2) + '.jpg' //设置压缩后图片的路径  
					self.compressImage(localurl, dstname)
				})
			})
		},
		// 从相册中选择图片  
		galleryImgs() {
			var self = this
			window.plus.gallery.pick(function(e) {
				console.log("选择了" + e.files.length + "个图片");
				for (var i = 0; i < e.files.length; i++) {
					if (i < 9) {
						self.imageList.push(e.files[i])
						var dstname = self.breedPlan.breedPlanId + '_' + new Date().getTime() + Math.random().toString(16).substring(
							2) + '.jpg' //设置压缩后图片的路径  
						self.compressImage(e.files[i], dstname)
					}
				}
			}, function(e) {
				console.log("取消选择图片");
			}, {
				filter: "image",
				multiple: true
			});
		},

		//压缩图片，这个比较变态的方法，无法return  
		compressImage(src, dstname) {
			var self = this
			//var dstname="_downloads/"+getUid()+".jpg";  
			window.plus.zip.compressImage({
					src: src,
					dst: dstname,
					overwrite: true,
					quality: 20,
					rotate: 0
				},
				function(e) {
					var reader = new plus.io.FileReader(); // 构建文件对象  
					reader.readAsDataURL(e.target) // 添加文件（此处安卓可以直接添加文件路径，而IOS则需要文件对象）  
					reader.onloadend = function(e) { // 文件加载 完成后的事件回调  
						var file = (function(path, name) {
							var arr = path.split(','),
								mime = arr[0].match(/:(.*?);/)[1],
								bstr = atob(arr[1]),
								n = bstr.length,
								u8arr = new Uint8Array(n);
							while (n--) {
								u8arr[n] = bstr.charCodeAt(n);
							}
							return new File([u8arr], name, {
								type: mime
							});
						})(e.target.result, dstname);
						self.uploadImage(file)
					}
				},
				function(error) {
					console.log(error)
				});
		},
		// 保存图片
		uploadImage(file) {
			var formData = new FormData()
			formData.append('file', file)
			window.model.upload('hzapp/breed/save_my_field_image.do', formData, function(data) {
				console.log(data)
			})
		}
	}
})
// 获取计划
window.addEventListener('getPlan', function(event) {
	vm.breedPlan = event.detail.breedPlan
})
