(function(mui, w, document, $) {
	mui.ready(function() {
		mui.init({});
		//点击查看更多
		const onMoreBtn = function() {
			mui('.mui-content').on('tap', '.mui-card', function() {
				mui.openWindow({
					url: 'progress-report-detail.html',
					id: 'progress-report-detail.html',
					extras: {
						test_id: $(this).data('testid')
					}
				})
			});
		};

		/*获取试验测试点状态报告*/
		var getTestReport = function() {
			plus.nativeUI.showWaiting();
			w.model.post('hzapp/fieldtest/load_test_report.do', {}, function(data) {
				let html = '';
				let res = data.data.tests;
				// 品种测试-进度报告数据预处理
				testProgressData = data.data.tests.map(item => {
					const date =  moment(item.createDate).format('YYYY-MM-DD')
					return {
						test_id: item.test_id,
						test_name: item.test_name,
						testType: item.testType,
						createUser: item.createUser,
						createDate: date,
						status: item.status,
						pointRefSize: item.pointRefSize,
						groupsize: item.groupsize,
						varietyRefSize: item.varietyRefSize
					}
				})
				for (let htmlKey in testProgressData) {
					html +=
						`<div class="mui-card" data-testid=\"${testProgressData[htmlKey].test_id}\">
								<div class="mui-card-header">
									<img src="../../images/icon/test.png" />
									<p>${testProgressData[htmlKey].test_name}</p>
								</div>
								<div class="mui-card-content">
									<div class="mui-card-content-inner card-cell-half clearfix">
										<p>试验类型：${testProgressData[htmlKey].testType}</p>
										<p>负 责 人：${testProgressData[htmlKey].createUser}</p>
										<p>创建日期：${testProgressData[htmlKey].createDate}</p>
										<p>试验状态：${testProgressData[htmlKey].status}</p>
										<p>测试点数：${testProgressData[htmlKey].pointRefSize}</p>
										<p>实验组数：${testProgressData[htmlKey].groupsize}</p>
										<p>品种个数：${testProgressData[htmlKey].varietyRefSize}</p>
									</div>
								</div>
								<div class="mui-card-footer" ><img src="../../images/icon/more.png" />查看详情</div>
							</div>`;
				}
				$('.mui-content').html(html);
				onMoreBtn(); //点击更多按钮
				plus.nativeUI.closeWaiting();
			}, function(error) {
				mui.toast(error.message, {
					type: 'div',
					duration: 'long'
				});
				plus.nativeUI.closeWaiting();
			})
		};

		mui.plusReady(function() {
			getTestReport(); //获取试验测试点状态报告	
		});
	})
})(mui, window, document, $)
