// 获取实验相关特性和性状分组
var testPoint = {}
var offlineOpen = localStorage.getItem('offline')
var vm = new Vue({
	el: '#topContainer',
	data: function() {
		return {
			progress: {}
		}
	}
})

function drawMain(drawing_elem, percent, forecolor, bgcolor, myText) {
	/*
		@drawing_elem: 绘制对象
		@percent：绘制圆环百分比, 范围[0, 100]
		@forecolor: 绘制圆环的前景色，颜色代码
		@bgcolor: 绘制圆环的背景色，颜色代码
	*/
	var context = drawing_elem.getContext("2d");
	var center_x = drawing_elem.width / 2;
	var center_y = drawing_elem.height / 2;
	var rad = Math.PI * 2 / 100;
	var speed = 0;

	// 绘制背景圆圈
	function backgroundCircle() {
		context.save();
		context.beginPath();
		context.lineWidth = 4; //设置线宽
		var radius = center_x - context.lineWidth;
		context.lineCap = "round";
		context.strokeStyle = bgcolor;
		context.arc(center_x, center_y, radius, 0, Math.PI * 2, false);
		context.stroke();
		context.closePath();
		context.restore();
	}

	//绘制运动圆环
	function foregroundCircle(n) {
		context.save();
		context.strokeStyle = forecolor;
		context.lineWidth = 4;
		context.lineCap = "round";
		var radius = center_x - context.lineWidth;
		context.beginPath();
		context.arc(center_x, center_y, radius, -Math.PI / 2, -Math.PI / 2 + n * rad, false); //用于绘制圆弧context.arc(x坐标，y坐标，半径，起始角度，终止角度，顺时针/逆时针)
		context.stroke();
		context.closePath();
		context.restore();
	}

	// 绘制固定文字
	function drawText(myText) {
		context.fillStyle = '#ffffff';
		var font_size = 10;
		context.font = font_size + "px Helvetica";
		var text_width = context.measureText(myText).width;
		context.fillText(myText, center_x - text_width / 2, 40);
	}

	//绘制文字
	function text(n) {
		context.save(); //save和restore可以保证样式属性只运用于该段canvas元素
		context.fillStyle = '#ffffff';
		var font_size = 30;
		context.font = font_size + "px Helvetica";
		var text_width = context.measureText(n.toFixed(0) + "%").width;
		// context.fillText(n.toFixed(0)+"%", center_x-text_width/2, center_y + font_size/2);
		context.fillText(n.toFixed(0) + "%", center_x - text_width / 2, 90);
		context.restore();
	}

	//执行动画
	(function drawFrame() {
		window.requestAnimationFrame(drawFrame);
		context.clearRect(0, 0, drawing_elem.width, drawing_elem.height);
		backgroundCircle();
		if (myText) {
			drawText(myText);
		}
		text(speed);
		foregroundCircle(speed);
		if (speed >= percent) return;
		speed += 1;
	}());
};

var time_canvas = document.getElementById("time-graph-canvas");

mui.plusReady(function() {
	plus.sqlite.openDatabase({
		name: 'hz',
		path: '_doc/huazhi.db',
		success: function(e) {},
		fail: function(e) {}
	})
	testPoint = JSON.parse(localStorage.getItem('testPoint'))
	getTestFeature()
})
// 左滑事件
window.addEventListener('swipeleft', function() {
	plus.webview.currentWebview().hide()
	var dt = plus.webview.getWebviewById('double-trait.html')
	dt.show('flip-ry', 300)
	mui.fire(plus.webview.getWebviewById('../variety/main.html'), 'pane', {
		from: 'taskSingle'
	})
})
// 父组件刷新
window.addEventListener('getFeature', function(event) {
	offlineOpen = localStorage.getItem('offline')
	testPoint = JSON.parse(localStorage.getItem('testPoint'))
	getTestFeature()
})
window.addEventListener('planErr', function(event) {
	window.model.planErr('没有进行中的试验');
})

// 事件监听
mui('#traitCat')[0].addEventListener('tap', function(e) {
	let tapEleClass = e.target.getAttribute('class');
	if (tapEleClass === 'li-wrap') {
		let display = e.target.nextElementSibling.style.display;
		display === 'flex' ? e.target.nextElementSibling.style.display = 'none' : e.target.nextElementSibling.style.display =
			'flex'
	}
	if (tapEleClass === 'bot-icon') {
		let display = e.target.parentNode.nextElementSibling.style.display;
		display === 'flex' ? e.target.parentNode.nextElementSibling.style.display = 'none' : e.target.parentNode.nextElementSibling
			.style.display = 'flex'
	}
})

// 测试项事件
var isAddItemTap = false

// 跳转详情
function traitItemTap() {
	mui('.collapse-content').on('tap', '.collapse-item', function() {
		mui.openWindow({
			url: 'trait-collect.html',
			id: 'trait-collect',
			extras: {
				testPoint: testPoint,
				traitId: this.dataset.id,
				traitName: this.dataset.name
			}
		})
	})
	isAddItemTap = true
}

// 获取单性状采集数据 
function getTestFeature() {
	if (!testPoint) {
		return
	}
	plus.nativeUI.showWaiting()
	if (offlineOpen === 'off') {
		plus.sqlite.selectSql({
			name: 'hz',
			sql: `select * from test_traits where test_id = ${testPoint.test_id} and test_point_id = ${testPoint.test_point_id}`,
			success: function(e) {
				let ret = {}
				e.forEach(item => {
					if (ret[item.trait_group]) {
						ret[item.trait_group].push(item)
					} else {
						ret[item.trait_group] = [item]
					}
				});
				setTestFeature({
					data: {
						progress: {
							trait_complete: 0,
							trait_sum: 100,
							trait_nostart: 0,
							trait_going: 0
						},
						traits: ret
					}
				})
				traitItemTap()
			}
		})
		plus.nativeUI.closeWaiting()
	} else {
		window.model.post('hzapp/fieldtest/load_test_traits.do', {
			test_id: testPoint.test_id,
			test_point_id: testPoint.test_point_id
		}, function(data) {
			setTestFeature(data)
			traitItemTap()
			plus.nativeUI.closeWaiting()
		}, function() {
			plus.nativeUI.closeWaiting()
		})
	}
}
// 渲染单性状采集数据 
function setTestFeature(data) {
	let traitStr = ''
	if (data.data) {
		vm.progress = data.data.progress
		drawMain(time_canvas, data.data.progress.trait_complete / data.data.progress.trait_sum * 100, "#ff5311", "#fff",
			"性状进度");
		for (let traitKey in data.data.traits) {
			traitStr += '<li class="collapse-li">'
			traitStr += '<div class="li-wrap">'
			traitStr += '<div class="li-title">' + traitKey + '</div>'
			traitStr += '<img class="bot-icon" src="../../images/bot.png">'
			traitStr += '</div>'
			traitStr += '<div class="collapse-content" style="display: flex;">'
			for (var i = 0; i < data.data.traits[traitKey].length; i++) {
				var traitItem = data.data.traits[traitKey][i]
				traitStr += '<span class="collapse-item'
				if (traitItem.trait_status === 'Active') {
					traitStr += ' c-red'
				} else if (traitItem.trait_status === 'Complete') {
					traitStr += ' c-green'
				} else if (traitItem.trait_status === 'Progress') {
					traitStr += ' c-orange'
				}
				traitStr += '" data-id="' + traitItem.trait_id + '" data-name="' + traitItem.trait_name + '">' + traitItem.trait_name +
					'</span>'
			}
			traitStr += '</div>'
			traitStr += '</li>'
		}
		document.getElementById('traitCat').innerHTML = traitStr
	}
}
